/**********************************************************************
*h*   
*
*   Name:               oim.h
* 
*   Description:        
*               OIM (OS Independent Module) related data structures. 
*  
*   Author:  
*  
*   History:  
*  
*h*   
**********************************************************************/
#pragma ident   "@(#)$RCSfile: oim.h,v $ $Revision: 1.6 $ $Date: 2001/02/23 11:15:13 $ NSC"

#ifndef _OIM_H
#define _OIM_H

#include "hsm.h"
#define	MAX_PORTS	256
extern	AdapterContext	*AdapterArray[MAX_PORTS];
#define bool_t  char
//jaggu, 19 Oct 6:09 PM
#define DEFER_CONFIG    1


/* Commonly used MACROS */
#define GET_LACPPORTP(Port,portp)               portp=LACPPortp[Port]
#define GET_LACPAGGRP(Port,aggrp)               aggrp=LACPAggrp[Port]  //revisit - need to removed -bjaggu
#define BIT_SET(arg, posn)              (arg |= posn)
#define BIT_CLEAR(arg, posn)    (arg &= ~(posn))
#define BIT_TEST(arg, posn)             (arg & posn)

#define MAX_LACPDUS_PER_SEC     3
#define MAX_PORTS                       256                             
#define LACP_MAX_PER_GROUP      8
#define ZERO_MEMORY                     0x001           
#define WAIT_WHILE_TIMER        0x001                   
#define AGGR_RESHUFFLE_TIMER 0x002                      

/* Slow Protocol type value */
#define SLOW_PROTOCOL_TYPE      0x8809
#define LACP_PACKET_SIZE        128

/* Subtype values of LACPDUs */
#define LACP_PDU_TYPE   0x1     /* Protocol Sub-type value in the LACPDU */
#define MARKER_PDU_TYPE 0x2     /* Protocol Sub-type value in the Marker PDU */

#define SUCCESS 0
#define FAILURE 1
/*  Definitions to be changed: REVISIT */
#define FREE    0       /* dont know what should be?? RCB->Status = FREE */
#define FALSE   0
#define TRUE    1
#define SHORT_TIMEOUT   0
#define DETACH  0
#define ATTACH  1
#define aggr_wait_ticks 1
#define fast_ticks      1
#define MAX_LACPDUS_SENT        3
#define PERIODIC_TX             1
#define COLLECTOR_MAX_DELAY 1

/*************************/

#define MAC_ADDR_LEN    6
#define MAC_HDR_LEN     14
#define MAX_PRIORITIES  04
#define NUM_OF_MAC_ADDRESS_CLASSES    256

/* The state variable for each port are encoded as individual bits
   within a single octet as follows */
#define LACP_ACTIVITY           0x01
#define LACP_TIMEOUT            0x02
#define AGGREGATION             0x04
#define SYNCHRONIZATION         0x08
#define COLLECTING              0x10
#define DISTRIBUTING            0x20
#define DEFAULTED               0x40
#define EXPIRED                 0x80

/* Timer Constants */
#define FAST_PERIODIC_TIME      1000000         /* in Microseconds */
#define SLOW_PERIODIC_TIME      30000000        /* in Microseconds */
#define SHORT_TIMEOUT_TIME      3000000         /* in Microseconds */
#define LONG_TIMEOUT_TIME       90000000        /* in Microseconds */
#define CHURN_DETECTION_TIME    60000000        /* in Microseconds */
#define AGGR_WAIT_TIME          2000000         /* in Microseconds */
#define ACTOR_CHURN_DETECTION_TIME              CHURN_DETECTION_TIME
#define PARTNER_CHURN_DETECTION_TIME    CHURN_DETECTION_TIME
#define PROPAGATION_DELAY                               50                       /* Revisit */
#define WAIT_WHILE_TIME                                 60000000        /* in Microseconds */
#define PORT_DETACH_WAIT_TIME                   60000000        /* in Microseconds */
#define COLLECTOR_MAX_DELAY_TIME                50                      /* in ms. */
#define RESHUFFLE_TIMEOUT 1500  // In ticks.. 100 Ticks = 1 second.

#define SHIFT_PORT      0xffff

/* States of Receive State Machine */
#define RECV_INITIALIZED                        0
#define RECV_PORT_DISABLED              1
#define RECV_EXPIRED                    2
#define RECV_LACP_DISABLED              3
#define RECV_DEFAULTED                  4
#define RECV_CURRENT                            5
#define NUM_RECV_STATE_MC_STATES        6

/* Mux machine state  constants  */
#define MUX_DETACHED            0
#define MUX_WAITING                     1
#define MUX_ATTACHED            2
#define MUX_COLLECTING          3       
#define MUX_DISTRIBUTING        4


/* Synchronization States of Actor/Partner in the Mux State Machine  */
#define         IN_SYNC                 1 
#define         OUT_OF_SYNC     0 

/* Periodic State Machine States */
#define NO_PERIODIC             0
#define FAST_PERIODIC           1
#define SLOW_PERIODIC           2


/* Churn Machine States  Changed By */   
#define NO_ACTOR_CHURN                  0
#define ACTOR_CHURN_MONITOR             1
#define ACTOR_CHURN                     2
#define NO_PARTNER_CHURN                3
#define PARTNER_CHURN_MONITOR           4
#define PARTNER_CHURN                   5

/* Port Selection States */
#define PORT_DETACH     0
#define PORT_ATTACH     1

/* LACPDU related constants. */
#define LACP_VERSION                                                    0x01
#define LACPDU_ACTOR_TLV_TYPE                   0x01
#define LACPDU_ACTOR_INFORMATION_LENGTH                 0x14    
#define LACPDU_PARTNER_TLV_TYPE                 0x02
#define LACPDU_PARTNER_INFORMATION_LENGTH       0x14
#define LACPDU_COLLECTOR_TLV_TYPE               0x03
#define LACPDU_COLLECTOR_INFORMATION_LENGTH             0x10
#define LACPDU_TERMINATOR_TLV_TYPE              0x00
#define LACPDU_TERMINATOR_LENGTH                0x00

/* Marker Related Constants */
#define MARKER_VERSION                                  0x01
#define MARKER_INFORMATION                              0x01
#define MARKER_RESPONSE_INFORMATION                     0x02
#define MARKER_INFORMATION_LENGTH                       0x10
#define MARKER_RESPONSE_INFORMATION_LENGTH              0x10
#define MARKER_PADDING                                  0x00
#define MARKER_TERMINATOR                               0x00
#define MARKER_TERMINATOR_LENGTH                        0x00

/* Revisit */
#define LACP_AVG_LOAD_THRESHOLD         10000           
#define LACPDU_QLENGTH                          (ushort)256
#define LACPDU_QLENGTH_MINUS1           (LACPDU_QLENGTH - 1)
#define MAX_LACP_EVENT_LIST_LEN         64
#define MAX_LACP_EVENT_LIST_LEN_MINUS1  (MAX_LACP_EVENT_LIST_LEN - 1)


/* Events for Receive State Machine */
#define         EV_REINITIALIZE_IS_TRUE                 0
#define         EV_PORT_ENABLED                         1
#define         EV_PORT_DISABLED                        2
#define         EV_LACP_ENABLED                         3
#define         EV_LACP_DISABLED                        4       
#define         EV_PORT_MOVED                           5
#define         EV_RECV_PDU                             6
#define         EV_CURRENT_WHILE_TIMER_EXPIRED          7
#define         NUM_RECV_STATE_MC_EVENTS                        8

/* Selection state machine events */                                            /* Revisit */
#define         EV_WAITWHILETIMER_EXPIRED               8
#define         EV_SELECTED_FALSE                       9
#define         NUM_SEL_STATE_MC_EVENTS                 10

#define         MAX_LACP_STATE_MC_EVENTS        11
#define         NUM_MUX_STATE_MC_EVENTS         11 /* Revisit */

/* REVISIT :
The signals below are mapped into the events(EV*) above and then indexed 
 into the state machine function table depending on the bit position.
#define         SIG_REINITIALIZE        1
#define         SIG_PORT_ENABLED        0x2
#define         SIG_PORT_DISABLED       0x4
#define         SIG_LACP_ENABLED        0x08
#define         SIG_LACP_DISABLED       0x10
#define         SIG_PORT_MOVED          0x20
#define         SIG_RECV_PDU                    0x40
#define         SIG_CURRENT_WHILE_TIMER_EXPIRED    0x80 */

/*  Constants required to check the Adapter status.  */
#define ADAPTER_INITIALIZED                     0x01
#define ADAPTER_OPEN                            0x02
#define ADAPTER_RESETTING                       0x04
#define ADAPTER_OPEN_WAITFOR_RESET      0x08
#define LINK_UP                                         0x10

// Added by Ravi
#define LACP_FLAG 0x02
#define GEC_FLAG  0x01

#define LOAD_PER_PORT(pPort, Load)      {  \
Load = ODMGetLoadPerPort(AdapterArray[pPort->ActorPortNumber]); \
		if(Load >= pPort->LoadPerPort) \
			Load -= pPort->LoadPerPort; \
		}

#define LOAD_PER_MAC(pAggr, i, Load) { \
		Load = pAggr->LoadPerMAC[i]; \
		if(Load >= pAggr->PrevLoadPerMAC[i]) \
			Load -= pAggr->PrevLoadPerMAC[i]; \
		}

/* Macros Used by Process Packets */
#define MAX_BUF 10
#define Q_EMPTY(q)      ((q->Write == q->Read) ? 1 : 0 )
#define Q_FULL(q)       (((q->Write + 1) % MAX_BUF == q->Read) ? 1 : 0) 


//typedef UCHAR   MacAddr[6];
//typedef       int             time_t;

/* Structures used for Marker Protocol */
typedef struct _markerId {
    USHORT    Port;
    USHORT    TransactionId;
}markerId_t;



typedef struct LacpRCB{
	USHORT  Read;
	USHORT  Write;
	HsmRCB  *pHsmRCB[MAX_BUF];
} LacpRCB_t;

typedef struct _PktStructNew {  
	USHORT  PktCount;
	PktInfo *pPktInfo;
} PktStructNew;

	
/* Different values for the Selected variable of the Port. */           
typedef enum selected {
    UNSELECTED = 0,
    SELECTED   = 1,
    STANDBY    = 2,
} selected_t;

/* Structure used by LACPCONFIG ioctl */
typedef struct _PortInfo {
    bool_t      LACP;
	bool_t  GEC;
	bool_t  LACPActivity;
	bool_t  AggregatorPort;
	USHORT  Port;
    USHORT  Key;
	USHORT  AggregatorIdentifier;
	USHORT  ActorOperKey;
    INT     Selected;
	bool_t  LACPTimeout;
    bool_t  CollectorState;
    bool_t  DistributorState;
    bool_t  Synchronization;
	// Added by Ravi
	MacAddr SystemId;
	USHORT  SystemPriority;
} PortInfo_t;

/* Variables associated with each Aggregator */
typedef struct lacpAggr {
	MacAddr         AggregatorMACAddress;
	USHORT      AggregatorIdentifier;
	bool_t      IndividualPort;                     
	MacAddr         ActorSystem;
	USHORT      ActorSystemPriority;
	USHORT      ActorAggregatorAdminKey;
	USHORT      ActorAggregatorOperKey;
	MacAddr         PartnerSystem;
	USHORT      PartnerSystemPriority;
	USHORT      PartnerAggregatorKey;
	bool_t      CollectorState;
	bool_t      DistributorState;
	USHORT      LAGPorts[LACP_MAX_PER_GROUP];
	USHORT      NumPorts;

    /* Variables needed for load balancing */
    USHORT      PortForMAC[NUM_OF_MAC_ADDRESS_CLASSES];
	ULONG       LoadPerMAC[NUM_OF_MAC_ADDRESS_CLASSES];
	ULONG       PrevLoadPerMAC[NUM_OF_MAC_ADDRESS_CLASSES];
	time_t      ReshuffleTimerID;  

	/* This Array holds the ports for which LAGId is same */
	struct lacpPort *AggregatablePorts[LACP_MAX_PER_GROUP]; 
	UINT            NumberOfAggregatablePorts;

	USHORT          MediaSpeed;
	/* Lock related variable */
	PVOID           AggrLock;
	/* For Aggregator Reshuffle */
	USHORT          TimerType;
} lacpAggr_t;


/* Variables used for managing the operation of the state machines */
typedef struct lacpControlVariables{
	bool_t      BEGIN;  
	bool_t      LACPEnabled;
	bool_t      ActorChurn;         
	bool_t      PartnerChurn;       
	bool_t      MuxState;
	bool_t      PortSelState;
	bool_t      Ready;
	bool_t      ReadyN;
	bool_t      Matched;
	selected_t  Selected;
	bool_t      PortMoved;
	bool_t      PrevMatched;
	selected_t  PrevSelected;
} lacpControlVariables_t;

	
/* Variables associated with each port */
typedef struct lacpPort{
	USHORT      ActorPortNumber;
	USHORT      ActorPortPriority;
	MacAddr         ActorPortSystem;
	USHORT      ActorPortSystemPriority;
	bool_t      AggregatorPort;
	bool_t      NTT;
	USHORT      ActorAdminPortKey;
	USHORT      ActorOperPortKey;
	UCHAR       ActorAdminPortState;
	UCHAR       ActorOperPortState;
	MacAddr         PartnerAdminSystem;
	MacAddr         PartnerOperSystem;
	USHORT      PartnerAdminSystemPriority;
	USHORT      PartnerOperSystemPriority;
	USHORT      PartnerAdminKey;
	USHORT      PartnerOperKey;
	USHORT      PartnerAdminPortNumber;
	USHORT      PartnerOperPortNumber;
	USHORT      PartnerAdminPortPriority;
	USHORT      PartnerOperPortPriority;
	UCHAR       PartnerAdminPortState;
	UCHAR       PartnerOperPortState;
    USHORT      PartnerCollectorMaxDelay;    /* in milliseconds */
	bool_t          PortEnabled;
	lacpControlVariables_t  ControlVars;

	time_t          PeriodicTimerID;
	time_t          CurrentWhileTimerID;
	time_t          WaitWhileTimerID;
	time_t          CollectorMaxDelayTimerID;
	time_t          ReadyNTID;
	time_t          ActorChurnTimerID; 
	time_t          PartnerChurnTimerID; 
	time_t          LacpDetachWaitTimerID;
	time_t          TransmitTimerID;                
		
	UCHAR       MuxMachineState;    
	UCHAR       PrevMuxMachState;
	UCHAR       ReceiveMachineState; 
	UCHAR       PeriodicTxMachState;
	UCHAR       ActorChurnState;
	UCHAR       PartnerChurnState;

	/* Variables used for load balancing */
	ULONG       LoadPerPort;

	struct lacpAggr *LACPAggrp;

	USHORT          LACPStateMachineEvents[MAX_LACP_EVENT_LIST_LEN];
    USHORT      LACPEventListHead;
    USHORT      LACPEventListTail;
    USHORT      PrevMacState;   /* mac_state field stored here. Used in 
				     * checkPortStatusTimer. */
	
    USHORT      CallCount;
	bool_t          PortMoved;
		
	/* Variables used by TX machine */
    ULONG       TicksWhenLastLACPDUSent;
    USHORT      PDUsAlreadySent;        /* Count of LACPDUs sent in                                 FAST_PERIODIC_TIME */
	
	/*  Lock related data */        
	PVOID           PortLock;
	
	USHORT          TimerType;
} lacpPort_t;


typedef struct TimerContext{
	USHORT  TimerType;
	PVOID   pContext;
}TimerContext_t;

/* LACPDU structure */
typedef struct {
	MacAddr         DestinationAddress;
	MacAddr         SourceAddress;
	USHORT          LengthType;
	UCHAR           SubType;
	UCHAR           VersionNumber;

	/* Actor information */
	UCHAR           ActorTLVType;
	UCHAR           ActorInformationLength;
	USHORT          ActorSystemPriority;
	MacAddr         ActorSystem;
	USHORT          ActorKey;
	UCHAR           ActorState;
	USHORT          ActorPortPriority;
	USHORT          ActorPort;

	/* Partner information */
	UCHAR           PartnerTLVType;
	UCHAR           PartnerInformationLength;
	USHORT          PartnerSystemPriority;
	MacAddr         PartnerSystem;
	USHORT          PartnerKey;
	UCHAR           PartnerState;
	USHORT          PartnerPortPriority;
	USHORT          PartnerPort;

	/* Collector Information */
	UCHAR           CollectorTLVType;
	UCHAR           CollectorInformationLength;
	USHORT          CollectorMaxDelay;
	UCHAR           Reserved1[12];

	/* Terminator information */
	UCHAR           TerminatorTLVType;
	UCHAR           TerminatorLength;
	UCHAR           Reserved2[58];
	INT                     FCS;
} lacpdu_t;


/* Marker PDU Structure */
typedef struct marker {
    MacAddr     DestinationAddress;
	MacAddr         SourceAddress;
    USHORT      LenType;
    UCHAR               Subtype;
    UCHAR               Version;
    UCHAR               TLVType;
    UCHAR               Length;
    USHORT      RequestorPort;
    MacAddr     RequestorSystem;
    UINT        RequestorTransactionId;
    USHORT      Pad;
    UCHAR       Terminator;
    UCHAR       TerminatorLength;
    CHAR        Reserved[90];
	INT                     FCS;
} marker_t;




#endif
