/******************************************************************************
*h*
*   Name:       oim.c
*
*   Description:
*			This file is the Operating system Independent Module.
*           Includes Initialization , Send and Receive routines,
*           Link Aggregation Control module (State machines),
*			Marker Protocol.
*   Author:
*
*   History:
*
*h*
******************************************************************************/
#pragma ident   "@(#)$RCSfile: oim.c,v $ $Revision: 1.21 $ $Date: 2001/10/29 13:16:56 $ NSC"

/* Include files */
#include "odm.h"
#include "oim.h"

#define	BASE_INDEX	0

/* function declarations to be removed */
#ifndef ODMhtons
extern USHORT ODMhtons(USHORT);
#endif
extern void *ODMMalloc(int, int);
extern UCHAR ODMGetIOBus(AdapterContext *);
extern UCHAR ODMGetSlot(AdapterContext *);
extern void ODMWakeup(void *);
extern void ODMMemSet(void *, int, int);
extern int	 ODMMemCmp(void *, void *, int);
extern void ODMFree(void *, unsigned int,unsigned int);
extern void ODMCopy(void *, void *, int);
extern void ODMInitializeLock(void **,int);
extern PRIV_LEVEL ODMAcquireLock(void *,UINT,PRIV_LEVEL);
extern void ODMReleaseLock(void *,UINT,PRIV_LEVEL);
#ifndef ODMError
extern void ODMError(char *cString,...);
#endif
extern void ODMPostEvent(lacpPort_t *pPort,USHORT Event,HsmRCB *Rcb);
extern ULONG ODMGetPresentTimeInTicks();
#ifndef ODMDelay
extern void ODMDelay(ULONG);
#endif

#ifndef ODMGetLoadPerPort
extern ULONG ODMGetLoadPerPort(AdapterContext *);
#endif
extern UINT  ODMProcessPacketsRunning();
extern void  ODMSignalProcessPackets();
//extern UCHAR ODMGetIndex();
extern void ODMUntimeout(time_t,void *);
extern void ODMMallocContiguous(AddressStruct *,USHORT);
extern void *ODMTimeout(void (*pFunc)(),void *ptr,ULONG nTicks,int nFlags);
extern void ODMAdapterOpen(void);
// Added by Gopi 15Oct 2000 12:05pm
extern void ODMLacpStart(USHORT nPort);
// End of changes.
extern void ODMUnInitializeLock(void *, int);
void LacpAdapterStatusCheck(AdapterContext *);
void AddPortToDeferList(lacpPort_t *,int); 


int  LacpInit(UINT);
void StopLACPTimers(lacpPort_t *);
void LacpPeriodicTransmissionMachine(lacpPort_t *pPort);
void SelectionLogic(lacpPort_t *pPort);
void LacpMuxMachineState(lacpPort_t *pPort);
void LacpActorChurnMonitor(lacpPort_t *pPort);
void LacpPartnerChurnMonitor(lacpPort_t *pPort);
void LacpTransmitMachine(lacpPort_t *pPort);
void LacpRecordDefault(lacpPort_t *pPort);   
void LacpActorChurnDetectionMachine(lacpPort_t *pPort);
void LacpPartnerChurnDetectionMachine(lacpPort_t *pPort);

void CurrentWhileTimer(lacpPort_t *pPort);
void LacpUpdateSelected(lacpPort_t *pPort,HsmRCB *Rcb);
void LacpUpdateNTT(lacpPort_t *pPort,HsmRCB *Rcb);
void LacpRecordPDU(lacpPort_t *pPort,HsmRCB *Rcb);
void LacpUpdateDefaultSelected(lacpPort_t *pPort,HsmRCB *Rcb);

void MuxDetached(lacpPort_t  *pPort);
void MuxWaiting(lacpPort_t *pPort);
void MuxAttached(lacpPort_t *pPort);
void MuxCollecting(lacpPort_t *pPort);
void MuxDistributing(lacpPort_t *pPort);

void RcvStateMachineInit(lacpPort_t *pPort,HsmRCB *Rcb);
void RcvStateMachineCurrent(lacpPort_t *pPort,HsmRCB *Rcb);
void RcvStateMachineExpired(lacpPort_t *pPort,HsmRCB *Rcb);
void RcvStateMachineLacpDisabled(lacpPort_t *pPort,HsmRCB *Rcb);
void RcvStateMachinePortDisabled(lacpPort_t *pPort,HsmRCB *Rcb);
void RcvStateMachineDefaulted(lacpPort_t *pPort,HsmRCB *Rcb);
void InvalidEvent(lacpPort_t *pPort,HsmRCB *Rcb);

void LacpWaitWhileTimer(void *arg);
void LacpSortPorts(USHORT *Ports, USHORT NumPorts);
void TransmitTimer(void *arg);
void LacpPeriodicTimer(lacpPort_t *pPort);
void LacpStateMachine(lacpPort_t *pPort, char event, HsmRCB *Rcb);
void ActorChurnMonitorState(lacpPort_t *pPort);
void PartnerChurnMonitorState(lacpPort_t *pPort);
void NoActorChurnState(lacpPort_t *pPort);
void NoPartnerChurnState(lacpPort_t *pPort);
void ActorChurnTimer(void *arg);
void PartnerChurnTimer(void *arg);

void AggrReshuffle(lacpAggr_t *pAggr);
INT AggrSendPacket(AdapterContext *pAdapter,PktInfo *Pkt,UCHAR Prio, INT *CableStatus);
int AggrSendPackets(AdapterContext *pAdapter, PktStruct *pkts, UCHAR Prio, INT *CableStatus);
int GetLeastLoadedPort(lacpAggr_t *pAggr);
void AggrRxPackets(AdapterContext *pAdapter, HsmRCB *Rcb);
void CollectorMaxDelayTimer(VOID *MarkerId);
SHORT GetMACtoShift(lacpAggr_t *pAggr, UINT Port, ULONG Load);
void LacpProcessPackets(VOID);
void MarkerPDUHandler(HsmRCB *Rcb, lacpPort_t *pPort);
void MarkerResponseHandler(HsmRCB *Rcb, lacpPort_t *pPort);
SHORT SendMarker(USHORT Port, SHORT TransactionId);
int SendMarkerResponse(HsmRCB *Rcb, lacpPort_t *pPort);
USHORT GetNumberOfLinks(AdapterContext *pAdapter);
VOID LacpDisablePort(AdapterContext *pAdapter);
ULONG GetAggrSpeed(AdapterContext *pAdapter);

UINT nFlags;
PRIV_LEVEL nPrivLevel;
/** Global variables **/
bool_t	MorePackets;

void (*lacpRcvStaMc[NUM_RECV_STATE_MC_STATES][NUM_RECV_STATE_MC_EVENTS])(lacpPort_t *,HsmRCB *) = { 

{		     /* RECV_UNINITIALIZED */
	RcvStateMachineInit,	/* EV_REINITIALIZE_IS_TRUE */  
	InvalidEvent,			/* EV_PORT_ENABLED */
	InvalidEvent,			/* EV_PORT_DISABLED */
	InvalidEvent,			/* EV_LACP_ENABLED */
	RcvStateMachineInit,	/* EV_LACP_DISABLED */
	InvalidEvent,			/* EV_PORT_MOVED */
	InvalidEvent,			/* EV_RECV_PDU */
	InvalidEvent			/* EV_CURRENT_WHILE_TIMER_EXPIRED */
},
{		     /* RECV_PORT_DISABLED */
	RcvStateMachineInit,			/* EV_REINITIALIZE_IS_TRUE */  
	RcvStateMachinePortDisabled,	/* EV_PORT_ENABLED */
	InvalidEvent,					/* EV_PORT_DISABLED */
	RcvStateMachineExpired,			/* EV_LACP_ENABLED */
	RcvStateMachineLacpDisabled,	/* EV_LACP_DISABLED */
	RcvStateMachineInit,			/* EV_PORT_MOVED */
	RcvStateMachinePortDisabled,	/* EV_RECV_PDU */
	InvalidEvent					/* EV_CURRENT_WHILE_TIMER_EXPIRED */
},	
{		     /* RECV_EXPIRED */
	RcvStateMachineInit,			/* EV_REINITIALIZE_IS_TRUE */  
  	InvalidEvent,					/* EV_PORT_ENABLED */
	RcvStateMachinePortDisabled,	/* EV_PORT_DISABLED */
	InvalidEvent,					/* EV_LACP_ENABLED */
	RcvStateMachineLacpDisabled,	/* EV_LACP_DISABLED */
	InvalidEvent,    				/* EV_PORT_MOVED */
	RcvStateMachineCurrent,			/* EV_RECV_PDU */
	RcvStateMachineDefaulted		/* EV_CURRENT_WHILE_TIMER_EXPIRED */
},	
{		     /* RECV_LACP_DISABLED */
	RcvStateMachineInit,			/* EV_REINITIALIZE_IS_TRUE */  
	InvalidEvent,					/* EV_PORT_ENABLED */
	RcvStateMachinePortDisabled,	/* EV_PORT_DISABLED */
	InvalidEvent,					/* EV_LACP_ENABLED */
	InvalidEvent,					/* EV_LACP_DISABLED */
	InvalidEvent,					/* EV_PORT_MOVED */
	InvalidEvent,					/* EV_RECV_PDU */
	InvalidEvent					/* EV_CURRENT_WHILE_TIMER_EXPIRED */
},	
{		     /* RECV_DEFAULTED */
	RcvStateMachineInit,			/* EV_REINITIALIZE_IS_TRUE */  
	InvalidEvent,					/* EV_PORT_ENABLED */
	RcvStateMachinePortDisabled,	/* EV_PORT_DISABLED */
	InvalidEvent,					/* EV_LACP_ENABLED */
	InvalidEvent,					/* EV_LACP_DISABLED */
	RcvStateMachineInit,			/* EV_PORT_MOVED */
	RcvStateMachineCurrent,			/* EV_RECV_PDU */
	InvalidEvent					/* EV_CURRENT_WHILE_TIMER_EXPIRED */
},	
{		     /* RECV_CURRENT */
	RcvStateMachineInit,			/* EV_REINITIALIZE_IS_TRUE */  
	InvalidEvent,					/* EV_PORT_ENABLED */
	RcvStateMachinePortDisabled,	/* EV_PORT_DISABLED */
	InvalidEvent,					/* EV_LACP_ENABLED */
	InvalidEvent,					/* EV_LACP_DISABLED */
	InvalidEvent,					/* EV_PORT_MOVED */
	RcvStateMachineCurrent,			/* EV_RECV_PDU */
	RcvStateMachineExpired			/* EV_CURRENT_WHILE_TIMER_EXPIRED */
}	
};


AdapterContext	*AdapterArray[MAX_PORTS];
UINT 			AdapterCount;

/* Global Lock structure for Global data */
void	*GlobalLock;


/* Other Global data structures, Variables and constants */
UCHAR		SlowProtocolMulticast[6] = {01,00,01,02,03,04};

/* Variables associated with the system */
MacAddr		ActorSystem;
USHORT      ActorSystemPriority;

lacpAggr_t 	*LACPAggrp[MAX_PORTS];
lacpPort_t 	*LACPPortp[MAX_PORTS];
//jaggu - 19 oct - 6:31 PM
PortInfo_t	*DeferPortInfoList[MAX_PORTS];

/* When DynLoad executes, it sets this variable to 1 */
UCHAR DynLoadRunning = 0;

/* 
 * Initialization Routines 
 */

/********************************************************************
*f*
*
* Name :			LacpRegister
*
* Description :		This function registers an adapter with the 
*					lacp driver.
*
* Parameters :		PAdapter	Pointer to AdapterContext Structure
*
*
* Return Value :	None
*
* Called By :		NIC driver during initialization.
*
* Lock :			Holds Global lock when updating AdapterArray.
*
*f*
*********************************************************************/

void LacpRegister(AdapterContext *pAdapter)
{
	short portnum = 0;
	PRIV_LEVEL CurrLevel;

	//DbgPrint1("Entering LacpRegister for port %x\n", pAdapter->Port);
	pAdapter->pLacpRCB = (LacpRCB_t *)ODMMalloc(sizeof(LacpRCB_t), ZERO_MEMORY); 
	//  Added by Gopi 13Oct 2000 4:40pm
	pAdapter->nFlags = 0;
	pAdapter->pAggregatorContext = pAdapter;
	// End of changes.
	
	// Initialize Global lock - Gopi, 16 Oct 3:15 PM
	if(!GlobalLock)
		ODMInitializeLock(&GlobalLock, 0);

	portnum = ODMGetPortNum(pAdapter);
	
	CurrLevel = ODMAcquireLock(GlobalLock,0, 0);
	AdapterArray[portnum] = pAdapter;
	AdapterArray[portnum]->Port = portnum;
	AdapterCount++;
	ODMReleaseLock(GlobalLock,nFlags,CurrLevel);

	//DbgPrint1("LacpRegister: Before ODMLacpStart for port %x\n", pAdapter->Port);

	// Added by Gopi 15 Oct 2000 12:05pm
    ODMLacpStart(portnum);
	//DbgPrint1("LacpRegister: After ODMLacpStart for port %x\n", pAdapter->Port);

	// end of changes
	/* Check for the case of Dynamic loading of NIC driver */
	/* Check whether DynLoad Daemon has issued BLOCKING IOCTL 
	   if so then ACK the IOCTL. */
	if (DynLoadRunning)
		ODMWakeup(&DynLoadRunning);
}

/********************************************************************
*f*
*
* Name :			LacpShowConfig
*
* Description :		Returns the configuration values of all the ports
*					in the portInfo structure passed as argument. 
*
* Parameters :		PAdapter	Pointer to AdapterContext Structure
*
*
* Return Value :	None
*
* Called By :		IOCTL LACP_SHOW_CONFIG.
*
* Lock :			None
*
*f*
*********************************************************************/

void
LacpShowConfig (PortInfo_t  *pPortsInfo)
{
	lacpPort_t *pPort;
	USHORT i,k=0;

	for (i=0; i<MAX_PORTS; i++ )
	{
		if(AdapterArray[i] != NULL) {
			if(AdapterArray[i]->Port != 0)	// NULL is replaced with 0 as NULL is void *
			{
				//pPortsInfo[k].Port = AdapterArray[i]->Port;
				pPort = LACPPortp[AdapterArray[i]->Port];	
				if (pPort == NULL) {
					/* Assign Default Values to pPortsInfo[k] Structure */
					ODMMemSet(&(pPortsInfo[k]), 0, sizeof(PortInfo_t));
					pPortsInfo[k].Port = AdapterArray[i]->Port;
				}	
				else {
					/* Copy corresponding fields from pPort/AdapterArray
					to pPortsInfo[i] */
					pPortsInfo[k].Port = AdapterArray[i]->Port;
    				pPortsInfo[k].LACP = (AdapterArray[i]->nFlags) & LACP_FLAG;
					pPortsInfo[k].GEC = (AdapterArray[i]->nFlags) & GEC_FLAG;
    				pPortsInfo[k].Key = pPort->ActorOperPortKey;
    				pPortsInfo[k].LACPActivity = (pPort->ActorOperPortState) & LACP_ACTIVITY;
    				pPortsInfo[k].LACPTimeout = (pPort->ActorOperPortState) & LACP_TIMEOUT;
    				pPortsInfo[k].AggregatorPort = pPort->AggregatorPort;
    				pPortsInfo[k].Selected = pPort->ControlVars.Selected;
    				pPortsInfo[k].CollectorState = (pPort->ActorOperPortState) & COLLECTING;
    				pPortsInfo[k].DistributorState = (pPort->ActorOperPortState) & DISTRIBUTING;
    				pPortsInfo[k].Synchronization = (pPort->ActorOperPortState) & SYNCHRONIZATION;
					pPortsInfo[k].AggregatorIdentifier = pPort->LACPAggrp->AggregatorIdentifier;
				}
				k++;
			}
		}
	}
	return;
}

/********************************************************************
*f*
*
* Name :			UpdatePortParams
*
* Description :		Updates fields in Port struct with the user-specified values 
*
* Parameters :		pPort		Pointer to Port structure
*					pPortInfo	Pointer to PortInfo_t structure
*								containing user-specified config values.
*
* Return Value :	None
*
* Called By :		LacpConfig
*
* Lock :			Port lock should be held before calling this routine
*
*f*
*********************************************************************/

void
UpdatePortParams(lacpPort_t *pPort, PortInfo_t *pPortInfo)
{
	pPort->ControlVars.LACPEnabled = pPortInfo->LACP;
	if (pPortInfo->LACPActivity)
		BIT_SET(pPort->ActorOperPortState, LACP_ACTIVITY);
	else
		BIT_CLEAR(pPort->ActorOperPortState, LACP_ACTIVITY);
	pPort->AggregatorPort = pPortInfo->AggregatorPort;
    pPort->ActorOperPortKey = pPortInfo->Key;
	if (pPortInfo->LACPTimeout)
		BIT_SET(pPort->ActorOperPortState, LACP_TIMEOUT);
	else
		BIT_CLEAR(pPort->ActorOperPortState, LACP_TIMEOUT);
	if (pPortInfo->CollectorState)
		BIT_SET(pPort->ActorOperPortState, COLLECTING);
	else
		BIT_CLEAR(pPort->ActorOperPortState, COLLECTING);
	if (pPortInfo->DistributorState)
		BIT_SET(pPort->ActorOperPortState, DISTRIBUTING);
	else
		BIT_CLEAR(pPort->ActorOperPortState, DISTRIBUTING);
	return;
}

/********************************************************************
*f*
*
* Name :			UpdateAggrParams
*
* Description :		Updates fields in Aggr struct with values in Port struct 
*
* Parameters :		pAggr		Pointer to aggregator structure
*					pPort		Pointer to Port structure
*
* Return Value :	None
*
* Called By :		LacpConfig
*
* Lock :			Aggr lock should be held before calling this routine
*
*f*
*********************************************************************/

void
UpdateAggrParams(lacpAggr_t *pAggr, lacpPort_t *pPort)
{
	AdapterContext *pAdapter;
	int i;

	pAdapter = AdapterArray[pPort->ActorPortNumber];
	for (i=0; i < MAC_ADDR_LEN; i++)
		pAggr->AggregatorMACAddress[i] = pAdapter->CurrMacAddr[i];
	pAggr->AggregatorIdentifier = pPort->ActorPortNumber;
	pAggr->ActorAggregatorAdminKey = pPort->ActorAdminPortKey;
	pAggr->ActorAggregatorOperKey = pPort->ActorOperPortKey;
	return;
}

/********************************************************************
*f*
*
* Name :			StopLACPTimers
*
* Description :		Stops all currently running timers for the specified port. 
*
* Parameters :		pPort		Pointer to Port structure
*
* Return Value :	None
*
* Called By :		LacpConfig
*
* Lock :			Locks(Port/Aggr/Global) should not be held when calling this routine
*
*f*
*********************************************************************/

void 
StopLACPTimers(lacpPort_t *pPort)
{
	time_t timerid;
	PRIV_LEVEL CurrLevel;

	if (timerid = pPort->PeriodicTimerID) {
		CurrLevel = ODMAcquireLock(pPort->PortLock, 0, 0);
		pPort->PeriodicTimerID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
		ODMUntimeout(timerid,pPort);
	}
	if (timerid = pPort->CurrentWhileTimerID) {
		CurrLevel = ODMAcquireLock(pPort->PortLock, 0, 0);
		pPort->CurrentWhileTimerID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
		ODMUntimeout(timerid,pPort);
	}
	if (timerid = pPort->WaitWhileTimerID) {
		CurrLevel = ODMAcquireLock(pPort->PortLock, 0, 0);
		pPort->WaitWhileTimerID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
		ODMUntimeout(timerid,pPort);
	}
	if (timerid = pPort->CollectorMaxDelayTimerID) {
		CurrLevel = ODMAcquireLock(pPort->PortLock, 0, 0);
		pPort->CollectorMaxDelayTimerID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
		ODMUntimeout(timerid,pPort);
	}
	if (timerid = pPort->ReadyNTID) {
		CurrLevel = ODMAcquireLock(pPort->PortLock, 0, 0);
		pPort->ReadyNTID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
		ODMUntimeout(timerid,pPort);
	}
	if (timerid = pPort->ActorChurnTimerID) {
		CurrLevel = ODMAcquireLock(pPort->PortLock, 0, 0);
		pPort->ActorChurnTimerID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
		ODMUntimeout(timerid,pPort);
	}
	if (timerid = pPort->PartnerChurnTimerID) {
		CurrLevel = ODMAcquireLock(pPort->PortLock, 0, 0);
		pPort->PartnerChurnTimerID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
		ODMUntimeout(timerid,pPort);
	}
	if (timerid = pPort->LacpDetachWaitTimerID) {
		CurrLevel = ODMAcquireLock(pPort->PortLock, 0, 0);
		pPort->LacpDetachWaitTimerID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
		ODMUntimeout(timerid,pPort);
	}
	if (timerid = pPort->TransmitTimerID) {
		CurrLevel = ODMAcquireLock(pPort->PortLock, 0, 0);
		pPort->TransmitTimerID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
		ODMUntimeout(timerid,pPort);
	}
	return;
}

/********************************************************************
*f*
*
* Name :			LacpConfig
*
* Description :		Performs LACP configuration for the specfied port 
*
* Parameters :		pPortInfo	Pointer to PortInfo_t structure
*								containing user-specified config values.
*
*
* Return Value :	None
*
* Called By :		IOCTL LACP_CONFIG.
*
* Lock :			Acquires Port lock, Aggr lock & Global lock when required.
*
*f*
*********************************************************************/

USHORT
LacpConfig (PortInfo_t *pPortInfo)
{
	USHORT PresentState = 0, Request = 0;
	AdapterContext *pAdapter, *pAggregatorAdapterContext, *pTempAdapterContext;
	int PortSize = sizeof(lacpPort_t);
	int AggrSize = sizeof(lacpAggr_t);
	int i, j;
	lacpPort_t *pPort, *temp, *pTempPort, *pAggrPort;
	lacpAggr_t *pAggr, *pTempAggr;
	MultiList Multi;
	mca_hash_t	*start;
	PRIV_LEVEL CurrLevel2,CurrLevel3,CurrLevel4,CurrLevel5;
	time_t timerid;
	UCHAR curstat;

/* 
LacpConfig changes considering GEC and LACP flags.

LACP    GEC		State/Request Flag
  0	     0			0
  0	     1			1
  1	     0			2
  1	     1			3


Note : pPortInfo is the port structure given by the user/Administrator.
*/

	//DbgPrint1("Entering  LacpConfig: port %x\n", pPortInfo->Port);

	/* Get adapter context structure of pPort */
	pAdapter = AdapterArray[pPortInfo->Port];
	if(pAdapter == NULL)
		return 0;
	PresentState = (pAdapter->nFlags) & (LACP_FLAG | GEC_FLAG);
	Request = ((pPortInfo->LACP) << 1) | (pPortInfo->GEC);

// If System ID/Priority has changed detach all ports in the system

	// ODMAcquireLock(GlobalLock, 0, 0);
	// Added by Gopi 16 Oct 2000 9:35am
	// changed to !ODMMemCmp(...
	// Uncomment later START - Ravi
#if 0
	if (ActorSystemPriority != pPortInfo->SystemPriority ||
			!ODMMemCmp(ActorSystem, pPortInfo->SystemId, MAC_ADDR_LEN)) { 
		ODMCopy(ActorSystem,pPortInfo->SystemId,sizeof(ActorSystem));
		ActorSystemPriority = pPortInfo->SystemPriority;
		for (i=0; i<MAX_PORTS; i++) {
			if (LACPPortp[i] == NULL)
				continue;
			ODMPostEvent(LACPPortp[i], EV_SELECTED_FALSE,0);
		}
		//ODMReleaseLock(GlobalLock,nFlags,0);
		return 0;
	}
	// ODMReleaseLock(GlobalLock,nFlags,0);
#endif
// Uncomment later END - Ravi
	
 
	switch(PresentState){

		case 0 :  // LACP and GEC both disabled.  Individual port.
			switch(Request){

				case 0: // LACP and GEC both disabled.  Individual port.
					break;
				case 1: // LACP Disabled and GEC Enabled.

					// Added by Gopi. 28 oct 2000 12:10pm
					if(pPortInfo->AggregatorPort == FALSE){
						//jaggu, 19 Oct 6:09 PM
						GET_LACPPORTP(pPortInfo->AggregatorIdentifier, temp);
						if (temp == NULL) {
							ODMError("LacpConfig: Aggregator structure not allocated");
							return	DEFER_CONFIG;
						}
						//jaggu, 19 Oct 6:09 PM
					}
					// end. Added by Gopi. 28 oct 2000 12:10pm

					/* Allocate port Structure say pPort */
					pPort = ODMMalloc(PortSize, ZERO_MEMORY);
					if (pPort == NULL) {
						ODMError("LacpConfig: Memory allocation of lacpPort failed\n");
						return 0;
					}
					ODMInitializeLock(&pPort->PortLock, 0);
					pPort->ControlVars.LACPEnabled = FALSE;
					pPort->ActorPortNumber = pPortInfo->Port;
					pPort->ActorPortPriority = pPortInfo->Port;
					BIT_SET(pPort->ActorOperPortState, DISTRIBUTING);
					BIT_SET(pPort->ActorOperPortState, COLLECTING);

					if(pPortInfo->AggregatorPort == TRUE)
					{
						pAggr = ODMMalloc(AggrSize, ZERO_MEMORY);
						if (pAggr == NULL) {
							ODMFree(pPort, PortSize,0);
							ODMError("LacpConfig: Memory allocation of lacpAggr failed\n");
							return 0;
						}
						ODMInitializeLock(&pAggr->AggrLock, 0);
						// Initialize PortForMac - Gopi, 16 Oct 3:35 PM
						for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS;
						pPort->LACPAggrp = pAggr;
						pPort->AggregatorPort = TRUE;
						pAggr->AggregatorIdentifier = pPort->ActorPortNumber;
						// Update AdapterContext Structure.
						pAdapter->pAggregatorContext = pAdapter;
						
						ODMSetdev_aggr(pAdapter,pAdapter);
						
						pAggr->ReshuffleTimerID = ODMTimeout(AggrReshuffle,pAggr,RESHUFFLE_TIMEOUT,AGGR_RESHUFFLE_TIMER);

						if(pAggr->ReshuffleTimerID == 0)
							ODMError("LacpConfig : Not able to start AggrReshuffle");
						
					}
					else // For non aggregator port.
					{
						MultiList Multi;

						pAggregatorAdapterContext = AdapterArray[pPortInfo->AggregatorIdentifier];
						pAdapter->pAggregatorContext = pAggregatorAdapterContext;

						ODMSetdev_aggr(pAdapter, pAdapter->pAggregatorContext);

						GET_LACPPORTP(pPortInfo->AggregatorIdentifier, temp);
						/* Already has max no. of ports in aggregation */
						if (temp->LACPAggrp->NumPorts == LACP_MAX_PER_GROUP) {
							ODMFree(pPort, PortSize,0);
							ODMError("LacpConfig: Already max no. of ports in aggregation");
							return 0;
						}
						pPort->LACPAggrp = temp->LACPAggrp;

						// Set aggregator's physical address to pPort.
						pAdapter->FuncStruct.HsmSetMacAddress(pAdapter, pAggregatorAdapterContext->CurrMacAddr);
						
						//bjaggu December 04 1:38
						pAdapter->FuncStruct.HsmRxFilter(pAdapter, pAdapter->pAggregatorContext->lacprxFilterFlag);

						// Copy the address to CurrMacAddress - Ravi 23 Oct 6:03 PM
						ODMCopy(pAggregatorAdapterContext->CurrMacAddr, pAdapter->CurrMacAddr, MAC_ADDR_LEN);

						//Set MAC Address of dev structure
						ODMSetMacAddr(pAdapter);

						// Add Multicast addresses of Aggregator port to this port
						Multi.Next = NULL;
						for (i=0; i< 128; i++)
							for (j=0; j < 16; j++) {
								start = pAggregatorAdapterContext->mca_tbl[i][j];
								while (start)
								{
									ODMCopy(start->MulticastAddr, Multi.MulticastAddr, MAC_ADDR_LEN);
									pAdapter->FuncStruct.HsmMulticastAdd(pAdapter, &Multi, FALSE);
									start = start->next;
								}
							}
						/* Replicate phy capabilities of aggregator - Ravi 28 Oct 4:56 PM */
						/* Revisit : Set media speed ? */
						pAdapter->FuncStruct.HsmSetPhyCapabilities(pAdapter, pAggregatorAdapterContext->PhysCapabilities, 0); 
						pAdapter->PhysCapabilities = pAggregatorAdapterContext->PhysCapabilities;
					}

					// Update global structs LACPPortp & LACPAggrp
					CurrLevel3 = ODMAcquireLock(GlobalLock, 0, 0);
					LACPPortp[pPortInfo->Port] = pPort;
					if(pPortInfo->AggregatorPort == TRUE)
						for (i=0; i < MAX_PORTS; i++) {
							if (LACPAggrp[i] == 0) {
								LACPAggrp[i] = pAggr;
								break;
							}
						}

					// If this card has the cable connected, tell upper layer about it. Dec 04, 5:08 PM
					if (pPortInfo->AggregatorPort == FALSE)
						if (GetNumberOfLinks(pAdapter->pAggregatorContext) == 1) {
							curstat = pAdapter->pAggregatorContext->AdapterStatus;
							pAdapter->pAggregatorContext->AdapterStatus |= LINK_UP;
							pAdapter->pAggregatorContext->FuncStruct.NsmIndicateLinkStatus((void *)pAdapter->pAggregatorContext);
							pAdapter->pAggregatorContext->AdapterStatus = curstat;
						}

					ODMReleaseLock(GlobalLock,nFlags,CurrLevel3);

					if(pPortInfo->AggregatorPort == TRUE)
					{
						pAggr->LAGPorts[0] = pPortInfo->Port;
						pAggr->NumPorts = 1;
					}
					else {
						//Add pPort entry to LAGPorts and increment nNumPorts
						CurrLevel2 = ODMAcquireLock(pPort->LACPAggrp->AggrLock, 0, 0);
						for (i=0; i < LACP_MAX_PER_GROUP; i++)
							if (pPort->LACPAggrp->LAGPorts[i] == 0) {
								pPort->LACPAggrp->LAGPorts[i] = pPortInfo->Port;
								pPort->LACPAggrp->NumPorts++;
								break;
							}
						ODMReleaseLock(pPort->LACPAggrp->AggrLock,nFlags,CurrLevel2);
					}
					pAdapter->nFlags = GEC_FLAG; // Only GEC is enabled.
					ODMAdapterOpen();  //Revisit: arguments ?
					break;

				case 2: // LACP is Enabled and GEC is disabled.
				// Allocate Aggregator structure and port structure.
				// and make the port as an individual port.
					pPort = ODMMalloc(PortSize, ZERO_MEMORY);
					if (pPort == NULL) {
						ODMError("LacpConfig: Memory allocation of lacpPort failed\n");
						return 0;
					}
					pAggr = ODMMalloc(AggrSize, ZERO_MEMORY);
					if (pAggr == NULL) {
						ODMFree(pPort, PortSize,0);
						ODMError("LacpConfig: Memory allocation of lacpAggr failed\n");
						return 0;
					}
					ODMInitializeLock(&pPort->PortLock, 0);
					ODMInitializeLock(&pAggr->AggrLock, 0);
					// Initialize PortForMac - Gopi, 16 Oct 3:35 PM
					for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
						pAggr->PortForMAC[i] = MAX_PORTS;
					pPort->ActorPortNumber = pPortInfo->Port;
					pPort->ActorPortPriority = pPortInfo->Port;
					pPort->PortEnabled = TRUE;
					pPort->LACPAggrp = pAggr;
					pPort->AggregatorPort = TRUE;
					pPort->ControlVars.LACPEnabled = TRUE;
					pAggr->AggregatorIdentifier = pPort->ActorPortNumber;
					pAggr->LAGPorts[0] = pPortInfo->Port;
					pAggr->NumPorts = 1;
					UpdatePortParams(pPort, pPortInfo);
					UpdateAggrParams(pAggr, pPort);

					// Make it non aggregatable individual port.
					pAggr->IndividualPort = TRUE;

					//Update the pAdapterContext structure.
					pAdapter->pAggregatorContext = pAdapter;
					// Update global structs LACPPortp & LACPAggrp
					ODMAcquireLock(GlobalLock, 0, 0);
					LACPPortp[pPortInfo->Port] = pPort;
					for (i=0; i < MAX_PORTS; i++) {
						if (LACPAggrp[i] == 0) {
							LACPAggrp[i] = pAggr;
							break;
						}
					}
					ODMReleaseLock(GlobalLock,nFlags,0);

					pAdapter->nFlags = LACP_FLAG;  // Enable only LACP.
					// Revisit: args to ODMAdapterOpen
					ODMAdapterOpen();
					LacpInit(pPortInfo->Port);
					break;
				case 3: //LACP Enabled and GEC Enabled.
					// Allocate port Structure
					pPort = ODMMalloc(PortSize, ZERO_MEMORY);
					if (pPort == NULL) {
						ODMError("LacpConfig: Memory allocation of lacpPort failed\n");
						return 0;
					}
					ODMInitializeLock(&pPort->PortLock, 0);
					pPort->ActorPortNumber = pPortInfo->Port;
					pPort->ActorPortPriority = pPortInfo->Port;
					pPort->ControlVars.LACPEnabled = TRUE;
					pPort->PortEnabled = TRUE;
					UpdatePortParams(pPort, pPortInfo);

					if(pPortInfo->AggregatorPort = TRUE)
					{
						//Allocate Aggr Structure 
						pAggr = ODMMalloc(AggrSize, ZERO_MEMORY);
						if (pAggr == NULL) {
							ODMFree(pPort, PortSize,0);
							ODMError("LacpConfig: Memory allocation of lacpAggr failed\n");
							return 0;
						}
						ODMInitializeLock(&pAggr->AggrLock, 0);
						// Initialize PortForMac - Gopi, 16 Oct 3:35 PM
						for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS;
						pPort->LACPAggrp = pAggr;
						pPort->AggregatorPort = TRUE;
						UpdateAggrParams(pAggr, pPort);

						// Update the pAdapter member pointers.
						pAdapter->pAggregatorContext = pAdapter;
					}
					
					// Update global structs LACPPortp & LACPAggrp
					ODMAcquireLock(GlobalLock, 0, 0);
					LACPPortp[pPortInfo->Port] = pPort;
					if(pPortInfo->AggregatorPort = TRUE)
						for (i=0; i < MAX_PORTS; i++) {
							if (LACPAggrp[i] == 0) {
								LACPAggrp[i] = pAggr;
								break;
							}
						}
					ODMReleaseLock(GlobalLock,nFlags,0);

					pAdapter->nFlags = GEC_FLAG | LACP_FLAG; // Enable both.
					//Revisit: args
					ODMAdapterOpen();
					LacpInit(pPortInfo->Port);
					break;
			}
			break;
		case 1: // LACP is Disabled and GEC is Enabled.
			pPort = LACPPortp[pPortInfo->Port];
			pAggr = pPort->LACPAggrp;
			switch(Request){
				case 0:
					//bjaggu - check for aggregator port to true 7:33 pm 26th Nov
					if(pPort->AggregatorPort == TRUE)
					{
						CurrLevel4 = ODMAcquireLock(pAggr->AggrLock, 0, 0);
						
						/* Set all MAC address classes to MAX_PORTS + val */
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS + 1;
						
						//Added by jaggu 12:44 PM
						timerid = pAggr->ReshuffleTimerID;
						pAggr->ReshuffleTimerID = 0;
						ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel4);
						ODMUntimeout(timerid,pAggr);

						/* Reset MAC address of all non-aggregator ports to
						   factory MAC address */
						CurrLevel5 = ODMAcquireLock(GlobalLock, 0, 0);
						for(i=0;i<LACP_MAX_PER_GROUP;i++)
						{
							if (pAggr->LAGPorts[i] == 0 || 
									LACPPortp[pAggr->LAGPorts[i]] == pPort)
								continue;
							pTempAdapterContext = AdapterArray[pAggr->LAGPorts[i]];
							pTempAdapterContext->FuncStruct.HsmSetMacAddress(pTempAdapterContext, pTempAdapterContext->PermMacAddr);
							//added by jaggu
							ODMCopy(pTempAdapterContext->PermMacAddr, pTempAdapterContext->CurrMacAddr, MAC_ADDR_LEN);

							ODMSetdev_aggr(pTempAdapterContext, pTempAdapterContext);
							ODMSetMacAddr(pTempAdapterContext);

							pTempAdapterContext->pAggregatorContext = pTempAdapterContext;
							pTempAdapterContext->nFlags = 0;
						}
						/* Run through each member port in the 
						 * aggregation and free port/aggregator 
						 * structures.
						 */
						for(i=0;i<LACP_MAX_PER_GROUP;i++)
						{
							// Get the pointer to the member port.
							if (pAggr->LAGPorts[i] == 0)
								continue;
							pTempPort = LACPPortp[pAggr->LAGPorts[i]];
							LACPPortp[pAggr->LAGPorts[i]] = NULL;
							//bjaggu December 04 12:48
							ODMUnInitializeLock(pTempPort->PortLock,0);
							ODMFree(pTempPort, PortSize,0);
						}

						// Remove the Aggregator structure.
						for (i=0; i<MAX_PORTS; i++)
							if (LACPAggrp[i] == pAggr) {
								// Shift the remaining members
								for (j=i; LACPAggrp[j]; j++)
									LACPAggrp[j] = LACPAggrp[j+1];
								//bjaggu December 04 12:48
								ODMUnInitializeLock(pAggr->AggrLock,0);
								ODMFree(pAggr, AggrSize,0);
								break;
							}
						
						pAdapter->nFlags = 0; //Disable both GEC and LACP.
						ODMReleaseLock(GlobalLock,nFlags,CurrLevel5);
					}
					else	// Non aggregator port
					{
						CurrLevel4 = ODMAcquireLock(pAggr->AggrLock, 0, 0);
						CurrLevel5 = ODMAcquireLock(GlobalLock, 0, 0);
						/* Set MAC address classes using this port to MAX_PORTS+1 */
						for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
							if (pAggr->PortForMAC[i] == pPort->ActorPortNumber)
								pAggr->PortForMAC[i] = MAX_PORTS + 1;
						// Remove the port structure.
						for (i=0; i < LACP_MAX_PER_GROUP; i++)
							if (pAggr->LAGPorts[i] == pPortInfo->Port) {
								pAggr->LAGPorts[i] = 0;
								pAggr->NumPorts--;
								//Set Present MAC address of port to Factory address
								pAdapter->FuncStruct.HsmSetMacAddress(pAdapter, pAdapter->PermMacAddr);
								// Copy the Permenent address to CurrMacAddress - jaggu 23 Nov 8:00 PM
								ODMCopy(pAdapter->PermMacAddr, pAdapter->CurrMacAddr, MAC_ADDR_LEN);
								ODMSetdev_aggr(pAdapter, pAdapter);
								ODMSetMacAddr(pAdapter);
								
								LACPPortp[pPortInfo->Port] = NULL;
		
								//bjaggu December 04 12:48
								ODMUnInitializeLock(pPort->PortLock,0);

								ODMFree(pPort, PortSize,0);
								break;
							}
						
						/* Set MAC address classes to MAX_PORTS */
						for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
							if (pAggr->PortForMAC[i] == MAX_PORTS + 1)
								pAggr->PortForMAC[i] = MAX_PORTS;
					
						pAdapter->pAggregatorContext = pAdapter;
						pAdapter->nFlags = 0; //Disable both GEC and LACP.

						ODMReleaseLock(GlobalLock,nFlags,CurrLevel5);
						ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel4);
					}
										
					break;

				case 1: // LACP Disabled and GEC Enabled.
					//jaggu - 4:36 22nd Nov - Pass appropriate lock to release - Aggregator for the port will be modified
					pTempAggr=pPort->LACPAggrp;
					CurrLevel4 = ODMAcquireLock(pTempAggr->AggrLock, 0, 0);
					CurrLevel5 = ODMAcquireLock(GlobalLock, 0, 0);
					
					if (pPortInfo->AggregatorPort == FALSE) {

						if(pPortInfo->AggregatorIdentifier != pPort->LACPAggrp->AggregatorIdentifier)
						{
							/* Set MAC address classes to MAX_PORTS+1 */
							for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
								if (pAggr->PortForMAC[i] == pPort->ActorPortNumber)
									pAggr->PortForMAC[i] = MAX_PORTS + 1;
							/* Reset port's MAC address to factory address */
							pAdapter->FuncStruct.HsmSetMacAddress(pAdapter, pAdapter->PermMacAddr);
							ODMCopy(pAdapter->PermMacAddr, pAdapter->CurrMacAddr, MAC_ADDR_LEN);
							//Detach pPort from the aggregation.
							for (i=0;i < LACP_MAX_PER_GROUP; i++)
								if (pAggr->LAGPorts[i] == pPortInfo->Port) {
									pAggr->LAGPorts[i] = 0;
									pAggr->NumPorts--;
									break;
								}
							//Attach to other aggregation.
							pPort->LACPAggrp = (LACPPortp[pPortInfo->AggregatorIdentifier])->LACPAggrp;
							for (i=0;i < LACP_MAX_PER_GROUP; i++)
								if (pPort->LACPAggrp->LAGPorts[i] == 0) {
									pPort->LACPAggrp->LAGPorts[i] = pPortInfo->Port;
									//jaggu Dec 05 12:39
									pPort->LACPAggrp->NumPorts++;
									break;
								}
							// Set MAC address classes of previous aggregator to MAX_PORTS
							for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
								if (pAggr->PortForMAC[i] == MAX_PORTS + 1)
									pAggr->PortForMAC[i] = MAX_PORTS;
							pAdapter->pAggregatorContext = AdapterArray[pPortInfo->AggregatorIdentifier];
							pAdapter->FuncStruct.HsmSetMacAddress(pAdapter, pAdapter->pAggregatorContext->CurrMacAddr);
							// Copy the address to CurrMacAddress - jaggu 23 Nov 8:00 PM
							ODMCopy(pAdapter->pAggregatorContext->CurrMacAddr, pAdapter->CurrMacAddr, MAC_ADDR_LEN);

							Multi.Next = NULL;
							for (i=0; i< 128; i++)
								for (j=0; j < 16; j++) {
									start = pAdapter->pAggregatorContext->mca_tbl[i][j];
									while (start)
									{
										ODMCopy(start->MulticastAddr, Multi.MulticastAddr, MAC_ADDR_LEN);
										pAdapter->FuncStruct.HsmMulticastAdd(pAdapter, &Multi, FALSE);
										start = start->next;
									}
								}
							/* Replicate phy capabilities of aggregator - Ravi 28 Oct 4:56 PM */
							/* Revisit : Set media speed ? */
							pAdapter->FuncStruct.HsmSetPhyCapabilities(pAdapter, pAdapter->pAggregatorContext->PhysCapabilities, 0); 
							pAdapter->PhysCapabilities = pAdapter->pAggregatorContext->PhysCapabilities;

							ODMSetdev_aggr(pAdapter, pAdapter->pAggregatorContext);
							ODMSetMacAddr(pAdapter);

							//bjaggu December 06 1:38
							pAdapter->FuncStruct.HsmRxFilter(pAdapter, pAdapter->pAggregatorContext->lacprxFilterFlag);

							// If this card has the cable connected, tell upper layer about it. Dec 04, 5:08 PM
							if (GetNumberOfLinks(pAdapter->pAggregatorContext) == 1) {
								curstat = pAdapter->pAggregatorContext->AdapterStatus;
								pAdapter->pAggregatorContext->AdapterStatus |= LINK_UP;
								pAdapter->pAggregatorContext->FuncStruct.NsmIndicateLinkStatus((void *)pAdapter->pAggregatorContext);
								pAdapter->pAggregatorContext->AdapterStatus = curstat;
							}
						}
					}

					ODMReleaseLock(GlobalLock,nFlags,CurrLevel5);
					ODMReleaseLock(pTempAggr->AggrLock,nFlags,CurrLevel4);
					break;

				case 2: // LACP is enabled and GEC is disabled.
					ODMAcquireLock(pPort->LACPAggrp->AggrLock, 0, 0);
					ODMAcquireLock(GlobalLock, 0, 0);

					if(pPort->AggregatorPort = TRUE)
					{
						// It is an aggregator port.
						// Make all the ports in the aggregation individual Aggregator port.
						for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS + 1;

						for (i=0; i< LACP_MAX_PER_GROUP; i++) {
							if (pAggr->LAGPorts[i] == 0)
								continue;
							pTempAdapterContext = AdapterArray[pAggr->LAGPorts[i]];
							pTempAdapterContext->pAggregatorContext = pTempAdapterContext;
							pTempAdapterContext->FuncStruct.HsmSetMacAddress(pTempAdapterContext, pTempAdapterContext->PermMacAddr);
						}
						for(i=0;i<pAggr->NumPorts;i++)
						{
							if (pAggr->LAGPorts[i] == 0)
								continue;
							pTempPort = LACPPortp[pAggr->LAGPorts[i]];
							if(pTempPort->AggregatorPort)
							{
								pTempAggr = pTempPort->LACPAggrp;
								pTempAggr->IndividualPort = TRUE;
								pTempPort->ControlVars.LACPEnabled = TRUE;
								pTempAdapterContext = AdapterArray[pAggr->LAGPorts[i]];
								pTempAdapterContext->nFlags = LACP_FLAG; // Only LACP is Enabled.
								pTempAdapterContext->pAggregatorContext = pTempAdapterContext;
							}
							else
							{
								//Allocate Aggr Structure 
								pTempAggr = ODMMalloc(AggrSize, ZERO_MEMORY);
								if (pTempAggr == NULL) {
									ODMError("LacpConfig: Memory allocation of lacpAggr failed\n");
									return 0;
								}
								ODMInitializeLock(&pTempAggr->AggrLock, 0);
								// Initialize PortForMac - Gopi, 16 Oct 3:35 PM
								for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
									pAggr->PortForMAC[i] = MAX_PORTS;
								pTempPort->LACPAggrp = pTempAggr;
								pTempAggr->IndividualPort = TRUE;
								pTempAggr->AggregatorIdentifier = pTempPort->ActorPortNumber;
								pTempPort->ControlVars.LACPEnabled  = TRUE;
								pTempAdapterContext = AdapterArray[pAggr->LAGPorts[i]];
								pTempAdapterContext->nFlags = LACP_FLAG; // Only LACP is Enabled.
								pTempAdapterContext->pAggregatorContext = pTempAdapterContext;
							}
							for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
								pAggr->PortForMAC[i] = MAX_PORTS;

							// Release locks before calling LacpInit
							ODMReleaseLock(GlobalLock,nFlags,0);
							ODMReleaseLock(pPort->LACPAggrp->AggrLock,nFlags,0);
							LacpInit(pPortInfo->Port);
							ODMAcquireLock(pPort->LACPAggrp->AggrLock, 0, 0);
							ODMAcquireLock(GlobalLock, 0, 0);
						}
					}
					else
					{
						/* Set MAC address classes to MAX_PORTS+1 */
						for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
							if (pAggr->PortForMAC[i] == pPort->ActorPortNumber)
								pAggr->PortForMAC[i] = MAX_PORTS + 1;
						/* Reset port's MAC address to factory address */
						pAdapter->FuncStruct.HsmSetMacAddress(pAdapter, pAdapter->PermMacAddr);
						for (i=0; i < pAggr->NumPorts; i++)
							if (pAggr->LAGPorts[i] == pPort->ActorPortNumber) {
								pAggr->LAGPorts[i] = 0;
								pAggr->NumPorts--;
								break;
							}
						// Not an aggregator port. Allocate Aggr Structure 
						pTempAggr = ODMMalloc(AggrSize, ZERO_MEMORY);
						if (pTempAggr == NULL) {
							ODMError("LacpConfig: Memory allocation of lacpAggr failed\n");
							return 0;
						}
						ODMInitializeLock(&pTempAggr->AggrLock, 0);
						for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS;
						pPort->LACPAggrp = pTempAggr;
						pTempAggr->IndividualPort = TRUE;
						pTempAggr->AggregatorIdentifier = pPort->ActorPortNumber;
						pPort->ControlVars.LACPEnabled  = TRUE;
						pTempAdapterContext = AdapterArray[pPort->ActorPortNumber];
						pTempAdapterContext->nFlags = LACP_FLAG; // Only LACP is Enabled.
						pTempAdapterContext->pAggregatorContext = pTempAdapterContext;
						// Release locks before calling LacpInit
						ODMReleaseLock(GlobalLock,nFlags,0);
						ODMReleaseLock(pPort->LACPAggrp->AggrLock,nFlags,0);
						LacpInit(pPortInfo->Port);
						break;
					}
					ODMReleaseLock(GlobalLock,nFlags,0);
					ODMReleaseLock(pPort->LACPAggrp->AggrLock,nFlags,0);
					break;

				case 3: // LACP is enabled and GEC is enabled.

					ODMAcquireLock(pPort->LACPAggrp->AggrLock, 0, 0);
					ODMAcquireLock(GlobalLock, 0, 0);
					// allowed for only Aggregator port.
					if(pPort->AggregatorPort = TRUE)
					{
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS + 1;
						pPort->ControlVars.LACPEnabled = TRUE;
						UpdatePortParams(pPort, pPortInfo);
						for (i=0; i < LACP_MAX_PER_GROUP; i++)
							if (pAggr->LAGPorts[i] != pPort->ActorPortNumber)
								pAggr->LAGPorts[i] = 0;
						
						// Update AdapterContext structure.
						pAdapter->nFlags = GEC_FLAG|LACP_FLAG;

						// Release locks before calling LacpInit
						ODMReleaseLock(GlobalLock,nFlags,0);
						ODMReleaseLock(pPort->LACPAggrp->AggrLock,nFlags,0);
						LacpInit(pPortInfo->Port);
						ODMAcquireLock(pPort->LACPAggrp->AggrLock, 0, 0);
						ODMAcquireLock(GlobalLock, 0, 0);

						// Enable LACP for all non aggregator ports.
						for(i=0;i<pAggr->NumPorts;i++)
						{
							if (pAggr->LAGPorts[i] == 0)
								continue;
							j = pAggr->LAGPorts[i];
							pTempPort = LACPPortp[j];
							pTempPort->ControlVars.LACPEnabled = TRUE;
							UpdatePortParams(pTempPort, pPortInfo);

							// Update AdapterContext structure of pTempPort.
							pTempAdapterContext = AdapterArray[j];
							pTempAdapterContext->nFlags = GEC_FLAG| LACP_FLAG;

							// Start state machines.
							// Release locks before calling LacpInit
							pAggr->LAGPorts[i] = 0;
							ODMReleaseLock(GlobalLock,nFlags,0);
							ODMReleaseLock(pPort->LACPAggrp->AggrLock,nFlags,0);
							LacpInit(j);
							ODMAcquireLock(pPort->LACPAggrp->AggrLock, 0, 0);
							ODMAcquireLock(GlobalLock, 0, 0);
						}
					}
					ODMReleaseLock(GlobalLock,nFlags,0);
					ODMReleaseLock(pPort->LACPAggrp->AggrLock,nFlags,0);
					break;
			}
			break;

		case 2: // LACP is enabled and GEC is Disabled.
			pPort = LACPPortp[pPortInfo->Port];
			pAggr = pPort->LACPAggrp;
			switch(Request){
				case 0:// LACP is disabled and GEC is disabled.

					/* Block sending further packets */
					ODMAcquireLock(pAggr->AggrLock, 0, 0);
					for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
						pAggr->PortForMAC[i] = MAX_PORTS + 1;
					ODMReleaseLock(pAggr->AggrLock,nFlags,0);
					// Disable slow protocol multicast address (& any other) on pPort.
					Multi.Next = NULL;
					ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
					pAdapter->FuncStruct.HsmMulticastDelete(pAdapter, &Multi);
					// Wait till the LACPDU queue becomes empty.
					while(pAdapter->pLacpRCB->Read != pAdapter->pLacpRCB->Write)
					{
						ODMDelay((ULONG)20);
					} 
					// Stop all the state machines and unschedule timer functions.
					StopLACPTimers(pPort);

					ODMAcquireLock(GlobalLock, 0, 0);
					// Remove the port and aggregator structures
					for (i=0; i<MAX_PORTS; i++)
						if (LACPAggrp[i] == pAggr) {
							// Shift the remaining members
							for (j=i; LACPAggrp[j]; j++)
								LACPAggrp[j] = LACPAggrp[j+1];
							ODMFree(pAggr, AggrSize,0);
							break;
						}
					LACPPortp[pPortInfo->Port] = NULL;
					ODMFree(pPort, PortSize,0);
					pAdapter->nFlags = 0;
					ODMReleaseLock(GlobalLock,nFlags,0);
					break;
				case 1: // LACP is disabled and GEC is enabled.
					/* Block sending further packets */
					ODMAcquireLock(pAggr->AggrLock, 0, 0);
					for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
						pAggr->PortForMAC[i] = MAX_PORTS + 1;
					ODMReleaseLock(pAggr->AggrLock,nFlags,0);
					// Disable slow protocol multicast address (& any other) on pPort.
					Multi.Next = NULL;
					ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
					pAdapter->FuncStruct.HsmMulticastDelete(pAdapter, &Multi);
					// Wait till the LACPDU queue becomes empty.
					while(pAdapter->pLacpRCB->Read != pAdapter->pLacpRCB->Write)
						ODMDelay((ULONG)20);
					// Stop all the state machines and unschedule timer functions.
					StopLACPTimers(pPort);

					if(pPortInfo->AggregatorPort = TRUE)
					{
						// Make this an aggregator port with GEC enabled.
						// NOTE: No need to hold port/Aggr lock as there are no 
						// threads/timer routines accessing port/aggregator structures.

						pAggr->IndividualPort = FALSE;
						pPort->ControlVars.LACPEnabled = FALSE;
						pAdapter->nFlags = GEC_FLAG; // only GEC is enabled.
						pAdapter->pAggregatorContext = pAdapter;
						// Clear LAGPorts. Add it's entry into LAGPorts
						for (i=0; i< LACP_MAX_PER_GROUP; i++)
							pAggr->LAGPorts[i] = 0;
						pAggr->LAGPorts[0] = pPortInfo->Port;
						pAggr->NumPorts = 1;
					}
					else
					{
						// Non aggregator port with GEC enabled.

						ODMAcquireLock(GlobalLock, 0, 0);
						// Remove the aggregator structure
						for (i=0; i<MAX_PORTS; i++)
							if (LACPAggrp[i] == pAggr) {
								// Shift the remaining members
								for (j=i; LACPAggrp[j]; j++)
									LACPAggrp[j] = LACPAggrp[j+1];
								ODMFree(pAggr, AggrSize,0);
								break;
							}
						ODMReleaseLock(GlobalLock,nFlags,0);

						// NOTE: No need to hold port lock here as no threads/timer 
						// functions accessing port structures.
						pAggr = LACPPortp[pPortInfo->AggregatorIdentifier]->LACPAggrp;
						pPort->LACPAggrp = pAggr;
						pPort->ControlVars.LACPEnabled = FALSE;
						// Add its entry on to the aggregator structures.
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0;i < LACP_MAX_PER_GROUP; i++)
							if (pAggr->LAGPorts[i] == 0) {
								pAggr->LAGPorts[i] = pPortInfo->Port;
								pAggr->NumPorts++;
								break;
							}
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);

						pAggregatorAdapterContext = AdapterArray[pPortInfo->AggregatorIdentifier];
						pAdapter->pAggregatorContext = pAggregatorAdapterContext;
						pAdapter->nFlags = GEC_FLAG; // Only GEC is enabled.
						pAdapter->FuncStruct.HsmSetMacAddress(pAdapter, pAggregatorAdapterContext->CurrMacAddr);
					}
					break;
				case 2:
					// No change.
					UpdatePortParams(pPort, pPortInfo);
					UpdateAggrParams(pAggr, pPort);
					break;
				case 3: // LACP is enabled and GEC is enabled.
					if(pPortInfo->AggregatorPort = TRUE)
					{
						ODMAcquireLock(pPort->PortLock, 0, 0);
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						// Make this an aggregator port with GEC and LACP enabled.
						pAggr->IndividualPort = FALSE;
						// Update Actor values in the Port and aggregator structure like 
						// Key, timeout etc...
						UpdatePortParams(pPort, pPortInfo);
						UpdateAggrParams(pAggr, pPort);

						// set pPort's selected =Unselected to make the port 
						// select an aggregator.
						pPort->ControlVars.Selected = UNSELECTED;

						pAdapter->pAggregatorContext = pAdapter;
						for (i=0; i < LACP_MAX_PER_GROUP; i++)
							pAggr->LAGPorts[i] = 0;
						pAggr->NumPorts = 0;
						
						pAdapter->nFlags = GEC_FLAG | LACP_FLAG; // both GEC & LACP are enabled.
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);
						ODMReleaseLock(pPort->PortLock,nFlags,0);
					}
					else
					{
						// Non aggregator port with GEC and LACP enabled.
						// Disable LACP and wait till LACPDUs received are processed.
						/* Block sending further packets */
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS + 1;
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);

						Multi.Next = NULL;
						ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
						pAdapter->FuncStruct.HsmMulticastDelete(pAdapter, &Multi);
						// Wait till the LACPDU queue becomes empty.
						while(pAdapter->pLacpRCB->Read != pAdapter->pLacpRCB->Write)
							ODMDelay((ULONG)20);
						// Stop all the state machines and unschedule timer functions.
						StopLACPTimers(pPort);

						pPort->AggregatorPort= FALSE;

						ODMAcquireLock(GlobalLock, 0, 0);
						// Remove the aggregator structure
						for (i=0; i<MAX_PORTS; i++)
							if (LACPAggrp[i] == pAggr) {
								// Shift the remaining members
								for (j=i; LACPAggrp[j]; j++)
									LACPAggrp[j] = LACPAggrp[j+1];
								ODMFree(pAggr, AggrSize,0);
								break;
							}
						ODMReleaseLock(GlobalLock,nFlags,0);

						pAdapter->nFlags = GEC_FLAG | LACP_FLAG; // Both GEC & LACP are enabled.
						pPort->ControlVars.Selected = UNSELECTED;
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							if (pAggr->PortForMAC[i] == MAX_PORTS + 1)
								pAggr->PortForMAC[i] = MAX_PORTS;
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);

						LacpInit(pPortInfo->Port);
					}
					break;
			}
			break;

		case 3: // LACP is Enabled and GEC is Enabled.
			pPort = LACPPortp[pPortInfo->Port];
			pAggr = pPort->LACPAggrp;
			switch(Request){
				case 0:
					if(pPort->AggregatorPort = TRUE)
					{
						// Detach all non aggregator ports from the aggregation.
						// Prevent ports from selecting the same aggregator.
						pAggr->ActorAggregatorOperKey = 0;

						/* Block sending further packets */
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS + 1;
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);

						for(i=0;i< LACP_MAX_PER_GROUP;i++)
						{
							if (pAggr->LAGPorts[i] == 0)
								continue;
							pTempPort = LACPPortp[pAggr->LAGPorts[i]];
							if(pTempPort->AggregatorPort == FALSE)
							{
								pTempAdapterContext = AdapterArray[pAggr->LAGPorts[i]];
								pTempPort->ActorOperPortKey = 0;
								// Disable LACP and wait till LACPDUs received are processed.
								Multi.Next = NULL;
								ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
								pTempAdapterContext->FuncStruct.HsmMulticastDelete(pTempAdapterContext, &Multi);
								// Wait till the LACPDU queue becomes empty.
								while(pTempAdapterContext->pLacpRCB->Read != pTempAdapterContext->pLacpRCB->Write)
									ODMDelay((ULONG)20);

								pTempAdapterContext->FuncStruct.HsmSetMacAddress(pTempAdapterContext, pTempAdapterContext->PermMacAddr);

								ODMAcquireLock(pTempPort->PortLock, 0, 0);
								LacpMuxMachineState(pTempPort);
								ODMReleaseLock(pTempPort->PortLock,nFlags,0);
								// Stop all the state machines and unschedule timer functions.
								StopLACPTimers(pTempPort);

								ODMAcquireLock(GlobalLock, 0, 0);
								LACPPortp[pAggr->LAGPorts[i]] = NULL;
								ODMFree(pTempPort, PortSize,0);
								ODMReleaseLock(GlobalLock,nFlags,0);

								// Update the adapter Context structure.
								pTempAdapterContext->pAggregatorContext  = pTempAdapterContext;
								pTempAdapterContext->nFlags = 0; // Disable both GEC and LACP.
							}
						}
						// Now remove the aggregator port
						// Disable LACP and wait till LACPDUs received are processed.
						Multi.Next = NULL;
						ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
						pAdapter->FuncStruct.HsmMulticastDelete(pAdapter, &Multi);
						// Wait till the LACPDU queue becomes empty.
						while(pAdapter->pLacpRCB->Read != pAdapter->pLacpRCB->Write)
							ODMDelay((ULONG)20);
						// Stop all the state machines and unschedule timer functions.
						StopLACPTimers(pPort);

						// Remove the aggregator structure
						ODMAcquireLock(GlobalLock, 0, 0);
						for (i=0; i<MAX_PORTS; i++)
							if (LACPAggrp[i] == pAggr) {
								// Shift the remaining members
								for (j=i; LACPAggrp[j]; j++)
									LACPAggrp[j] = LACPAggrp[j+1];
								ODMFree(pAggr, AggrSize,0);
								break;
							}
						ODMReleaseLock(GlobalLock,nFlags,0);

						// Update the pAdapterContext structure.
						pAdapter->nFlags = 0; // Disable both GEC and LACP.

					}
					else
					{
						// For non aggregator port.
						/* Block sending further packets */
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS + 1;
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);

						// Disable LACP and wait till LACPDUs received are processed.
						Multi.Next = NULL;
						ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
						pAdapter->FuncStruct.HsmMulticastDelete(pAdapter, &Multi);
						// Wait till the LACPDU queue becomes empty.
						while(pAdapter->pLacpRCB->Read != pAdapter->pLacpRCB->Write)
							ODMDelay((ULONG)20);
						// Stop all the state machines and unschedule timer functions.
						StopLACPTimers(pPort);

						pAdapter->FuncStruct.HsmSetMacAddress(pAdapter, pAdapter->PermMacAddr);

						// Prevent port from selecting aggregator.
						pPort->ActorOperPortKey = 0;
						pPort->ControlVars.Selected = UNSELECTED;
						ODMAcquireLock(pPort->PortLock, 0, 0);
						LacpMuxMachineState(pPort);
						ODMReleaseLock(pPort->PortLock,nFlags,0);

						ODMAcquireLock(GlobalLock, 0, 0);
						LACPPortp[pPortInfo->Port] = NULL;
						ODMFree(pPort, PortSize,0);
						ODMReleaseLock(GlobalLock,nFlags,0);

						// Update the adapter context structure.
						pAdapter->nFlags = 0; // Both GEC & LACP are disabled.
						pAdapter->pAggregatorContext = pAdapter;
					}
					break;
				case 1: // LACP is disabled and GEC is enabled.
					// Allowed for aggregator port only..
					if(pPort->AggregatorPort = TRUE)
					{
						/* Block sending further packets */
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS + 1;
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);

						// Detach all non aggregator ports from the aggregation.
						for(i=0;i< LACP_MAX_PER_GROUP;i++)
						{
							if (pAggr->LAGPorts[i] == 0)
								continue;
							pTempPort = LACPPortp[pAggr->LAGPorts[i]];
							if(pTempPort->AggregatorPort == FALSE)
							{
								pTempAdapterContext = AdapterArray[pAggr->LAGPorts[i]];
								// Disable LACP and wait till LACPDUs received are processed.
								Multi.Next = NULL;
								ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
								pTempAdapterContext->FuncStruct.HsmMulticastDelete(pTempAdapterContext, &Multi);
								// Wait till the LACPDU queue becomes empty.
								while(pTempAdapterContext->pLacpRCB->Read != pTempAdapterContext->pLacpRCB->Write)
									ODMDelay((ULONG)20);
								// Stop all the state machines and unschedule timer functions.
								StopLACPTimers(pTempPort);
								// Update the adapter Context structure.
								pTempAdapterContext->nFlags = GEC_FLAG; // Enable Only GEC.
							}
						}
						// Disable LACP for Aggregator port and wait till LACPDUs received are processed.
						Multi.Next = NULL;
						ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
						pAdapter->FuncStruct.HsmMulticastDelete(pAdapter, &Multi);
						// Wait till the LACPDU queue becomes empty.
						while(pAdapter->pLacpRCB->Read != pAdapter->pLacpRCB->Write)
							ODMDelay((ULONG)20);
						// Stop all the state machines and unschedule timer functions.
						StopLACPTimers(pPort);
						// Update the adapter Context structure.
						pAdapter->nFlags = GEC_FLAG; // Enable Only GEC.
						/* Enable sending  packets */
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							if (pAggr->PortForMAC[i] == MAX_PORTS + 1)
								pAggr->PortForMAC[i] = MAX_PORTS;
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);

					}
					break;
				case 2: // LACP is enabled and GEC is disabled.
					if(pPort->AggregatorPort = TRUE)
					{
						/* Block sending further packets */
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS + 1;

						// Prevent other ports from attaching to this aggregator
						pAggr->ActorAggregatorOperKey = 0;
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);

						// Detach all non aggregator ports
						for(i=0;i< LACP_MAX_PER_GROUP;i++)
						{
							if (pAggr->LAGPorts[i] == 0)
								continue;
							pTempPort = LACPPortp[pAggr->LAGPorts[i]];

							if(pTempPort->AggregatorPort == FALSE)
							{
								pTempAdapterContext = AdapterArray[pAggr->LAGPorts[i]];
								pTempAdapterContext->FuncStruct.HsmSetMacAddress(pTempAdapterContext, pTempAdapterContext->PermMacAddr);

								// Disable LACP and wait till LACPDUs received are processed.
								Multi.Next = NULL;
								ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
								pTempAdapterContext->FuncStruct.HsmMulticastDelete(pTempAdapterContext, &Multi);
								// Wait till the LACPDU queue becomes empty.
								while(pTempAdapterContext->pLacpRCB->Read != pTempAdapterContext->pLacpRCB->Write)
									ODMDelay((ULONG)20);

								ODMAcquireLock(pTempPort->PortLock, 0, 0);
								pPort->ControlVars.Selected = UNSELECTED;
								ODMReleaseLock(pTempPort->PortLock,nFlags,0);
								// Unschedule timer functions.
								StopLACPTimers(pPort);

								// Allocate Aggr Structure and Initialize
								pTempAggr = ODMMalloc(AggrSize, ZERO_MEMORY);
								if (pTempAggr == NULL) {
									ODMError("LacpConfig: Memory allocation of lacpAggr failed\n");
									return 0;
								}
								ODMInitializeLock(&pTempAggr->AggrLock, 0);
								for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
									pAggr->PortForMAC[i] = MAX_PORTS;
								UpdateAggrParams(pTempAggr, pPort);
								pTempAggr->IndividualPort = TRUE;
								pTempAggr->AggregatorIdentifier = pTempPort->ActorPortNumber;
								pTempPort->AggregatorPort = TRUE;
								pTempPort->LACPAggrp = pTempAggr;

								ODMAcquireLock(GlobalLock, 0, 0);
								for (i=0; i < MAX_PORTS; i++)
									if (LACPAggrp[i] == NULL) {
										LACPAggrp[i] = pTempAggr;
										break;
									}
								ODMReleaseLock(GlobalLock,nFlags,0);

								// Update the adapter Context structure.
								pTempAdapterContext->pAggregatorContext = pTempAdapterContext;
								pTempAdapterContext->nFlags = LACP_FLAG; // Enable Only LACP.
								LacpInit(pAggr->LAGPorts[i]);
							}
						}
						// Now update the aggregator structure.
						// Disable LACP and wait till LACPDUs received are processed.
						Multi.Next = NULL;
						ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);						
						pAdapter->FuncStruct.HsmMulticastDelete(pAdapter, &Multi);
						// Wait till the LACPDU queue becomes empty.
						while(pAdapter->pLacpRCB->Read != pAdapter->pLacpRCB->Write)
							ODMDelay((ULONG)20);
						// Stop all the state machines and unschedule timer functions.
						StopLACPTimers(pPort);
						// Update LAGPorts & initialize MAC class with MAX_PORTS
						for (i=0; i < LACP_MAX_PER_GROUP; i++)
							pAggr->LAGPorts[i] = 0;
						pAggr->NumPorts = 0;
						for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS;

						pAggr->IndividualPort = TRUE;
						LacpInit(pPortInfo->Port);
					}
					else
					{
						// For non aggregator port.
						/* Block sending further packets */
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS + 1;
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);

						// Disable LACP and wait till LACPDUs received are processed.
						Multi.Next = NULL;
						ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);
						pAdapter->FuncStruct.HsmMulticastDelete(pAdapter, &Multi);
						// Wait till the LACPDU queue becomes empty.
						while(pAdapter->pLacpRCB->Read != pAdapter->pLacpRCB->Write)
							ODMDelay((ULONG)20);
						// Stop all the state machines and unschedule timer functions.
						StopLACPTimers(pPort);

						for (i=0; i< LACP_MAX_PER_GROUP; i++)
							if (pAggr->LAGPorts[i] == pPort->ActorPortNumber) {
								pAggr->LAGPorts[i] = 0;
								pAggr->NumPorts--;
							}
						pAdapter->FuncStruct.HsmSetMacAddress(pAdapter, pAdapter->PermMacAddr);
						ODMAcquireLock(pAggr->AggrLock, 0, 0);
						for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS;
						ODMReleaseLock(pAggr->AggrLock,nFlags,0);


						// Allocate Aggr Structure and initialize
						pTempAggr = ODMMalloc(AggrSize, ZERO_MEMORY);
						if (pTempAggr == NULL) {
							ODMError("LacpConfig: Memory allocation of lacpAggr failed\n");
							return 0;
						}
						ODMInitializeLock(&pTempAggr->AggrLock, 0);
						for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
							pAggr->PortForMAC[i] = MAX_PORTS;
						UpdateAggrParams(pTempAggr, pPort);
						pTempAggr->IndividualPort = TRUE;
						pTempAggr->AggregatorIdentifier = pPort->ActorPortNumber;
						pPort->AggregatorPort = TRUE;
						pPort->LACPAggrp = pTempAggr;

						ODMAcquireLock(GlobalLock, 0, 0);
						for (i=0; i < MAX_PORTS; i++)
							if (LACPAggrp[i] == NULL) {
								LACPAggrp[i] = pTempAggr;
								break;
							}
						ODMReleaseLock(GlobalLock,nFlags,0);

						// Update the adapter Context structure.
						pAdapter->pAggregatorContext = pAdapter;
						pAdapter->nFlags = LACP_FLAG; // Enable Only LACP.
						LacpInit(pPortInfo->Port);
					}
					break;
				case 3: // LACP is enabled and GEC is enabled 
					if(pPort->AggregatorPort = TRUE)
					{
						if(pPortInfo->AggregatorPort = FALSE)
						{
							/* Block sending further packets */
							ODMAcquireLock(pAggr->AggrLock, 0, 0);
							for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
								pAggr->PortForMAC[i] = MAX_PORTS + 1;
							pAggr->ActorAggregatorOperKey = 0;
							ODMReleaseLock(pAggr->AggrLock,nFlags,0);

							// Aggregator port has to be removed.
							// Load some negative values in the pAggr structure
							ODMAcquireLock(pPort->PortLock, 0, 0);
							pPort->ActorOperPortKey = 0;
							// Update the pPort structure with pPortInfo values.
							UpdatePortParams(pPort, pPortInfo);
							ODMReleaseLock(pPort->PortLock,nFlags,0);
							// Detach ports in the aggregation
							for(i=0;i<LACP_MAX_PER_GROUP;i++)
							{
								if (pAggr->LAGPorts[i] == 0)
									continue;
								pTempPort = LACPPortp[pAggr->LAGPorts[i]];
								ODMAcquireLock(GlobalLock, 0, 0);
								ODMPostEvent(pTempPort,EV_SELECTED_FALSE,0);
								ODMReleaseLock(GlobalLock,nFlags,0);
							}
							// The last non aggregator port will remove the aggregator structure.
							return 0;
						}
						// Check if the aggregator key has changed
						if(pPort->ActorOperPortKey != pPortInfo->ActorOperKey)
						{
							ODMAcquireLock(pPort->PortLock, 0, 0);
							ODMAcquireLock(pAggr->AggrLock, 0, 0);
							// Update the pPort structure with portinfo values.
							UpdatePortParams(pPort, pPortInfo);
							//overwrite the new operational values in the aggregator structure
							pAggr->ActorAggregatorOperKey = pPortInfo->ActorOperKey;
							UpdateAggrParams(pAggr, pPort);

							ODMReleaseLock(pAggr->AggrLock,nFlags,0);
							ODMReleaseLock(pPort->PortLock,nFlags,0);

							//detach non aggregator ports.
							for(i=0;i<LACP_MAX_PER_GROUP;i++)
							{
								if (pAggr->LAGPorts[i] == 0)
									continue;
								pTempPort = LACPPortp[pAggr->LAGPorts[i]];
								if(pTempPort->AggregatorPort = TRUE)
									continue;	
								ODMAcquireLock(GlobalLock, 0, 0);
								ODMPostEvent(pTempPort,EV_SELECTED_FALSE,0);
								ODMReleaseLock(GlobalLock,nFlags,0);
							}
						}
						else
						{
							ODMAcquireLock(pPort->PortLock, 0, 0);
							// update the new operational vaues into pPort.
							UpdatePortParams(pPort, pPortInfo);
							pPort->NTT= TRUE;
							LacpTransmitMachine(pPort);
							ODMReleaseLock(pPort->PortLock,nFlags,0);
						}
					}
					else
					{
						// for non aggregator port.
						ODMAcquireLock(pPort->PortLock, 0, 0);
						if(pPortInfo->AggregatorPort = TRUE)
						{
							/* Block sending further packets */
							ODMAcquireLock(pAggr->AggrLock, 0, 0);
							for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
								pAggr->PortForMAC[i] = MAX_PORTS + 1;
							ODMReleaseLock(pAggr->AggrLock,nFlags,0);

							pAdapter->FuncStruct.HsmSetMacAddress(pAdapter, pAdapter->PermMacAddr);

							ODMAcquireLock(pAggr->AggrLock, 0, 0);
							for (i=0; i < LACP_MAX_PER_GROUP; i++)
								if (pAggr->LAGPorts[i] == pPort->ActorPortNumber) {
									pAggr->LAGPorts[i] = 0;
									pAggr->NumPorts--;
									break;
								}
							for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
								pAggr->PortForMAC[i] = MAX_PORTS;
							ODMReleaseLock(pAggr->AggrLock,nFlags,0);

							// Make this an aggregator port.
							// update the new operational vaues into pPort.
							UpdatePortParams(pPort, pPortInfo);
							// Allocate Aggregator structure and Initialize
							pTempAggr = ODMMalloc(AggrSize, ZERO_MEMORY);
							if (pTempAggr == NULL) {
								ODMError("LacpConfig: Memory allocation of lacpAggr failed\n");
								return 0;
							}
							ODMInitializeLock(&pTempAggr->AggrLock, 0);
							for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
								pAggr->PortForMAC[i] = MAX_PORTS;
							UpdateAggrParams(pTempAggr, pPort);
							pPort->LACPAggrp = pTempAggr;
							pPort->AggregatorPort = TRUE;
							pTempAggr->AggregatorIdentifier = pPort->ActorPortNumber;

							ODMAcquireLock(GlobalLock, 0, 0);
							for (i=0; i < MAX_PORTS; i++)
								if (LACPAggrp[i] == NULL) {
									LACPAggrp[i] = pTempAggr;
									break;
								}

							ODMReleaseLock(GlobalLock,nFlags,0);
							// Update adapter context of pPort.
							pAdapter->pAggregatorContext = pAdapter;

							pPort->ControlVars.Selected = UNSELECTED;
							LacpMuxMachineState(pPort);
							ODMReleaseLock(pPort->PortLock,nFlags,0);
							return 0;
						}
						if(pPort->ActorOperPortKey != pPortInfo->ActorOperKey)
						{
							UpdatePortParams(pPort, pPortInfo);
							pPort->ControlVars.Selected = UNSELECTED;
							LacpMuxMachineState(pPort);
						}
						ODMReleaseLock(pPort->PortLock,nFlags,0);
					}
					break;
			}
			break;
	}

	if (pAdapter->nFlags)
		LacpAdapterStatusCheck(pAdapter);

	//DbgPrint1("Exiting  LacpConfig: port %x\n", pPortInfo->Port);
	return 0;
}

/********************************************************************
*f*
*
* Name :			LacpInit
*
* Description :		Enables the Slow protocol multicast address and initializes the
*					LACP state machine. 
*
* Parameters :		Port	Port for which state machine has to be called
*
*
* Return Value :	SUCCESS or FAILURE
*
* Called By :		LacpConfig
*
* Lock :			Locks (Port, Aggr, Global) should not be held 
*					when calling this function
*
*f*
*********************************************************************/

int
LacpInit(UINT Port)
{
	MultiList Multi;
	lacpPort_t *pPort;
	AdapterContext *pAdapter;

	/* Get the pointer to the port and aggregator structure for this Port.*/
	GET_LACPPORTP(Port, pPort);

	if (pPort->ControlVars.LACPEnabled) 
	{
		Multi.Next = NULL;
	
		/* Copy SlowProtocolMulticast address to MulticastAddr list */
		ODMCopy(SlowProtocolMulticast, Multi.MulticastAddr, MAC_ADDR_LEN);

		/* Enable the SLOW_PROTOCOL_MULT_ADDR in this Port.*/
		pAdapter = AdapterArray[Port];
		if ( pAdapter->FuncStruct.HsmMulticastAdd(pAdapter, &Multi, FALSE) == FAILURE)
		{
			ODMError(" !LacpInit : HsmMulticast Enable failed for port %d", Port);
			return FAILURE;
		}
	
		LacpStateMachine(pPort,EV_REINITIALIZE_IS_TRUE,NULL);
		
		return SUCCESS;
	}
	ODMError("LacpInit: LACP not enabled for port %d", Port);
	return FAILURE;
}

/*  Lacp Control Module */
/********************************************************************
*f*
*
*	Name :  LacpStateMachine
*
*	Description :This function implements the entire lacp state machine 
*                for a port. It invokes all the state machines for 
*                the port.
*
*	Parameters :
*				pPort	Pointer to the lacpPort_t structure.
*				event	Event which has caused this state machine to be called.
*				Rcb		Pointer to the HsmRCB
*
*	Return Value : None
*
*	Called By : LacpInit and LacpProcessPackets.
*
*	Lock : The function holds the Port lock.
*
*f*
*********************************************************************/

void
LacpStateMachine(lacpPort_t *pPort, char event, HsmRCB *Rcb)
{
	PRIV_LEVEL CurrLevel;
	
	if(pPort)
    {
		CurrLevel = ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);

		if(event == EV_SELECTED_FALSE)
			pPort->ControlVars.Selected = UNSELECTED;

		if(event < NUM_RECV_STATE_MC_EVENTS)
			(*lacpRcvStaMc[pPort->ReceiveMachineState][event])(pPort,Rcb);
		
		LacpPeriodicTransmissionMachine(pPort);
	
		if(pPort->MuxMachineState == MUX_DETACHED && pPort->ControlVars.Selected == UNSELECTED)
		{
			SelectionLogic(pPort);
			if(pPort->ControlVars.Selected == UNSELECTED)
			{
				ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
            	if(Rcb)
               		Rcb->Status = FREE;
            	return;
			}
		}

		if(event < NUM_MUX_STATE_MC_EVENTS)
       		LacpMuxMachineState(pPort);

		LacpActorChurnDetectionMachine(pPort);
       	LacpPartnerChurnDetectionMachine(pPort);

		pPort->ControlVars.BEGIN = FALSE;

		if(pPort->NTT == TRUE)
        	LacpTransmitMachine(pPort);
                         
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);
	
	}
	else /* if pPort is NULL */
	{
		ODMError("LacpStateMachine : pPort is null.Cannot call the state machines");
		if(Rcb)
			Rcb->Status = FREE;
	}
	return;
}

/********************************************************************
*f*
*
* Name : RcvStateMachineInit
*
* Description : This function initialises/reinitialise the receive 
*				state machine. 
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*				Rcb		Pointer to the HsmRCB structure
*
* Return Value : None
*
* Called By : LacpStateMachine.
*
* Lock : This function is called with the PortLock held.
*
*f*
*********************************************************************/


 
void
RcvStateMachineInit(lacpPort_t *pPort, HsmRCB *Rcb)
{
	/* Copy the admin values key,lacp_activity,LACP_timeout,port_priority 
	 * in the per port Structure to corresponding Operational variables.
	 */

	pPort->ControlVars.Selected = UNSELECTED;

	LacpRecordDefault(pPort);   

	BIT_CLEAR(pPort->ActorOperPortState,EXPIRED);
	pPort->PortMoved = FALSE;

	RcvStateMachinePortDisabled(pPort,(HsmRCB *)0);

	return;
}

/********************************************************************
*f*
*
* Name : RcvStateMachinePortDisabled 
*
* Description : This function implements PORT_DISABLED state of Receive
*				machine state.
* Parameters :
*				pPort	Pointer to the per port data structure.
*				Rcb		Pointer to the HsmRCB structure
*
* Return Value : None
*
* Called By : RcvStateMachineInit
*
* Lock : This function is called with the portLock held.
*
*f*
*********************************************************************/

void
RcvStateMachinePortDisabled(lacpPort_t *pPort,HsmRCB *Rcb)
{
	pPort->ReceiveMachineState = RECV_PORT_DISABLED;

	BIT_CLEAR(pPort->PartnerOperPortState,SYNCHRONIZATION);
	if(pPort->PortEnabled)
	{
		if(pPort->ControlVars.LACPEnabled)
		    RcvStateMachineExpired(pPort,(HsmRCB *)0);
		else
			RcvStateMachineLacpDisabled(pPort,(HsmRCB *)0);
	}
	return;
}


/********************************************************************
*f*
*
* Name : RcvStateMachineExpired
*
* Description : This function implemets the EXPIRED state of Receive 
*				 machine state. 
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*				Rcb		Pointer to the HsmRCB structure
*
* Return Value : None
*
* Called By : RcvStateMachinePortDisabled
*
* Lock : This function is called with the portLock held.
*
*f*
*********************************************************************/

void
RcvStateMachineExpired(lacpPort_t *pPort,HsmRCB *Rcb)
{
	pPort->ReceiveMachineState = RECV_EXPIRED;

	BIT_CLEAR(pPort->PartnerOperPortState,SYNCHRONIZATION);
	BIT_SET(pPort->PartnerOperPortState,LACP_TIMEOUT);  
	BIT_SET(pPort->ActorOperPortState,EXPIRED);

	pPort->CurrentWhileTimerID = ODMTimeout(CurrentWhileTimer,pPort,SHORT_TIMEOUT_TIME,nFlags);
	if (pPort->CurrentWhileTimerID == 0)
		ODMError("RcvStateMachineExpired : Not able to schedule CurrentWhileTimer");
	
	return;
}



/********************************************************************
*f*
*
* Name : RcvStateMachineLacpDisabled
*
* Description : This function implemets the LACP_DISABLED state of Receive 
*				 machine state. 
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*				Rcb		Pointer to the HsmRCB structure
*
* Return Value : None
*
* Called By : RcvStateMachinePortDisabled
*
* Lock : This function is called with the portLock held.
*
*f*
*********************************************************************/

void
RcvStateMachineLacpDisabled(lacpPort_t *pPort,  HsmRCB *Rcb)
{
	pPort->ReceiveMachineState = RECV_LACP_DISABLED;

	pPort->ControlVars.Selected = UNSELECTED;
	LacpRecordDefault(pPort); 
	BIT_CLEAR(pPort->PartnerOperPortState,AGGREGATION);
	BIT_CLEAR(pPort->ActorOperPortState,EXPIRED);

	return;
}


/********************************************************************
*f*
*
* Name : RcvStateMachineCurrent
*
* Description : This function implemets the CURRENT state of Receive 
*				 machine state. 
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*				Rcb		Pointer to the HsmRCB structure
*
* Return Value : None
*
* Called By : LacpStateMachine 
*
* Lock : This function is called with the portLock held.
*
*f*
*********************************************************************/

void
RcvStateMachineCurrent (lacpPort_t *pPort,  HsmRCB *Rcb)
{
	
	unsigned long CurrentWhileTimeInticks;

	/* Get the pointer to the LACPDU received */
	lacpdu_t *pLacpdu = (lacpdu_t *)Rcb->pDataBuf;

	pPort->ReceiveMachineState = RECV_CURRENT;
	/* Stop the timer, if current while timer is running. */
	if(pPort->CurrentWhileTimerID)
	{
		ODMUntimeout(pPort->CurrentWhileTimerID,pPort);
		pPort->CurrentWhileTimerID = 0;
	}

	LacpUpdateSelected(pPort,Rcb);
	LacpUpdateNTT(pPort,Rcb);
	LacpRecordPDU(pPort,Rcb);

	BIT_CLEAR(pPort->ActorOperPortState,EXPIRED);

	if(pLacpdu->PartnerPort != pPort->ActorPortNumber)
	{
		/* This means that a LACPDU meant for some other port has 
		 * been received by this port.  So send a PORT_MOVED Event
		 * to the RX state machine of that port if it is on the 
		 * same system 
		 */

		if(pLacpdu->PartnerSystem == pPort->ActorPortSystem) 
			ODMPostEvent(pPort,EV_PORT_MOVED,0);
	}
   	
	if(pPort->ActorOperPortState & LACP_TIMEOUT)
	{
		CurrentWhileTimeInticks = SHORT_TIMEOUT_TIME;
	}
	else
	{
		CurrentWhileTimeInticks = LONG_TIMEOUT_TIME;
	}

	pPort->CurrentWhileTimerID =ODMTimeout(CurrentWhileTimer,pPort,CurrentWhileTimeInticks,nFlags);

	if(pPort->CurrentWhileTimerID == 0)
		ODMError("RcvStateMachineCurrent : Not able to schedule CurrentWhileTimer");

	return;
}


/********************************************************************
*f*
*
* Name : RcvStateMachineDefaulted
*
* Description : This function implemets the DEFAULTED state of Receive 
*				 machine state. 
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*				Rcb		Pointer to the HsmRCB structure
*
* Return Value : None
*
* Called By : LacpStateMachine 
*
* Lock : This function is called with the portLock held.
*
*f*
*********************************************************************/

void
RcvStateMachineDefaulted(lacpPort_t *pPort,HsmRCB *Rcb)
{

	pPort->ReceiveMachineState = RECV_DEFAULTED;
	LacpUpdateDefaultSelected(pPort,Rcb);
	LacpRecordDefault(pPort);
	BIT_CLEAR(pPort->ActorOperPortState,EXPIRED);
	
	return;
}

/********************************************************************
*f*
*
* Name : InvalidEvent
*
* Description : InvalidEvent is do-nothing function used in Receive 
*				machine state. If called, indicates unhandled event 
*				occured.
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*				Rcb		Pointer to the HsmRCB structure
*
* Return Value : None.
*
* Called By : LacpStateMachine
*
* Lock : This function is called with the portLock held.
*
*f*
*********************************************************************/

void 
InvalidEvent(lacpPort_t *pPort, HsmRCB *Rcb)
{
	ODMError("InvalidEvent : unhandled event occured.");
	if(Rcb->pDataBuf == NULL) 
		Rcb->Status = FREE;

	return;
}


/********************************************************************
*f*
*
* Name : CurrentWhileTimer
*
* Description : This timer is used whether received protocol information
*				has expired. If ActorOperState.LACP_Timeout is set to 
*				Short Timeout, the timer is started with the value 
*				Short_Timeout_Time. Otherwise, it is started with the value 
*				Long_Timeout_Time
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*
* Return Value : None
*
* Called By : Scheduled by RcvStateMachineExpired and 
*			  RcvStateMachineCurrent 	
*
* Lock : The function holds port lock.
*
*f*
*********************************************************************/

void 
CurrentWhileTimer(lacpPort_t *pPort)
{
	PRIV_LEVEL CurrLevel;

	if(pPort->ReceiveMachineState == RECV_EXPIRED || pPort->ReceiveMachineState == RECV_CURRENT)
    {
		LacpStateMachine(pPort,EV_CURRENT_WHILE_TIMER_EXPIRED,0);
	}

	CurrLevel = ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
	pPort->CurrentWhileTimerID= 0;
	ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel);

	return;
}


/********************************************************************
*f*
*
* Name : LacpRecordPDU
*
* Description : The function records the parameter values for the Actor 
*				carried in a LACPDU as the current Partner operational 
*				parameter values with the exception of Synchronization
*				and sets ActorOperPortState.Defaulted = FALSE.	
*					The function also updates the value of the 
*				PartnerPortState.Synchronization using the parameter values 
*				carried in receiced LACPDU.	
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*				Rcb		Pointer to HsmRCB
*
* Return Value : None
*
* Called By : RcvStateMachineCurrent
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void   
LacpRecordPDU(lacpPort_t *pPort, HsmRCB *Rcb)
{
 
	lacpdu_t *pLacpdu = (lacpdu_t *)Rcb->pDataBuf;

	/* Copy the following Actor information carried in the 
	 * Received_LACPDU as the current operational values in 
	 * the pPort structure for the partner: ActorPortNumber,
	 * ActorPortpriority, ActorPortSystem, ActorSystemPriority,
	 * ActorOperPortKey and ActorOperPortState.
	 */

	pPort->PartnerOperPortNumber = pLacpdu->ActorPort;
	pPort->PartnerOperPortPriority = pLacpdu->ActorPortPriority;
	ODMCopy(pLacpdu->ActorSystem,pPort->PartnerOperSystem,sizeof(ActorSystem)); 
	pPort->PartnerOperSystemPriority = pLacpdu->ActorSystemPriority;
	pPort->PartnerOperKey = pLacpdu->ActorKey;
	pPort->PartnerOperPortState = pLacpdu->ActorState;

	BIT_CLEAR(pPort->ActorOperPortState,DEFAULTED);

	/* Update the PartnerOperPortState.Synchronization 
	 */

	if(pLacpdu->PartnerPort == pPort->ActorPortNumber && 
		pLacpdu->PartnerPortPriority == pPort->ActorPortPriority &&
		ODMMemCmp(pLacpdu->PartnerSystem,pPort->ActorPortSystem,MAC_ADDR_LEN) &&
		pLacpdu->PartnerSystemPriority == pPort->ActorPortSystemPriority &&
		pLacpdu->PartnerKey == pPort->ActorOperPortKey &&
		((pLacpdu->PartnerState & AGGREGATION) == (pPort->ActorOperPortState & AGGREGATION)) &&
		((pLacpdu->ActorState & SYNCHRONIZATION) == TRUE))
	{
		BIT_SET(pPort->PartnerOperPortState,SYNCHRONIZATION);
	}
	else
		if(((pLacpdu->ActorState & AGGREGATION) == FALSE) &&
			((pLacpdu->ActorState & SYNCHRONIZATION) == TRUE))
		{
			BIT_SET(pPort->PartnerOperPortState,SYNCHRONIZATION);
		}
		else
			BIT_CLEAR(pPort->PartnerOperPortState,SYNCHRONIZATION);

	if( (pLacpdu->ActorState & LACP_ACTIVITY) == TRUE ||
		((pPort->ActorOperPortState & LACP_ACTIVITY) == TRUE &&
		  (pLacpdu->PartnerState & LACP_ACTIVITY) == TRUE))

		BIT_SET(pPort->ActorOperPortState,LACP_ACTIVITY);

	return;
}



/********************************************************************
*f*
*
* Name : LacpRecordDefault
*
* Description :This function records the default parameter values for
*				the Partner carried in the Partner  Admin parameters 
*				as the current Partner operational parameter values 
*				and sets ActorOperPortState.Defaulted to TRUE.
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*
* Return Value : None
*
* Called By : RcvStateMachineDefaulted, RcvStateMachineLacpdisabled
*			  and RcvStateMachineInit.
* 	
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void
LacpRecordDefault(lacpPort_t *pPort)
{
	pPort->PartnerOperPortNumber = pPort->PartnerAdminPortNumber;
	pPort->PartnerOperPortPriority = pPort->PartnerAdminPortPriority;
	ODMCopy(pPort->PartnerOperSystem,pPort->PartnerAdminSystem,sizeof(ActorSystem));
	pPort->PartnerOperSystemPriority = pPort->PartnerAdminSystemPriority;
	pPort->PartnerOperKey = pPort->PartnerAdminKey;
	pPort->PartnerOperPortState = pPort->PartnerAdminPortState;

	BIT_SET(pPort->ActorOperPortState,DEFAULTED);

	return;
}



/********************************************************************
*f*
*
* Name : LacpUpdateSelected
*
* Description : The function updates the value of the Selected variable,
*				using parameter values from a newly received LACPDU. 
*
* Parameters :
*				pPort	Pointer to the per port data structure.
*				Rcb		Pointer to the HsmRCB structure
*
* Return Value : None
*
* Called By : RcvStateMachineCurrent
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
LacpUpdateSelected(lacpPort_t *pPort, HsmRCB *Rcb)
{
	lacpdu_t *pLacpdu = (lacpdu_t *)Rcb->pDataBuf;

	if(pPort->ControlVars.Selected != SELECTED)
		return;
	if(!(pLacpdu->ActorPort == pPort->PartnerOperPortNumber && 
		pLacpdu->ActorPortPriority == pPort->PartnerOperPortPriority &&
		ODMMemCmp(pLacpdu->ActorSystem,pPort->PartnerOperSystem, MAC_ADDR_LEN) &&
		pLacpdu->ActorSystemPriority == pPort->PartnerOperSystemPriority &&
		pLacpdu->ActorKey == pPort->PartnerOperKey &&
		((pLacpdu->ActorState & AGGREGATION) == (pPort->PartnerOperPortState & AGGREGATION))) )
	{
		pPort->ControlVars.Selected = UNSELECTED;
	}

	return;
}


/********************************************************************
*f*
*
* Name : LacpUpdateDefaultSelected
*
* Description : The function updates the value of the Selected variable,
*				using the Partner administrative parameter values. 
*
* Parameters :
*				pPort 	The per port structure 
*
* Return Value : None
*
* Called By : RcvStateMachineDefaulted
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
LacpUpdateDefaultSelected(lacpPort_t *pPort,HsmRCB *Rcb)
{
	if(pPort->ControlVars.Selected != SELECTED)
		return;

	if(!(pPort->PartnerAdminPortNumber == pPort->PartnerOperPortNumber && 
		pPort->PartnerAdminPortPriority == pPort->PartnerOperPortPriority &&
		ODMMemCmp(pPort->PartnerAdminSystem,pPort->PartnerOperSystem, MAC_ADDR_LEN) &&
		pPort->PartnerAdminSystemPriority == pPort->PartnerOperSystemPriority &&
		pPort->PartnerAdminKey == pPort->PartnerOperKey &&
		((pPort->PartnerAdminPortState & AGGREGATION) == (pPort->PartnerOperPortState & AGGREGATION))) )
	{
		pPort->ControlVars.Selected = UNSELECTED;
	}
	return;
}


/********************************************************************
*f*
*
* Name : LacpUpdateNTT
*
* Description : The function updates the values of the NTT variable
*				using the parameter values from a newly received LACPDU.	
*
* Parameters :
*				pPort 	Pointer to port structure 
*				Rcb		Pointer to the HsmRCB structure
*
* Return Value : None
*
* Called By : RcvStateMachineCurrent
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
LacpUpdateNTT(lacpPort_t *pPort, HsmRCB *Rcb)
{
	lacpdu_t *pLacpdu =(lacpdu_t *) Rcb->pDataBuf;

	if(!(pLacpdu->PartnerPort == pPort->ActorPortNumber && 
		pLacpdu->PartnerPortPriority == pPort->ActorPortPriority &&
		ODMMemCmp(pLacpdu->PartnerSystem,pPort->ActorPortSystem, MAC_ADDR_LEN) &&
		pLacpdu->PartnerSystemPriority == pPort->ActorPortSystemPriority &&
		pLacpdu->PartnerKey == pPort->ActorOperPortKey &&
		((pLacpdu->PartnerState & LACP_ACTIVITY) == (pPort->ActorOperPortState & LACP_ACTIVITY)) &&
		((pLacpdu->PartnerState & LACP_TIMEOUT) == (pPort->ActorOperPortState & LACP_TIMEOUT)) &&
		((pLacpdu->PartnerState & SYNCHRONIZATION) == (pPort->ActorOperPortState & SYNCHRONIZATION)) &&
		((pLacpdu->PartnerState & AGGREGATION) == (pPort->ActorOperPortState & AGGREGATION))) )
	{
		pPort->NTT = TRUE ;
	}

	return;
}


/********************************************************************
*f*
*
* Name : LacpMuxMachineState
*
* Description : The Function implemets the transitions among different 
*				Mux Machine states like DETACHED, WAITING, ATTACHED,
*				COLLECTING, and DISTRIBUTING.
*
* Parameters :
*				pPort 	Pointer to port structure 
*
* Return Value : None
*
* Called By : LacpStateMachine	
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void
LacpMuxMachineState(lacpPort_t  *pPort)
{
	if (pPort->ControlVars.BEGIN)
	{
		pPort->ControlVars.PortSelState = DETACH;
		MuxDetached(pPort);
	}

	while ( TRUE ) 
	{
		switch (pPort->MuxMachineState) 
		{
			case  MUX_DETACHED : 
				if(pPort->ControlVars.Selected == SELECTED || 
					pPort->ControlVars.Selected == STANDBY)
				{			
    				MuxWaiting(pPort);
					break;
    			}
				else 
					return;		

			case  MUX_WAITING : 
				if(pPort->ControlVars.Selected == UNSELECTED) 
				{
					MuxDetached(pPort);
					break;
        		}
        		else
					if(pPort->ControlVars.Selected == SELECTED && 
						pPort->ControlVars.Ready == TRUE)
					{
	        			MuxAttached(pPort);
						break;			
					}
					else 
						return;
			
			case  MUX_ATTACHED :	
				if(pPort->ControlVars.Selected == UNSELECTED || 
					pPort->ControlVars.Selected == STANDBY) 
				{
        				MuxDetached(pPort);	
						break;
    			}
				else 
					if(pPort->ControlVars.Selected == SELECTED && 
						(pPort->PartnerOperPortState & SYNCHRONIZATION))
					{
						MuxCollecting(pPort);
						break;
					}
					else 
						return;

			case	MUX_COLLECTING :
				if(pPort->ControlVars.Selected == UNSELECTED || 
					pPort->ControlVars.Selected == STANDBY || 
					(!(pPort->PartnerOperPortState & SYNCHRONIZATION)) )
				{
        				MuxAttached(pPort);
        				break;
    			}
    			else 
					if(pPort->ControlVars.Selected == SELECTED && 
						(pPort->PartnerOperPortState & SYNCHRONIZATION) && 
						(pPort-> PartnerOperPortState & COLLECTING))
					{
						MuxDistributing(pPort);
						break;
					}
					else
						return;

			case  MUX_DISTRIBUTING :
				if ((pPort->ControlVars.Selected == UNSELECTED) ||
        			(pPort->ControlVars.Selected == STANDBY) ||
					(!(pPort->PartnerOperPortState & SYNCHRONIZATION)) ||
					(!(pPort->PartnerOperPortState & COLLECTING))) 
				{	
					MuxCollecting(pPort);
					break;
    			}
				else
					return;

			default	 :
				break;
		}	/* End of Switch */
     } /* End of While */
}


/********************************************************************
*f*
*
* Name : MuxDetached
*
* Description : The function implements the DETACHED state of Mux machine
*				State.
*
* Parameters :
*				pPort	The Port structure
*
* Return Value : None
*
* Called By : MuxMachineState
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void
MuxDetached(lacpPort_t  *pPort)  
{

	lacpAggr_t *aggpAggr;
	lacpPort_t *aggpPort;
	AdapterContext *pAdapterContext;
	unsigned int indx,i,j,k;
	void *tmptid;

	if(pPort->ControlVars.PortSelState == ATTACH)
    { 
		/* Need to detach this Port from the Aggregator */

		/* Get the Aggregator for this Port */
		aggpAggr = pPort->LACPAggrp;

		/* Get adapterContext of pPort */
		pAdapterContext = AdapterArray[pPort->ActorPortNumber];

		/* Get Aggregator port structure in aggrpPort */
        aggpPort = LACPPortp[aggpAggr->AggregatorIdentifier];

		/* Remove this Port from the Link Aggregation group */
		if(aggpAggr) 
    	{
			ODMAcquireLock(aggpAggr->AggrLock,nFlags,nPrivLevel);
			for(indx=0; indx < aggpAggr->NumPorts; indx++)
    		{

				if(aggpAggr->LAGPorts[indx] == pPort->ActorPortNumber)
        		{
					aggpAggr->NumPorts--;
		
       				for(i=indx;i<aggpAggr->NumPorts; i++)
                   		aggpAggr->LAGPorts[i] = aggpAggr->LAGPorts[i+1];

					if(pPort->AggregatorPort)
						for(indx=0; indx < NUM_OF_MAC_ADDRESS_CLASSES; indx++)
                   			aggpAggr->PortForMAC[indx] = MAX_PORTS;        
			
		   			break;
		     	} /* End of if   */
		 	} /* End of for */

			ODMReleaseLock(aggpAggr->AggrLock,nFlags,0);
			
       	} /* end of if(aggpAggr) */

		if(pPort->AggregatorPort != TRUE){
			
			/* Disable all the multicast addresses and 
			 * Reset the MAC address back to the factory_addr.
			 * Reload the NULL list to remove all  multicast 
			 * addresses 
			 */
			pAdapterContext->FuncStruct.HsmMulticastAdd(pAdapterContext,(MultiList *)NULL,TRUE);
			pAdapterContext->FuncStruct.HsmSetMacAddress(pAdapterContext,(UCHAR *)pAdapterContext->PermMacAddr);
			pPort->LACPAggrp = (lacpAggr_t *)NULL;
		}
        
		pPort->ControlVars.Selected = UNSELECTED;
		pPort->ControlVars.PortSelState = DETACH;
		
		/* Check if this happens to be the last one to detach. 
		 * If so unschedule Reshuffle timer routine.... 
		 */

		if(!aggpAggr->NumPorts) 
			if(aggpAggr->ReshuffleTimerID)
            {
				tmptid = aggpAggr->ReshuffleTimerID;
				ODMAcquireLock(aggpAggr->AggrLock,nFlags,nPrivLevel);
				aggpAggr->ReshuffleTimerID = 0;
				ODMReleaseLock(aggpAggr->AggrLock,nFlags,0);
				ODMUntimeout(tmptid,pPort);
				/* Check if timer is signalled, if so do the untimeout again 
				 * as AggrReshuffle schedule itself 
				 */ 
				if(aggpAggr->ReshuffleTimerID && aggpAggr->ReshuffleTimerID != tmptid)
					ODMUntimeout(aggpAggr->ReshuffleTimerID,pPort);
			}
		
		/* Send Event to Ports Which are in STANDBY state So that 
		 * reevaluation of selection for that port is happened again 
		 */

		ODMAcquireLock(aggpAggr->AggrLock,nFlags,nPrivLevel);
		for(i=0;i<aggpAggr->NumberOfAggregatablePorts; i++)
			if (aggpAggr->AggregatablePorts[i]->ControlVars.Selected == STANDBY)
			{
				/* Remove pPort entry from AggregatablePorts */
				for(j=0;j<aggpAggr->NumberOfAggregatablePorts;j++)
				{
					if(aggpAggr->AggregatablePorts[j] == pPort)
						break;
				}
				if(!aggpAggr->AggregatablePorts[j])
					for(k=j;k<aggpAggr->NumberOfAggregatablePorts-1;k++)
						aggpAggr->AggregatablePorts[k] = aggpAggr->AggregatablePorts[k+1];
				--aggpAggr->NumberOfAggregatablePorts;
				ODMPostEvent(aggpAggr->AggregatablePorts[i], EV_SELECTED_FALSE,NULL);		
			}
		ODMReleaseLock(aggpAggr->AggrLock,nFlags,0);
			
    } /* End of Detaching  */

	BIT_CLEAR(pPort->ActorOperPortState, SYNCHRONIZATION);
	
	BIT_CLEAR(pPort->ActorOperPortState, DISTRIBUTING) ;

	BIT_CLEAR(pPort->ActorOperPortState, COLLECTING) ;

	pPort->NTT = TRUE;

	/* No need to wait for Periodic Machine to send LACPDU */
	LacpTransmitMachine(pPort);

    /* Find all the ports with same Selection parameters */
	if (pPort->ControlVars.Selected == UNSELECTED)
		SelectionLogic(pPort);
	pPort-> MuxMachineState = MUX_DETACHED;
}

/********************************************************************
*f*
*
* Name : MuxWaiting 
*
* Description : The function implements the DETACHED state of Mux machine
*				State.
*
* Parameters :
*			pPort	Pointer to Port structure.
*
* Return Value : None
*
* Called By : MuxMachineState
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
MuxWaiting(lacpPort_t *pPort)
{
	if ((pPort->ControlVars.Selected == SELECTED))
	{
		if(pPort->ControlVars.ReadyN == FALSE && 
			pPort->WaitWhileTimerID == 0)        		
		{
            /* Start the wait while timer and return, just to 
			 * allow things to settle down. After this timer 
			 * expires, the timer function will make ReadyN as 
			 * TRUE.
			 */

			pPort->WaitWhileTimerID = ODMTimeout(LacpWaitWhileTimer,pPort,WAIT_WHILE_TIME,nFlags);
			pPort->MuxMachineState = MUX_WAITING;
        }
	}
	else 
		if (pPort->ControlVars.Selected == STANDBY) /* Link status is STANDBY */
			pPort->MuxMachineState = MUX_WAITING;

	return;
}

/********************************************************************
*f*
*
* Name : LacpWaitWhileTimer 
*
* Description : This timer provides hysteresis before performing 
*				an aggregation change, to allow all links that will 
*				join this aggregation to do so. It is started with 
*				Aggregate_wait_Time
*			
*
* Parameters :
*			arg		Pointer to Port structure.
*
* Return Value : None
*
* Called By : Scheduled by MuxDetached
*
* Lock : This function holds port lock.
*
*f*
*********************************************************************/


void 
LacpWaitWhileTimer( void *arg )
{
	int *ptrPort = (int *)arg;
	int nPort = *ptrPort;
	lacpPort_t *pPort,*TmppPort;
	lacpAggr_t *pAggr;
	unsigned int ID;

	
	pPort = LACPPortp[nPort];
	if(pPort)
    {
    	pAggr = pPort->LACPAggrp;
		ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
		if(pPort->ControlVars.Selected == SELECTED)
        {
	   		pPort->ControlVars.ReadyN = TRUE;
            /* Check the 'ReadyN' state of other ports */
        	for(ID=0;ID<pAggr->NumberOfAggregatablePorts;ID++) 
			{
				TmppPort = pAggr->AggregatablePorts[ID];
				if(TmppPort->ControlVars.ReadyN != TRUE)
				{
					ODMReleaseLock(pPort->PortLock,nFlags,0);
					ODMDelay(aggr_wait_ticks);
					ODMAcquireLock(pPort->PortLock, nFlags,nPrivLevel);
				}
           	}  
		
			/* We assume all the possible ports have 'ReadyN' as TRUE */
			pPort->ControlVars.Ready = TRUE;
			LacpMuxMachineState(pPort);
		}
		pPort->WaitWhileTimerID = 0;
		ODMReleaseLock(pPort->PortLock,nFlags,0);
	}

	return; 
}

/********************************************************************
*f*
*
* Name : MuxAttached 
*
* Description : The function implements the ATTACHED state of Mux machine
*				State.
*
* Parameters :
*			pPort	Pointer to Port structure.
*
* Return Value : None
*
* Called By : MuxMachineState
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void
MuxAttached(lacpPort_t *pPort)
{
	lacpAggr_t *aggpAggr;
	lacpPort_t *aggpPort;
	AdapterContext *pAdapterContext,*pAggregatorAdapterContext;
	MultiList Multi;
	int indx,i,j;
	if(pPort->ControlVars.PortSelState == DETACH)
	{
   		aggpAggr = pPort->LACPAggrp;

		/*Aggregator's lacpPort_t pointer */
		aggpPort = LACPPortp[aggpAggr->AggregatorIdentifier];

		/* Get AdapterContext of pPort */
		pAdapterContext = AdapterArray[pPort->ActorPortNumber];

		/* Get Adapter Context of Aggregator port */
		pAggregatorAdapterContext = AdapterArray[aggpPort->ActorPortNumber];
	
		ODMAcquireLock(aggpAggr->AggrLock,nFlags,nPrivLevel);
		if(pPort->AggregatorPort == FALSE)
		{
		
			/* Set the aggregators MAC address to this port.
			 * All the multicast addresses enabled in the aggregator
			 * port should be enabled in this port. 
			 */

			pAdapterContext->FuncStruct.HsmSetMacAddress(pAdapterContext,(UCHAR *)pAggregatorAdapterContext->CurrMacAddr);

			Multi.Next = NULL;
			for (i=0; i< 128; i++)
			{
				for (j=0; j < 16; j++)
				{
					if (pAggregatorAdapterContext->mca_tbl[i][j]) {
						ODMCopy((pAggregatorAdapterContext->mca_tbl[i][j])->MulticastAddr, Multi.MulticastAddr, MAC_ADDR_LEN);
						pAdapterContext->FuncStruct.HsmMulticastAdd(pAdapterContext, &Multi, FALSE);
					} 
				}
			}
		}
		if(!aggpAggr->NumPorts)
		{
			for(indx=0; indx < NUM_OF_MAC_ADDRESS_CLASSES; indx++)
          		aggpAggr->PortForMAC[indx] = MAX_PORTS;

			/* Start the reshuffle tiemout for this Aggregator */
			if(!aggpAggr->ReshuffleTimerID)
			{
				aggpAggr->ReshuffleTimerID = ODMTimeout(AggrReshuffle,aggpAggr,RESHUFFLE_TIMEOUT,AGGR_RESHUFFLE_TIMER);

				if(aggpAggr->ReshuffleTimerID == 0)
					ODMError("MuxAttached : Not able to start AggrReshuffle");

			}
		}

		aggpAggr->LAGPorts[aggpAggr->NumPorts++] = pPort->ActorPortNumber;
		pPort->ControlVars.PortSelState = ATTACH; 
		ODMReleaseLock(aggpAggr->AggrLock,nFlags,0);
	}
	
	BIT_SET(pPort->ActorOperPortState, SYNCHRONIZATION);
	BIT_CLEAR(pPort->ActorOperPortState, COLLECTING) ;
	pPort->NTT = TRUE;
	LacpTransmitMachine(pPort);
	pPort->MuxMachineState = MUX_ATTACHED;	

	return;

}

/********************************************************************
*f*
*
* Name : MuxCollecting 
*
* Description : The function implements the COLLECTING state of Mux machine
*				State.
*
* Parameters :
*			pPort	Pointer to Port structure.
*
* Return Value : None
*
* Called By : MuxMachineState
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void
MuxCollecting(lacpPort_t *pPort)
{
	int ret,val,indx;
	lacpAggr_t *aggpAggr;

	aggpAggr = pPort->LACPAggrp;

	/* If MuxCollecting is called from Distributing state then 
	 * send marker as the port is being shifted.
	 */
	if(pPort->ActorOperPortState & DISTRIBUTING)
	{
		/* Remove this port from the PortForMAC array also, 
		 * so that this port is no longer used for transmission.
		 */
		
		ret = SendMarker(pPort->ActorPortNumber,(short)SHIFT_PORT);	
		val = (ret == SUCCESS) ? (pPort->ActorPortNumber + 1) : 0;

		for(indx=0; indx < NUM_OF_MAC_ADDRESS_CLASSES; indx++)
		{
			if(aggpAggr->PortForMAC[indx] == pPort->ActorPortNumber)
				aggpAggr->PortForMAC[indx] = MAX_PORTS + val;
		}
	}
	BIT_SET(pPort->ActorOperPortState, COLLECTING) ;
	BIT_CLEAR(pPort->ActorOperPortState, DISTRIBUTING) ;

	pPort->NTT = TRUE;

	LacpTransmitMachine(pPort);
	pPort->MuxMachineState = COLLECTING;

	return;
}

/********************************************************************
*f*
*
* Name : MuxDistributing 
*
* Description : The function implements the DISTRIBUTING state of Mux 
*				machine	State.
*
* Parameters :
*			pPort	Pointer to Port structure.
*
* Return Value : None
*
* Called By : MuxMachineState
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
MuxDistributing (lacpPort_t *pPort)
{
	/*  Get load per port fom OS */
	pPort->LoadPerPort = ODMGetLoadPerPort(AdapterArray[pPort->ActorPortNumber]); 
	BIT_SET(pPort->ActorOperPortState, DISTRIBUTING) ;
	pPort->MuxMachineState = DISTRIBUTING;

	return;
}
/********************************************************************
*f*
*
* Name : SelectionLogic 
*
* Description : The Selection logic selects a compatible Aggregator for a port, 
*				using the port's LAG ID. The selection logic may determine that
*				the link should be operated as a standby link if there are 
*				constraints on the simultaneous attachment of ports that have 
*				selected the same Aggregator.
*
* Parameters :
*			pPort	Pointer to Port structure.
*
* Return Value : None
*
* Called By : MuxMachineState
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void
SelectionLogic(lacpPort_t *pPort)
{

	unsigned int i;
	
	USHORT SelPorts,SelectedPorts[MAX_PORTS];
	lacpPort_t *pTempPort;
	lacpAggr_t *pAggr,**pAggrPtr;
	AdapterContext *pAdapterContext,*pAggregatorContext;

	pAggr = pPort->LACPAggrp;
	pAdapterContext = AdapterArray[pPort->ActorPortNumber];
	/* For Aggreagtor Port  */
	if(pPort->AggregatorPort)
	{
		if(pPort->LACPAggrp->IndividualPort == TRUE)
		{
			/* Detach all the ports being attached. */
			for(i=0;i<pAggr->NumPorts;i++)
			{
				if(pPort->AggregatorPort == TRUE)
					continue;
				pTempPort = LACPPortp[pAggr->LAGPorts[i]];
				ODMAcquireLock(GlobalLock,nFlags,nPrivLevel);
				ODMPostEvent(pTempPort, EV_SELECTED_FALSE,0);	
				ODMReleaseLock(GlobalLock,nFlags,0);	
			}
		}

		ODMAcquireLock(pAggr->AggrLock, nFlags, nPrivLevel);
		
		if(ODMMemCmp(pPort->PartnerOperSystem,pAggr->PartnerSystem, MAC_ADDR_LEN) && 
			pPort->PartnerOperKey == pAggr->PartnerAggregatorKey &&
			pAggr->MediaSpeed == pAdapterContext->MediaSpeed &&
			pAdapterContext->DuplexMode == FULL_DUPLEX) 
		{
			/* Attach Aggregator Port to the aggregator. */
			pPort->ControlVars.Selected = SELECTED;
			pAggr->AggregatorIdentifier = pPort->ActorPortNumber;
			/*pPort->LACPAggrp = pAggr; // Assigned in LACP Config */
			pAdapterContext->pAggregatorContext = pAdapterContext;
		}
		else
		{
			/*If aggregator port has not attached to the aggregator. */
			if(pAggr->PartnerSystemPriority  == 0)
			{
				/* No port has attached to the aggregator. 
				 * Copy the Aggregator port's partner values to the 
				 * aggregator's partner values  
				 */
				ODMCopy(pAggr->PartnerSystem,pPort->PartnerOperSystem,sizeof(ActorSystem));
				pAggr->PartnerSystemPriority = pPort->PartnerOperSystemPriority;
				pAggr->PartnerAggregatorKey = pPort->PartnerOperKey;

				/* Copy the Physical Capabilities to the Aggregator 
				 * Structure.
				 */
				pAggr->MediaSpeed = pAdapterContext->MediaSpeed;
			

				/* Attach the aggregator port to the Aggregator. */
				pAggr->AggregatorIdentifier = pPort->ActorPortNumber;
				pPort->ControlVars.Selected = SELECTED;
				/*pPort->LACPAggrp = pAggr; // Assigned in LACPConfig */
				pAdapterContext->pAggregatorContext = pAdapterContext;
			}
			else
			{
				/* Some ports have attached to this aggregator. 
				 * So overwrite aggregator port's partner values. 
				 */
				ODMCopy(pAggr->PartnerSystem,pPort->PartnerOperSystem,sizeof(ActorSystem));
				pAggr->PartnerSystemPriority = pPort->PartnerOperSystemPriority;
				pAggr->PartnerAggregatorKey = pPort->PartnerOperKey;
				pAggr->AggregatorIdentifier = pPort->ActorPortNumber;
				
				/* Copy the Physical Capabilities to the Aggregator 
				 * Structure.
				 */
				pAggr->MediaSpeed = pAdapterContext->MediaSpeed;

				/* Detach all the ports being attached. */
				for(i=0;i<pAggr->NumPorts;i++)
				{
					if(pPort->AggregatorPort == TRUE)
						continue;
					pTempPort = LACPPortp[pAggr->LAGPorts[i]];
					ODMAcquireLock(GlobalLock,nFlags,nPrivLevel);
					ODMPostEvent(pTempPort, EV_SELECTED_FALSE,0);	
					ODMReleaseLock(GlobalLock,nFlags,0);	
				}
				/* Attach Aggregator Port to the aggregator. */
				pPort->ControlVars.Selected = SELECTED;
				/* pPort->LACPAggrp =pAggr; // Assigned in LACPConfig */
				pAdapterContext->pAggregatorContext = pAdapterContext;
			}
		}
		ODMReleaseLock(pAggr->AggrLock,nFlags,0);
		return;
	}

	/*  For non aggregator ports,go through Aggregator's list 
	 *  to find the aggregator 
	 */

	/* pAggrPtr is double pointer pointing to LACPAggrp 
	 * arrray of pointers to Aggr structure. 
	 */
	pAggrPtr = LACPAggrp;
	while(pAggr != NULL)
	{
		if(pAggr->IndividualPort = TRUE)
		{
			pAggrPtr++; 
			pAggr = *pAggrPtr; 
			continue;
		}
		ODMAcquireLock(pAggr->AggrLock, nFlags, nPrivLevel);
		ODMAcquireLock(GlobalLock, nFlags, nPrivLevel);
		if(pPort->ActorOperPortKey == pAggr->ActorAggregatorOperKey && 
			pAggr->PartnerSystemPriority  == 0)
		{
			/* Copy the partner operational values of port to 
			 * Aggregator structure.
			 */
			ODMCopy(pAggr->PartnerSystem,pPort->PartnerOperSystem,sizeof(ActorSystem));
			pAggr->PartnerSystemPriority = pPort->PartnerOperSystemPriority;
			pAggr->PartnerAggregatorKey = pPort->PartnerOperKey;

			/* Copy the Physical Capabilities of the port to the 
			 * Aggregator Structure.
			 */

			pPort->ControlVars.Selected = SELECTED;
			pPort->LACPAggrp =pAggr;
			pAggregatorContext = AdapterArray[pAggr->AggregatorIdentifier];
			pAdapterContext->pAggregatorContext = pAggregatorContext;
			goto END_SUCCESS;

		}	

		if(pPort->ActorOperPortKey == pAggr->ActorAggregatorOperKey && 
			pPort->PartnerOperKey == pAggr->PartnerAggregatorKey && 
			ODMMemCmp(pPort->PartnerOperSystem,pAggr->PartnerSystem, MAC_ADDR_LEN) &&
			pAggr->MediaSpeed == pAdapterContext->MediaSpeed &&
			pAdapterContext->DuplexMode == FULL_DUPLEX)
		{

			/*Aggregator is Found. */
			/*Find a list of ports attached to the found aggregator */
			SelPorts = 0;
			for(i=0;i<AdapterCount;i++)
			{
				pTempPort = LACPPortp[AdapterArray[i]->Port];
				if(!pTempPort || pTempPort == pPort)
					continue;
				if(pTempPort->LACPAggrp->IndividualPort == FALSE && 
					pTempPort->ActorOperPortKey == pPort->ActorOperPortKey && 
					pTempPort->PartnerOperKey == pPort->PartnerOperKey && 
					ODMMemCmp(pTempPort->ActorPortSystem,pPort->ActorPortSystem, MAC_ADDR_LEN) && 
					pTempPort->ActorPortSystemPriority == pPort->ActorPortSystemPriority &&
					ODMMemCmp(pTempPort->PartnerOperSystem,pPort->PartnerOperSystem, MAC_ADDR_LEN) && 
					pTempPort->PartnerOperSystemPriority == pPort->PartnerOperSystemPriority && 
					pTempPort->ControlVars.Selected == SELECTED && 
					AdapterArray[i]->MediaSpeed == pAdapterContext->MediaSpeed &&
					AdapterArray[i]->DuplexMode == FULL_DUPLEX)
					
				{
					SelectedPorts[SelPorts++] = pTempPort->ActorPortNumber;
						
				}
			}

			if(SelPorts < LACP_MAX_PER_GROUP)
			{	
				pPort->ControlVars.Selected = SELECTED;
				pPort->LACPAggrp =pAggr;
				pAggregatorContext = AdapterArray[pAggr->AggregatorIdentifier];
				pAdapterContext->pAggregatorContext = pAggregatorContext;
				goto END_SUCCESS;
			}
			
			/* There are sufficient no of ports attached to the aggregator. 
			 * So check for the priority to join by detaching lower 
			 * priority port 
			 *
			 * If Partner System Priority is greater than Actor System 
			 * Priority then  sort the Selected ports in ascending 
			 * order of PartnerOperPortPriority :Link Priority. 
			 */
			if(pPort->PartnerOperSystemPriority < pPort->ActorPortSystemPriority)
				LacpSortPorts(SelectedPorts,SelPorts);
			
			/* Find a Port from SelectedPorts list with the least priority
			 * (based on Link Priority) say pTempPort
			 *
			 * Least priority port will be the last one in the 
			 * selected port list.
			 */
			pTempPort = LACPPortp[SelectedPorts[SelPorts-1]];

			if(pPort->PartnerOperSystemPriority  < pPort->ActorPortSystemPriority)
			{
				/* Partner System Priority is greater  */
				if(pTempPort && 
					pPort->PartnerOperPortPriority < pTempPort->PartnerOperPortPriority)
				{
					ODMPostEvent(pTempPort,EV_SELECTED_FALSE,0);
								
					/* Select the aggregator. */
					pPort->LACPAggrp = pAggr;
					pPort->ControlVars.Selected = SELECTED;
					pAggregatorContext = AdapterArray[pAggr->AggregatorIdentifier];
					pAdapterContext->pAggregatorContext = pAggregatorContext;
					 
				}
				else
				{
					pPort->ControlVars.Selected = STANDBY;
					for(i=0;i<AdapterCount;i++)
					{
						if(pAggr->AggregatablePorts[i] != NULL)
							continue;
						pAggr->AggregatablePorts[i] = pPort;
						pAggr->NumberOfAggregatablePorts++;
						break;
					}
				}
			}
			else
			{
				/* Actor System Priority is greater. */
				if(pTempPort && 
					pPort->ActorPortPriority < pTempPort->ActorPortPriority)
				{
					ODMPostEvent(pTempPort,EV_SELECTED_FALSE,0);
					
					/* Select the aggregator. */
					pPort->LACPAggrp = pAggr;
					pPort->ControlVars.Selected = SELECTED;
					pPort->LACPAggrp =pAggr;
					pAggregatorContext = AdapterArray[pAggr->AggregatorIdentifier];
					pAdapterContext->pAggregatorContext = pAggregatorContext;
					
				}
				else
				{
					pPort->ControlVars.Selected = STANDBY;
					for(i=0;i<AdapterCount;i++)
					{
						if(pAggr->AggregatablePorts[i] != NULL)
							continue;
						pAggr->AggregatablePorts[i] = pPort;
						pAggr->NumberOfAggregatablePorts++;
						break;
					}
				}
			}
			goto END_SUCCESS;

		}
		pAggrPtr++;
		pAggr = *pAggrPtr;
		ODMReleaseLock(GlobalLock,nFlags,0);
		ODMReleaseLock(pAggr->AggrLock,nFlags,0);
	}
	/* pPort is unable to select an aggregator. */
	pPort->ControlVars.Selected = UNSELECTED;	
	return;

	END_SUCCESS:

	ODMReleaseLock(GlobalLock,nFlags,0);
	ODMReleaseLock(pAggr->AggrLock,nFlags,0);
	return;	
}


/********************************************************************
*f*
*
* Name : LacpSortPorts
*
* Description :	The function sorts the ports in ascending order of 	
*				value of PartnerOperPortPriority.
*
* Parameters :
*				Ports		List of ports. 
*				NumPorts	No of ports
*
* Return Value : void
*
* Called By : SelectionLogic
*
* Lock : The function is called with Port, Aggregator and Global
*		 lock being held. 	
*
*f*
*********************************************************************/

void 
LacpSortPorts(USHORT *Ports, USHORT NumPorts)
{
	
	lacpPort_t	*TmppPort1,*TmppPort2;
	USHORT nTmpPort,i,j;

	for(i=0;i<NumPorts;i++)
    {
    	TmppPort1 = LACPPortp[Ports[i]];
        for (j = i+1; j < NumPorts; j++)
        {
    		TmppPort2 = LACPPortp[Ports[j]];
            if(TmppPort2->PartnerOperPortPriority<TmppPort1->PartnerOperPortPriority)
            {
				/* Swap the ports */
                nTmpPort = Ports[i];
                Ports[i] = Ports[j];
                Ports[j] = nTmpPort;
            }
        }
    }

	return;
}

/********************************************************************
*f*
*
* Name : LacpTransmitMachine
*
* Description : The transmit machine creates a LACPDU for tranmission
*				with the operational values of the port.
*					Subject to the restriction that no more than 3
*				LACPDUs may be transmitted in any Fast_Periodic_Time 
*				interval, If NTT is set true when this limit is in force,
*				the tranmission is delayed until such a time as the 
*				restriction is no longer in force. 
*
* Parameters :
*				pPort		Pointer to Port structure.
*
* Return Value : None
*
* Called By : LacpStateMachine and other functions on NTT.
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void
LacpTransmitMachine(lacpPort_t *pPort)
{	
	ULONG PresentTimeInTicks,PrevTimeTicks,nTimeDiff,nWaitTimeTicks;
	lacpdu_t *pLacpdu;
	AddressStruct pAddrStruct;
	PktInfo	Pkt;
	AdapterContext *pAdapterContext;

	pAdapterContext = AdapterArray[pPort->ActorPortNumber];

	if(pPort->PortEnabled == FALSE)
	{
		pPort->NTT = FALSE;
		return;
	}

	PresentTimeInTicks = ODMGetPresentTimeInTicks();
	PrevTimeTicks = pPort->TicksWhenLastLACPDUSent;

	if(PresentTimeInTicks < PrevTimeTicks)
	{
		/* Overflow condition */
		nTimeDiff = fast_ticks;
	}
	else
	{
		nTimeDiff = PresentTimeInTicks - PrevTimeTicks;
	}

	if(nTimeDiff < fast_ticks)
	{
		if( pPort->PDUsAlreadySent < MAX_LACPDUS_SENT)
		{
			pPort->PDUsAlreadySent++;
		}
		else
		{
			/* cannot send more than MAX_LACPDUS_SENT in any 
			 * fast_periodic_time  so schedule the Transmit 
			 * Machine to send LACPDUs once the restriction 
			 * is removed if not scheduled. 
			 */

			if(pPort->TransmitTimerID)
			{
				/* The timer is already scheduled. Just return. */
				pPort->NTT = FALSE;
				return;
			}
			/* else schedule the timer */
			nWaitTimeTicks = fast_ticks - nTimeDiff; 
			pPort->TransmitTimerID = ODMTimeout(TransmitTimer,pPort,nWaitTimeTicks,nFlags);
			pPort->NTT = FALSE;
			return;
		}
	}
	else
	{
		/* FAST Periodic time has elapsed since the last 
		 * transmit request. 
		 */
		pPort->TicksWhenLastLACPDUSent = PresentTimeInTicks;
		pPort->PDUsAlreadySent = 1;
	}

	/*  Allocate memory for Pkt and get physical and 
	 *  virtual addresses
	 *
	 *  ODMMallocContiguous will return virtual and physical 
	 *  addresses of memory allocated.
	 */
	pAddrStruct.VirtAddr = NULL;
	pAddrStruct.PhysAddr = NULL;
	pAddrStruct.BufSize  = sizeof(lacpdu_t);
	pAddrStruct.pCookie  = NULL;

	ODMMallocContiguous(&pAddrStruct,0);
	if(pAddrStruct.PhysAddr == NULL)
	{
		/* Not able to send LACPDU.
		 * Nothing to worry ... 
		 * simply return SUCCESS
		 */
		return; 
	}
	Pkt.FragArray[0].pFrag = pAddrStruct.PhysAddr;
	Pkt.FragArray[0].FragLen = pAddrStruct.BufSize;
	Pkt.NumFrags = 1;
	/* Indicating its LACPDU Packet. */
	Pkt.SlowProtocolType = TRUE;
	/* Storing the virtual address in OSCtrlBlk 
	 * to free the LACPDU packet on TxComplete event 
	 */
	Pkt.pOSCtrlBlk = pAddrStruct.VirtAddr;

	/* Use Virtual address in pLacpdu for filling LACPDU
	 * details
	 */
	pLacpdu = (lacpdu_t *)pAddrStruct.VirtAddr;

	/* Fill in the lacpdu_t structure. */
	
	ODMCopy(SlowProtocolMulticast,pLacpdu->DestinationAddress,MAC_ADDR_LEN);
	ODMCopy(pAdapterContext->CurrMacAddr,pLacpdu->SourceAddress,MAC_ADDR_LEN);
	pLacpdu->LengthType = (USHORT)ODMhtons(SLOW_PROTOCOL_TYPE);
	pLacpdu->SubType = LACP_PDU_TYPE ;
	pLacpdu->VersionNumber = LACP_VERSION;
	/* Actor Information */
	pLacpdu->ActorTLVType = LACPDU_ACTOR_TLV_TYPE ;
    pLacpdu->ActorInformationLength = LACPDU_ACTOR_INFORMATION_LENGTH ;
    pLacpdu->ActorSystemPriority = pPort->ActorPortSystemPriority ;
    ODMCopy(pPort->ActorPortSystem,pLacpdu->ActorSystem,MAC_ADDR_LEN);
    pLacpdu->ActorKey = pPort->ActorOperPortKey ;
    pLacpdu->ActorState = pPort->ActorOperPortState ;
    pLacpdu->ActorPortPriority = pPort->ActorPortPriority;
    pLacpdu->ActorPort = pPort->ActorPortNumber;
 
	/* PArtner Information */
	pLacpdu->PartnerTLVType = LACPDU_PARTNER_TLV_TYPE ;
    pLacpdu->PartnerInformationLength = LACPDU_PARTNER_INFORMATION_LENGTH ;
    pLacpdu->PartnerSystemPriority = pPort->PartnerOperSystemPriority ;
    ODMCopy(pPort->PartnerOperSystem,pLacpdu->PartnerSystem,MAC_ADDR_LEN) ;
    pLacpdu->PartnerKey = pPort->PartnerOperKey ;
    pLacpdu->PartnerState = pPort->PartnerOperPortState ;
    pLacpdu->PartnerPortPriority = pPort->PartnerOperPortPriority ;
    pLacpdu->PartnerPort = pPort->PartnerOperPortNumber ;

	/* Collector Information */
    pLacpdu->CollectorTLVType = LACPDU_COLLECTOR_TLV_TYPE ;
    pLacpdu->CollectorInformationLength = LACPDU_COLLECTOR_INFORMATION_LENGTH;
    pLacpdu->CollectorMaxDelay = COLLECTOR_MAX_DELAY;

	/* Terminator Information */
    pLacpdu->TerminatorTLVType = LACPDU_TERMINATOR_TLV_TYPE ;
    pLacpdu->TerminatorLength = LACPDU_TERMINATOR_LENGTH ;

    /*  send the LACPDU with the port's adapter context. */
	if((pAdapterContext->FuncStruct.HsmSendPkt)(pAdapterContext,Pkt,0) == FAILURE) 
		pPort->PDUsAlreadySent--;
	pPort->NTT = FALSE;

	return;
}


/********************************************************************
*f*
*
* Name : TransmitTimer
*
* Description : The Timer will send LACPDU which is scheduled 
*				to delay the tranmission of LACPDU because of 
*				restriction of not more than 3 LACPDUs in sec.
*
*
* Parameters :
*				arg		Port index
*
* Return Value : None
*
* Called By : scheduled by LacpTranmitMachine
*
* Lock : The function holds the port lock.
*
*f*
*********************************************************************/

void 
TransmitTimer(void *arg)
{
	lacpPort_t *pPort = arg;
	AdapterContext *pAdapterContext;
	lacpdu_t *pLacpdu;
	AddressStruct pAddrStruct;
	PktInfo	Pkt;

	pAdapterContext = AdapterArray[pPort->ActorPortNumber];
	
	/*  Allocate memory for Pkt and get physical and 
	 *  virtual addresses
	 *
	 *  ODMMallocContiguous will return virtual and physical 
	 *  addresses of memory allocated.
	 */
	pAddrStruct.VirtAddr = NULL;
	pAddrStruct.PhysAddr = NULL;


	pAddrStruct.BufSize  = sizeof(lacpdu_t);
	pAddrStruct.pCookie  = NULL;

	ODMMallocContiguous(&pAddrStruct,0);


	if(pAddrStruct.PhysAddr == NULL)
	{
		/* Not able to send LACPDU.
		 * Nothing to worry ... 
		 * simply return SUCCESS
		 */
		return; 
	}
	Pkt.FragArray[0].pFrag = pAddrStruct.PhysAddr;
	Pkt.FragArray[0].FragLen = pAddrStruct.BufSize;
	Pkt.NumFrags = 1;
	/* Indicating its LACPDU Packet. */
	Pkt.SlowProtocolType = TRUE;
	/* Storing the virtual address in OSCtrlBlk 
	 * to free the LACPDU packet on TxComplete event 
	 */
	Pkt.pOSCtrlBlk = pAddrStruct.VirtAddr;

	/* Use Virtual address in pLacpdu for filling LACPDU
	 * details
	 */
	pLacpdu = (lacpdu_t *)pAddrStruct.VirtAddr;

	/* Fill in the lacpdu_t structure. */
	
	ODMCopy(SlowProtocolMulticast,pLacpdu->DestinationAddress,MAC_ADDR_LEN);
	ODMCopy(pAdapterContext->CurrMacAddr,pLacpdu->SourceAddress,MAC_ADDR_LEN);
	pLacpdu->LengthType = (USHORT)ODMhtons(SLOW_PROTOCOL_TYPE);
	pLacpdu->SubType = LACP_PDU_TYPE ;
	pLacpdu->VersionNumber = LACP_VERSION;
	/* Actro Information */
	pLacpdu->ActorTLVType = LACPDU_ACTOR_TLV_TYPE ;
    pLacpdu->ActorInformationLength = LACPDU_ACTOR_INFORMATION_LENGTH ;
    pLacpdu->ActorSystemPriority = pPort->ActorPortSystemPriority ;
    ODMCopy(pPort->ActorPortSystem,pLacpdu->ActorSystem,MAC_ADDR_LEN);
    pLacpdu->ActorKey = pPort->ActorOperPortKey ;
    pLacpdu->ActorState = pPort->ActorOperPortState ;
    pLacpdu->ActorPortPriority = pPort->ActorPortPriority;
    pLacpdu->ActorPort = pPort->ActorPortNumber;
 
	/* PArtner Information */
	pLacpdu->PartnerTLVType = LACPDU_PARTNER_TLV_TYPE ;
    pLacpdu->PartnerInformationLength = LACPDU_PARTNER_INFORMATION_LENGTH ;
    pLacpdu->PartnerSystemPriority = pPort->PartnerOperSystemPriority ;
    ODMCopy(pPort->PartnerOperSystem,pLacpdu->PartnerSystem,MAC_ADDR_LEN);
    pLacpdu->PartnerKey = pPort->PartnerOperKey ;
    pLacpdu->PartnerState = pPort->PartnerOperPortState ;
    pLacpdu->PartnerPortPriority = pPort->PartnerOperPortPriority ;
    pLacpdu->PartnerPort = pPort->PartnerOperPortNumber ;
	/* Collector Information */
    pLacpdu->CollectorTLVType = LACPDU_COLLECTOR_TLV_TYPE ;
    pLacpdu->CollectorInformationLength = LACPDU_COLLECTOR_INFORMATION_LENGTH;
    pLacpdu->CollectorMaxDelay = COLLECTOR_MAX_DELAY;

	/* Terminator Information */
    pLacpdu->TerminatorTLVType = LACPDU_TERMINATOR_TLV_TYPE ;
    pLacpdu->TerminatorLength = LACPDU_TERMINATOR_LENGTH ;

    /*  send the LACPDU with the port's adapter context. */
	if((pAdapterContext->FuncStruct.HsmSendPkt)(pAdapterContext,Pkt,0)); 
		
	ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
	pPort->PDUsAlreadySent = 1;
	pPort->TicksWhenLastLACPDUSent = ODMGetPresentTimeInTicks();
	pPort->TransmitTimerID  = 0;
	ODMReleaseLock(pPort->PortLock,nFlags,0);
	
	return;
}


/********************************************************************
*f*
*
* Name : LacpTxCompleted
*
* Description : Callback routine invoked by HsmTxComplete to indicate
*				Tx complete.
*
* Parameters :
*			pAdapter	Pointer to Adapter Context.
*			pTCBHead	Pointer to first Transmit Control Block
*			pTCBNext	Pointer to last Transmit Control Block
*
* Return Value : void
*
* Called By : HsmTxComplete
*
* Lock :
*
*f*
*********************************************************************/

void 
LacpTxCompleted( AdapterContext *pAdapter, HsmTCB *TCB)
{
	
	ODMFree(TCB->pOsCtrlBlk, LACP_PACKET_SIZE,0);
	TCB->SlowProtocolType = FALSE;
	return;
}


/********************************************************************
*f*
*
* Name : LacpPeriodicTransmissionMachine
*
* Description : This implemets the Periodic Tranmission Machine 
*				which determines whether the Actor and its Partner
*				will exchange LACPDUs periodically in order to 
*				maintain an aggregation.
*
* Parameters :
*				pPort		Pointer to Port structure.
*
* Return Value : None
*
* Called By : LacpStateMachine
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void
LacpPeriodicTransmissionMachine(lacpPort_t *pPort) 
{
	time_t tmptid;
	if(pPort->ControlVars.LACPEnabled == FALSE || 
		pPort->PortEnabled == FALSE ||
		(pPort->ActorOperPortState & LACP_ACTIVITY == 0 && 
		pPort->PartnerOperPortState & LACP_ACTIVITY == 0))
	{
		pPort->PeriodicTxMachState = NO_PERIODIC;
		ODMReleaseLock(pPort->PortLock,nFlags,0);
		ODMUntimeout(pPort->PeriodicTimerID,pPort);
		ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
		pPort->PeriodicTimerID = 0;
		return ;
	}
	if(pPort->ControlVars.BEGIN = TRUE)
		pPort->PeriodicTxMachState = NO_PERIODIC;

	switch(pPort->PeriodicTxMachState)
	{
		case NO_PERIODIC :
			pPort->PeriodicTxMachState = FAST_PERIODIC;
			LacpPeriodicTransmissionMachine(pPort);
			break;

		case FAST_PERIODIC:
			if((pPort->PartnerOperPortState & LACP_TIMEOUT) == 0) // LONG_TIMEOUT
			{
				/* Stop the Timer if running. */
				if(pPort->PeriodicTimerID)
				{
					tmptid = pPort->PeriodicTimerID;
					pPort->PeriodicTimerID = 0;
					ODMReleaseLock(pPort->PortLock,nFlags,0);
					ODMUntimeout(tmptid,pPort);
					ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
				}
				pPort->PeriodicTxMachState = SLOW_PERIODIC;
				LacpPeriodicTransmissionMachine(pPort);
			}
			else
			{
				/* if timer is not running */
				if(!pPort->PeriodicTimerID)
				{ 
					/* Start timer with Fast_Periodic_Time */
					pPort->PeriodicTimerID = ODMTimeout(LacpPeriodicTimer,pPort,FAST_PERIODIC_TIME,nFlags);
				}
			}
			break;

		case SLOW_PERIODIC:
			if((pPort->PartnerOperPortState & LACP_TIMEOUT) == TRUE) //SHORT_TIMEOUT)
			{
				/* Stop the Timer if running. */
				if(pPort->PeriodicTimerID)
				{
					tmptid = pPort->PeriodicTimerID;
					pPort->PeriodicTimerID = 0;
					ODMReleaseLock(pPort->PortLock,nFlags,0);
					ODMUntimeout(tmptid,pPort);
					ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
				}
				pPort->PeriodicTxMachState = FAST_PERIODIC;
				LacpPeriodicTransmissionMachine(pPort);
			}
			else
			{
				/* if timer is not running */
				if(!pPort->PeriodicTimerID)
				{ 
					/* Start timer with Slow_Periodic_Time */
					pPort->PeriodicTimerID = ODMTimeout(LacpPeriodicTimer,pPort,SLOW_PERIODIC_TIME,nFlags);
				}
			}
			break;
	}

	return;
} 


/********************************************************************
*f*
*
* Name : LacpPeriodicTimer
*
* Description : Implements the periodic state machine's timer routine.
*				In this function the Periodic state machine state will 
*				be in the PERIODIC_TX transitory state. It sets NTT flag
*				and changes the state to either FAST_PERIODIC or 
*				SLOW_PERIODIC depending on the Partner Operational 
*				Port's LACPTimeout vaue.
*
* Parameters :
*				pPort	Pointer to Port structure.
*
* Return Value : None
*
* Called By : Scheduled by LacpPeriodicTranmissionMachine.
*
* Lock :
*
*f*
*********************************************************************/

void
LacpPeriodicTimer(lacpPort_t *pPort)
{
      
	ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
	pPort->PeriodicTxMachState = PERIODIC_TX;
	pPort->NTT = TRUE;
	if((pPort->PartnerOperPortState & LACP_TIMEOUT) == TRUE)// SHORT_TIMEOUT)
		pPort->PeriodicTxMachState = FAST_PERIODIC;
	if((pPort->PartnerOperPortState & LACP_TIMEOUT) == FALSE) //LONG_TIMEOUT)
		pPort->PeriodicTxMachState = SLOW_PERIODIC;
	LacpTransmitMachine(pPort);
	LacpPeriodicTransmissionMachine(pPort);
	ODMReleaseLock(pPort->PortLock,nFlags,0);

	return;
}


/********************************************************************
*f*
*
* Name : LacpActorChurnDetectionMachine
*
* Description : It implemets the Actor Churn Detection Machine. It detects 
*				the situation where a port is operable, but the Actor
*				and partner have not attached the link to an Aggregator and
*				brought the link into operation within a bounded time period.
*
* Parameters :
*				pPort	Pointer to Port structure.
*
* Return Value : None
*
* Called By : LacpStateMachine
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
LacpActorChurnDetectionMachine(lacpPort_t *pPort)
{
	if(pPort->ControlVars.BEGIN|| pPort->PortEnabled == FALSE)
	{
		/*  No need to start the Actor churn machine 
		 *	Stop the actor_churn_timer if started.
		 */

		if(pPort->ActorChurnTimerID)
		{
			/* actor_churn_timer is running */
			ODMReleaseLock(pPort->PortLock,nFlags,0);
			ODMUntimeout(pPort->ActorChurnTimerID,pPort);
			ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
			pPort->ActorChurnTimerID = 0;
			pPort->ActorChurnState = NO_ACTOR_CHURN;
			pPort->ControlVars.ActorChurn = FALSE;
		}
		pPort->ActorChurnState = NO_ACTOR_CHURN;
		pPort->ControlVars.ActorChurn = FALSE;

		return;
	}
	switch(pPort->ActorChurnState)
	{
		case NO_ACTOR_CHURN:
			if((pPort->ActorOperPortState & SYNCHRONIZATION) == FALSE &&
				pPort->ControlVars.Selected != STANDBY)
			{
				ActorChurnMonitorState(pPort);
			}
			break;

		case ACTOR_CHURN_MONITOR:
		case ACTOR_CHURN:
			if((pPort->ActorOperPortState & SYNCHRONIZATION) == TRUE || 
				pPort->ControlVars.Selected == STANDBY)
			{
				NoActorChurnState(pPort);
			}
			break;
	} 

	return;
}


/********************************************************************
*f*
*
* Name : ActorChurnMonitorState
*
* Description : It implemets the ACTOR_CHURN_MONITOR state of Actor
*				Churn Detection Machine.
*
* Parameters :
*			pPort	Pointer to Port structure.
*
* Return Value : None
*
* Called By : LacpActorChurnStateMachine
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
ActorChurnMonitorState(lacpPort_t *pPort)
{
	pPort->ControlVars.ActorChurn = FALSE;
	/* Start the actor_churn_timer */
	pPort->ActorChurnTimerID = ODMTimeout(ActorChurnTimer,pPort,ACTOR_CHURN_DETECTION_TIME,nFlags);
	pPort->ActorChurnState = ACTOR_CHURN_MONITOR;

	if((pPort->ActorOperPortState & SYNCHRONIZATION) == TRUE)
		NoActorChurnState(pPort);

	return;
}


/********************************************************************
*f*
*
* Name : NoActorChurnState
*
* Description : It implemets the NO_ACTOR_CHURN state of Actor Churn 
*				Detection Machine
*
* Parameters :
*			pPort	Pointer to port structure
*
* Return Value : None
*
* Called By : LacpActorChurnDetectionMachine
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
NoActorChurnState(lacpPort_t *pPort)
{
	pPort->ControlVars.ActorChurn = FALSE;
	pPort->ActorChurnState = ACTOR_CHURN;

	if((pPort->ActorOperPortState & SYNCHRONIZATION) == FALSE)
		ActorChurnMonitorState(pPort);

	return;
}



/********************************************************************
*f*
*
* Name : ActorChurntimer
*
* Description : The Timer function implements the ACTOR_CHURN state
*				of the Actor Churn Detection Machine.
*
* Parameters :
*			arg		Pointer to Port structure.
*
* Return Value : None
*
* Called By : Scheduled by LacpActorChurnMachineState
*
* Lock : 
*
*f*
*********************************************************************/

void 
ActorChurnTimer(void *arg)
{
	lacpPort_t *pPort = (lacpPort_t *)arg ;

	ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
	pPort->ControlVars.ActorChurn = TRUE;
	pPort->ActorChurnState = ACTOR_CHURN;

	if((pPort->ActorOperPortState & SYNCHRONIZATION) == TRUE ||
		pPort->ControlVars.Selected == STANDBY)
	{
		NoActorChurnState(pPort);
	}
    else
	{
		/* Inform the Administrator since Aggregator still not found
		 */
		ODMError("ActorChurntimer : Inform the administrator, that ACTOR CHURN is TRUE");
	}

	pPort->ActorChurnTimerID  = 0;
	ODMReleaseLock(pPort->PortLock,nFlags,0);

	return;
}		


/********************************************************************
*f*
*
* Name : LacpPartnerChurnDetectionMachine 
*
* Description : This function detects the presence of a condition when 
*				systems participating in the link aggregation link are 
*				unable to resolve the state of a given link, i.e., the 
*				ports are out of sync for a long time, its 
*				partner_churn_state is set to PARTNER_CHURN
*
* Parameters :
*			pPort	Pointer to Port structure
*
* Return Value : None
*
* Called By : LacpStateMachine
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void
LacpPartnerChurnDetectionMachine(lacpPort_t *pPort)
{
	if(pPort->ControlVars.BEGIN = TRUE || 
		pPort->PortEnabled == FALSE)
	{
		/*  No need to start the Partner churn machine 
		 *	Stop the partner_churn_timer if started.
		 */
		if(pPort->PartnerChurnTimerID)
		{
			/* partner_churn_timer is running */
			ODMReleaseLock(pPort->PortLock,nFlags,0);
			ODMUntimeout(pPort->PartnerChurnTimerID,pPort);
			ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
			pPort->PartnerChurnTimerID = 0;
			pPort->PartnerChurnState = NO_PARTNER_CHURN;
			pPort->ControlVars.PartnerChurn = FALSE;
		}
		pPort->ActorChurnState = NO_PARTNER_CHURN;
		pPort->ControlVars.PartnerChurn = FALSE;

		return;
	}

	switch(pPort->PartnerChurnState)
	{
		case NO_PARTNER_CHURN:
			if((pPort->PartnerOperPortState & SYNCHRONIZATION) == FALSE)
				PartnerChurnMonitorState(pPort);
			break;

		case PARTNER_CHURN_MONITOR:
		case PARTNER_CHURN:
			if((pPort->PartnerOperPortState & SYNCHRONIZATION) == TRUE)
				NoPartnerChurnState(pPort);
			break;

	}	

	return;
}

/********************************************************************
*f*
*
* Name : PartnerChurnMonitorState
*
* Description : It implemets the PARTNER_CHURN_MONITOR state of Partner
*				Churn Detection Machine.
*
* Parameters :
*			pPort	Pointer to Port structure.
*
* Return Value : None
*
* Called By : LacpPartnerChurnStateMachine
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
PartnerChurnMonitorState(lacpPort_t *pPort)
{
	pPort->ControlVars.PartnerChurn = FALSE;
	/* Start the partner_churn_timer */
	pPort->PartnerChurnTimerID = ODMTimeout(PartnerChurnTimer,pPort,PARTNER_CHURN_DETECTION_TIME,nFlags);
	pPort->PartnerChurnState = PARTNER_CHURN_MONITOR;

	if((pPort->PartnerOperPortState & SYNCHRONIZATION) == TRUE)
		NoPartnerChurnState(pPort);

	return;
}


/********************************************************************
*f*
*
* Name : NoPartnerChurnState
*
* Description : It implemets the NO_PARTNER_CHURN state of Partner Churn 
*				Detection Machine
*
* Parameters :
*			pPort	Pointer to port structure
*
* Return Value : None
*
* Called By : LacpPartnerChurnDetectionMachine
*
* Lock : This function is called with the Port Lock held.
*
*f*
*********************************************************************/

void 
NoPartnerChurnState(lacpPort_t *pPort)
{
	pPort->ControlVars.PartnerChurn = FALSE;
	pPort->PartnerChurnState = PARTNER_CHURN;

	if((pPort->PartnerOperPortState & SYNCHRONIZATION) == FALSE)
		PartnerChurnMonitorState(pPort);

	return;
}

/********************************************************************
*f*
*
* Name : PartnerChurntimer
*
* Description : The Timer function implements the PARTNER_CHURN state
*				of the Partner Churn Detection Machine.
*
* Parameters :
*			arg		Pointer to Port structure.
*
* Return Value : None
*
* Called By : Scheduled by LacpPArtnerChurnMachineState
*
* Lock : 
*
*f*
*********************************************************************/

void
PartnerChurnTimer(void *arg)
{
	lacpPort_t *pPort = (lacpPort_t *)arg ;

	ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
	pPort->ControlVars.PartnerChurn = TRUE;
	pPort->PartnerChurnState = PARTNER_CHURN;

	if((pPort->PartnerOperPortState & SYNCHRONIZATION) == TRUE)
		NoPartnerChurnState(pPort);
    else
	{
		/* Inform the Administrator since Aggregator still not found
		 */
		ODMError("PartnerChurnTimer : Infroming the administrator, that PARTNER_CHURN is TRUE");
	}
	pPort->PartnerChurnTimerID = 0;
	ODMReleaseLock(pPort->PortLock,nFlags,0);

	return;
}		


/********************************************************************
*f*
*
* Name : LacpAdapterStatusCheck
*
* Description : The function Enables/Disables on Link UP/DOWN.
*				
*
*
*
* Parameters :
*		padapter	Pointer to Adapter Context. 
*
* Return Value : None
*
* Called By : HsmIsr
*
* Lock :
*
*f*
*********************************************************************/

void
LacpAdapterStatusCheck(AdapterContext *pAdapter) 
{

	USHORT indx;
	lacpAggr_t *pAggr;
	PRIV_LEVEL	CurrLevel1, CurrLevel2, CurrLevel3;
	lacpPort_t *pPort = LACPPortp[pAdapter->Port];
	
	// Added by Gopi 16.  Oct 2000  2:30
	// Since this routine runs in interrupt context.
	// set the corresponding IRQL level to 'Level'
	// The following Level has to be set depending on
	// different OSs.

	CurrLevel1 = ODMAcquireLock(pPort->PortLock,nFlags,0);
	
	//DbgPrint1("CheckStatus AdapterStatus & LINK_UP = %x\n",pAdapter->AdapterStatus & LINK_UP);
	
	if(!(pAdapter->AdapterStatus & ADAPTER_OPEN)) {
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel1);
		return;	
	}
    if(!(pAdapter->AdapterStatus & LINK_UP))
	{
		/* Link is Down */
		pPort->PortEnabled = FALSE;
		
		/*  Revisit */
		BIT_CLEAR(pPort->ActorOperPortState, DISTRIBUTING);
		BIT_CLEAR(pPort->ActorOperPortState, COLLECTING);
		
	
		if(pPort->ControlVars.LACPEnabled)
		{
			CurrLevel3 = ODMAcquireLock(GlobalLock,nFlags,0);
			ODMPostEvent(pPort, EV_PORT_DISABLED,0);
			ODMReleaseLock(GlobalLock,nFlags,CurrLevel3);
		}
	
		pAggr = pPort->LACPAggrp;
		
		CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,nFlags,0);
		for(indx=0; indx < NUM_OF_MAC_ADDRESS_CLASSES; indx++) 
		{
			if(pAggr->PortForMAC[indx] == pPort->ActorPortNumber) {
				pAggr->PortForMAC[indx] = MAX_PORTS;
				/* Reset load per MAC - Ravi 1st Nov, 12:45 PM */
				pAggr->PrevLoadPerMAC[indx] = pAggr->LoadPerMAC[indx];
			}
		}
		ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel2);
		/* Inform the Administrator for Link down
		 */
		ODMError("LacpAdapterStatusCheck : Link is down, Port 0x%x\n", pAdapter->Port);
	}
	else /* Link is UP */
	{		
		pPort->PortEnabled = TRUE;

		if(pPort->ControlVars.LACPEnabled)
		{
			CurrLevel3 = ODMAcquireLock(GlobalLock,nFlags,0);
			ODMPostEvent(pPort,EV_PORT_ENABLED,0);
			ODMReleaseLock(GlobalLock,nFlags,CurrLevel3);
		}

		/* Now the Port can Transmit and Receive */
		BIT_SET(pPort->ActorOperPortState, DISTRIBUTING);
		BIT_SET(pPort->ActorOperPortState, COLLECTING);

		/* Reset port load - Ravi 1st Nov 12:45 PM */
		pPort->LoadPerPort = ODMGetLoadPerPort(AdapterArray[pPort->ActorPortNumber]);

		/* Inform the Administrator for Link up 
		 */
		ODMError("LacpAdapterStatusCheck : Link is up, Port 0x%x\n", pAdapter->Port);
	}
	ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel1);

	return;
}

/* Aggregator */
/*******************************************************************************
*f*	
*	Name :
*			AggrSendPacket
*
*	Description :
*			This function is called whenever NSM wants to send a packet through the
*			aggregator. 
*			
*	Parameters :
*			pAdapter - Pointer to the AdapterContext structure
*			pkt		 - Pointer to PktInfo structure
*			Prio	 - Priority queue in to which this set of packet is to be put.
*
*	Return Value : 
*			SUCCESS/FAILURE
*
*	Called By :
*			NIC Driver Send Entry Point
*
*	Lock :
*			None
*f*
********************************************************************************/

INT
AggrSendPacket(AdapterContext *pAdapter,PktInfo *Pkt,UCHAR Prio, INT *CableStatus)
{
	UCHAR		index;
	USHORT		nPort, Aggr_Port;
	INT			PortIndex;
	AdapterContext	*pAdapterTemp;
	UINT			ret, i;
	ULONG		size = 0;
	lacpAggr_t	*pAggr;
	lacpPort_t	*pAggrPort;
	
	#if 0		// This code is being added to avoid sending packet through non aggregator port
	if(pAdapter->pAggregatorContext != pAdapter) {
		ODMError("!AggrSendPacket : Misconfiguration of IP : Cannot Send Packet\n");
		return FAILURE;
	}
	#endif

	index = ODMGetIndex(Pkt); /* last byte of the destination MAC address */

	Aggr_Port = pAdapter->Port;

	GET_LACPPORTP(Aggr_Port, pAggrPort);

	pAggr = pAggrPort->LACPAggrp;

	nPort = pAggr->PortForMAC[index];
	if (nPort >= MAX_PORTS)
	{
		if (nPort == MAX_PORTS) /* Port unassigned for this MAC Address Class */
		{
			ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
			if ((PortIndex = GetLeastLoadedPort(pAggr)) == -1)
			{
				/* All the Ports of this LAG are disabled */
				pAggr->DistributorState = FALSE; /*disable distributor*/
				ODMReleaseLock(pAggr->AggrLock,nFlags,0);
				*CableStatus = -1;
				pAggr->LoadPerMAC[index] += Aggr_Port;

				return FAILURE;
			}
			
			nPort = pAggr->PortForMAC[index] = pAggr->LAGPorts[PortIndex];
			ODMReleaseLock(pAggr->AggrLock,nFlags,0);

		}
		else /* Waiting for Marker Response or CollectorMaxDelay */
		{
			pAggr->LoadPerMAC[index] += Aggr_Port;
			ODMError("!AggrSend : Cannot send the packet\n");
			return FAILURE;
		}
	}

	if ( nPort == Aggr_Port)
	{
		ret = pAdapter->FuncStruct.HsmSendPkt(pAdapter,Pkt,Prio);
	}
	else
	{
		pAdapterTemp = (AdapterContext *)AdapterArray[nPort];
		ret = pAdapterTemp->FuncStruct.HsmSendPkt(pAdapterTemp, Pkt, Prio);
	}

	if(ret == FAILURE)
		return FAILURE;
	pAggr->LoadPerMAC[index] += ret;
	
	return ret;
}	

/*******************************************************************************
*f*	
*	Name :
*			AggrSendPackets
*
*	Description :
*			This function is called whenever NSM wants to send packets through the
*			aggregator. 
*			
*	Parameters :
*			pAdapter - Pointer to the AdapterContext structure
*			pkts	 - Pointer to the PktStruct, in which the data to be sent down
*					   is encapsulated
*			Prio	 - Priority queue in to which this set of packet is to be put
*			
*	Return Value : 
*			The number of packets that was queued for transmission
*
*	Called By :
*			NIC Driver Send Entry Point
*
*	Lock :
*			None
*f*
********************************************************************************/


// new version of aggrsendpackets. Split based on port rather than MAC addr class
INT
AggrSendPackets(AdapterContext *pAdapter, PktStruct *Pkts, UCHAR Prio, INT *CableStatus)
{
	UCHAR		index, next_index;
	USHORT		nPort, Aggr_Port;
	lacpAggr_t	*pAggr;
	lacpPort_t	*pAggrPort;
	INT			PortIndex;
	AdapterContext	*pAdapterTemp;
	UINT 		ret, i=0, j, k, start=0;
	ULONG		size = 0;
	USHORT		NumPkts = Pkts->PktCount;
	PRIV_LEVEL	CurrLevel2;

	// This code is being added to avoid sending packet through non aggregator port
	if(pAdapter->pAggregatorContext != pAdapter) {
		*CableStatus = -1;
		return 0;
	}


	//DbgPrint("LACP: Entering AggrSendPackets. Portnum %x\n", pAdapter->Port);

	Aggr_Port = pAdapter->Port;
	GET_LACPPORTP(Aggr_Port, pAggrPort);
	pAggr = pAggrPort->LACPAggrp;
	
	index = ODMGetIndex(&(Pkts->PktArray[0])); /* Last byte of the destination MAC address */

	for(i=1; i < NumPkts; i++) 
	{
		next_index = ODMGetIndex(&(Pkts->PktArray[i]));/* Last byte of the subsequent next packet destination MAC address */

		if( next_index == index)
			continue;

		nPort = pAggr->PortForMAC[index];
		if ((nPort < MAX_PORTS) && (pAggr->PortForMAC[next_index] == nPort)) {
			index = next_index;
			continue;
		}
		if (nPort >= MAX_PORTS)
		{
			if (nPort == MAX_PORTS) /* Port unassigned for this MAC Address Class */
			{
				// Acquire AggrLock - Ravi 8th Nov 1:00 PM
				CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
				if ((PortIndex = GetLeastLoadedPort(pAggr)) == -1)
				{
					/* All the Ports of this LAG are disabled */
					ODMError("!AggrSendPacket : All Ports Distributors Disabled\n");
					// Don't Acquire lock as its held above. Added by Gopi 9 Nov 2000 12:30
					//CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
					pAggr->DistributorState = FALSE; /*disable distributor*/
					ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel2);
					*CableStatus = -1;
					pAggr->LoadPerMAC[index] += start;
					Pkts->PktCount = NumPkts;	// Restore PktCount - Ravi
					return(start);
				}
			
//				CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
				nPort = pAggr->PortForMAC[index] = pAggr->LAGPorts[PortIndex];
				ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel2);
			}
			else 
			{
				ODMError("!AggrSend : Cannot send packets\n");
				pAggr->LoadPerMAC[index] += start;
				Pkts->PktCount = NumPkts;	// Restore PktCount - Ravi
				return(start);
			}
		}

		Pkts->PktCount = i - start;
		// added for testing. remove later.  Gopi
		//pAdapter->FuncStruct.NsmSetPktStatus(Pkts,start,Pkts->PktCount);

		if ( nPort == Aggr_Port)
			ret = pAdapter->FuncStruct.HsmSendPkts(pAdapter, Pkts, Prio, start);
		else
		{
			pAdapterTemp = (AdapterContext *) AdapterArray[nPort];
			ret = pAdapterTemp->FuncStruct.HsmSendPkts(pAdapterTemp, Pkts, Prio, start);
		}

		if(ret != Pkts->PktCount)
		{
#if 0	// Use no. of packets instead of byte count.
			for(j=start; j<(start + ret); j++) { /* Loop Untill the number of packets sent */
				for (k=0; k< Pkts->PktArray[j].NumFrags;)
					size += Pkts->PktArray[j].FragArray[k++].FragLen;
			}
			pAggr->LoadPerMAC[index] += size; /* Update Load per MAC */
#endif
			pAggr->LoadPerMAC[index] += (start + ret);
			Pkts->PktCount = NumPkts;
			return (start + ret);
		}
		else
		{
#if 0	// Use no. of packets instead of byte count.
			for(j=start; j<(start + ret); j++) { /* Loop Untill the number of packets sent */
				for (k=0; k< Pkts->PktArray[j].NumFrags;)
					size += Pkts->PktArray[j].FragArray[k++].FragLen;
			}
			pAggr->LoadPerMAC[index] += size; /* Update Load per MAC */
#endif
		}
		
		index = next_index;
		start = start + ret;
	} /* End of Loop till number of packets */

	nPort = pAggr->PortForMAC[index];
	if (nPort >= MAX_PORTS)
	{
		if (nPort == MAX_PORTS) /* Port unassigned for this MAC Address Class */
		{
			// Acquire AggrLock - Ravi 8th Nov 1:00 PM
			CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
			if ((PortIndex = GetLeastLoadedPort(pAggr)) == -1)
			{
				/* All the Ports of this LAG are disabled */
				ODMError("!AggrSendPacket : All Ports Distributors Disabled\n");

				// Don't Acquire lock as its held above. Added by Gopi 9 Nov 2000 12:30
				//CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
				pAggr->DistributorState = FALSE; /*disable distributor*/
				ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel2);
				Pkts->PktCount = NumPkts;
				*CableStatus = -1;
				pAggr->LoadPerMAC[index] += start;
				return(start);
			}
			
//			CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
			nPort = pAggr->PortForMAC[index] = pAggr->LAGPorts[PortIndex];
			ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel2);
		}
		else /* Waiting for Marker Response or CollectorMaxDelay */
		{
			ODMError("!AggrSend : Waiting For Marker Response PDUs\n");
			Pkts->PktCount = NumPkts;
			pAggr->LoadPerMAC[index] += start;
			return(start);
		}
	}

	Pkts->PktCount = i - start;

	if ( nPort == Aggr_Port)
	{
		ret = pAdapter->FuncStruct.HsmSendPkts(pAdapter, Pkts, Prio, start);
	}
	else
	{
		pAdapterTemp = (AdapterContext *) AdapterArray[nPort];
		ret = pAdapterTemp->FuncStruct.HsmSendPkts(pAdapterTemp, Pkts, Prio, start);
	}

#if 0	// Use no. of packets instead of byte count.
	for(j=start; j<(start + ret); j++) { /* Loop Until the number of packets sent */
		for (k=0; k< Pkts->PktArray[j].NumFrags;)
			size += Pkts->PktArray[j].FragArray[k++].FragLen;
	}
	pAggr->LoadPerMAC[index] += size; /* Update Load per MAC */
#endif
	pAggr->LoadPerMAC[index] += (start + ret);
	Pkts->PktCount = NumPkts;
	return (start + ret);
}

/*******************************************************************************
*f*	
*	Name :
*			GetLeastLoadedPort
*
*	Description :
*			This function finds the least loaded Port from the Aggregator. The Port
*			has its distributing bit set.
*			
*	Parameters :
*			pAggr - Pointer to the lacpAggr_t structure
*			
*	Return Value : 
*			-1 if none of the ports have their distributing bit set else Index to 
*			the port that is least loaded
*
*	Called By :
*			NIC Driver Send Entry Point
*
*	Lock :
*			None.
*f*
*******************************************************************************/

INT
GetLeastLoadedPort(lacpAggr_t *pAggr)
{
	lacpPort_t	*pPort;
	INT			i, min = -1;
	ULONG		Load,MinLoad = 0xFFFFFFFF;
	PRIV_LEVEL	CurrLevel;

	for( i=0; i < LACP_MAX_PER_GROUP; i++)
	{
		if (pAggr->LAGPorts[i] == 0 || 
			(!((AdapterArray[pAggr->LAGPorts[i]])->AdapterStatus & LINK_UP)))
				continue;
		
		GET_LACPPORTP(pAggr->LAGPorts[i], pPort);

		if ( !(pPort->ActorOperPortState & DISTRIBUTING) )
			continue;
		
		/* Get PerPortLoad */
		LOAD_PER_PORT(pPort, Load);
		
		if ( Load < MinLoad )
		{
			min = i;
			MinLoad = Load;
		}
	}
	return min;
}


/*******************************************************************************
*f*	
*	Name :
*			AggrRxPackets
*
*	Description :
*			This function is called whenever a LACPDU/MARKER_PDU is received 
*			from the HSM. It stores the information in a circular queue, pHsmRCB
*			for the further processing
*			
*	Parameters :
*			pAdapter - Pointer to the AdapterContext structure
*			Rcb		 - Pointer to the HsmRCB in the list for which receive completion
*					   has happened
*
*	Return Value : 
*			None
*
*	Called By :
*			HsmRxPackets()
*
*	Lock :
*			None
*f*
********************************************************************************/

VOID
AggrRxPackets(AdapterContext *pAdapter, HsmRCB *Rcb)
{
	USHORT temp;

	if(Q_FULL(pAdapter->pLacpRCB))
	{
		/* Queue is full : Drop the received packet */
		ODMError("!AggrRxPackets : LACP Queue is Full\n");
		Rcb->Status = FREE;
		return;
	}
	else {
		temp = (pAdapter->pLacpRCB->Write + 1) % MAX_BUF;
		/* Enque the packet received */
		pAdapter->pLacpRCB->pHsmRCB[temp] = Rcb;
		pAdapter->pLacpRCB->Write = temp;
	}

	if(ODMProcessPacketsRunning()) {
		/* This flag is set if LacpProcessPacket is running */
		MorePackets = TRUE;
	}
	else {
		/* Signal LacpProcessPackets to process LACPDU/MARKER PDU */
		ODMSignalProcessPackets();
	}
}


/*******************************************************************************
*f*	
*	Name :
*			LacpProcessPackets
*
*	Description :
*			This function processes lacpdu/marker_pdu queued when received by
*           AggrRxPackets() in pHsmRCB[] of	AdapterContext. 
*			
*	Parameters :
*			void
*
*	Return Value : 
*			None
*
*	Called By :
*			Signalled by AggrRxPackets()
*
*	Lock :
*			None
*f*
********************************************************************************/

VOID 
LacpProcessPackets(VOID)
{
	HsmRCB *current_rcb, *latest_rcb;
	lacpPort_t	*pPort;
	AdapterContext	*pAdapter;
	USHORT	j, temp;


	REPROCESS :
	
	for(j=0; j<=MAX_PORTS; j++)
	{
		if (AdapterArray[j] == NULL) 
			continue;
		/* Get the pointer to the AdapterContext. */
		pAdapter = (AdapterContext *)AdapterArray[j];
		GET_LACPPORTP(pAdapter->Port, pPort);

		latest_rcb = NULL;

		while(!Q_EMPTY(pAdapter->pLacpRCB)) 
		{
			temp = (pAdapter->pLacpRCB->Read + 1) % MAX_BUF;
			pAdapter->pLacpRCB->Read = temp;
			current_rcb = (HsmRCB *) pAdapter->pLacpRCB->pHsmRCB[temp];
			
			/* Check the subtype of lacpdu received */
			switch(*(current_rcb->pDataBuf+14))
			{
				case LACP_PDU_TYPE :
					if(latest_rcb != NULL) {
						latest_rcb->Status = FREE;
					}
					latest_rcb = current_rcb;
					break;
				case MARKER_PDU_TYPE :
					/* Marker Protocol handler */
					MarkerPDUHandler(current_rcb, pPort);
					current_rcb->Status = FREE;
			}
		} /* End of Process */

		if (latest_rcb) {
			/* Call LacpStateMachine() to process the latest lacpdu */	
			LacpStateMachine(pPort, EV_RECV_PDU, latest_rcb);
			latest_rcb->Status = FREE;
		}

    } /* End of Adapter */

    if(MorePackets) {
		MorePackets = FALSE;
		goto REPROCESS;
	}
}


/*******************************************************************************
*f*	
*	Name :
*			AggrReshuffle
*
*	Description :
*			This function finds the MAC Address class that has to be shifted 
*			from the most loaded port to the least loaded port to balance the 
*			load among the ports of the LAG.
*
*	Parameters :
*			Aggrp - Pointer to the aggregator structure
*			
*	Return Value : 
*			None
*
*	Called By :
*			LacpMuxMachineState() ( first time ),
*			It calls itself on reshuffle Timeout Onwards.
*
*	Lock :
*			None
*f*
********************************************************************************/

VOID 
AggrReshuffle(lacpAggr_t *pAggr)
{
	SHORT	i,MACtoShift, ret;
	ULONG	Avg=0, MaxthLoad=0, ExtraLoad, LoadOnMAC, PerPortLoad;
	USHORT	Port, MaxthPort=0;
	lacpPort_t *pPort;
	PRIV_LEVEL CurrLevel2;
	AdapterContext *pAdapter;
	ULONG	MinthLoad = 0xffffffff;		// Ravi, 7th Nov 6:15 PM
	USHORT	MinthPort = 0;	// Ravi, 7th Nov 6:15 PM
	USHORT	LinkUpPorts = 0;

	//DbgPrint("Inside AggrReshuffle\n");
	/* Find the average load per port in this aggregator and the most laoaded
	   port */
	CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,0,0);
	//DbgPrint("AggrReshuffle : After Acquiring Aggr lock\n");
	for ( i=0; i < LACP_MAX_PER_GROUP; i++)
	{
		Port = pAggr->LAGPorts[i];
		if(!Port)
			continue;

		GET_LACPPORTP(Port, pPort);
		if(AdapterArray[Port]->AdapterStatus & LINK_UP)
			if((pPort->ActorOperPortState) & DISTRIBUTING) 
				LinkUpPorts++;
			
	}
	for ( i=0; i < LACP_MAX_PER_GROUP; i++)
	{
		Port = pAggr->LAGPorts[i];
		// Added by Gopi 30 Mon Oct 2000 
		if(Port == 0)
			continue;
		//End of changes. Added by Gopi 30 Mon Oct 2000.
		GET_LACPPORTP(Port, pPort);
		LOAD_PER_PORT(pPort, PerPortLoad);
		/* added dbgprint, remove later - Ravi 1st Nov 2:00 PM */
		ODMDbgPrint3("Load on Port 0x%x = 0x%x\n", Port, PerPortLoad);
		//DbgPrint("Port for MAC classes 0x8, 0x53, 0x96 0x%x  0x%x 0x%x\n", pAggr->PortForMAC[0x8], pAggr->PortForMAC[0x53], pAggr->PortForMAC[0x96]);
		if(!LinkUpPorts)
			continue;

		//Avg += (PerPortLoad / (pAggr->NumPorts));
		// Considering only the LINK_UP ports for getting the avg load.
		Avg += (PerPortLoad / LinkUpPorts);					

		if(PerPortLoad > MaxthLoad)
		{
			MaxthLoad = PerPortLoad;
			MaxthPort = Port;
		}
		// Calculate the Min load too. Ravi, 7th Nov 6:15 PM
		if (((AdapterArray[Port])->AdapterStatus & LINK_UP) &&
				(pPort->ActorOperPortState & DISTRIBUTING)) {
			if (PerPortLoad < MinthLoad) {
				MinthLoad = PerPortLoad;
				MinthPort = Port;
			}
		}
		/* Update Ports Load with the current statistics */
		pPort->LoadPerPort = ODMGetLoadPerPort(AdapterArray[pPort->ActorPortNumber]);
	}
	
	//DbgPrint("AggrReshuffle : After the for loop \n");
	/* Get the extra Load on the most loaded Port */
	ExtraLoad = MaxthLoad - Avg;

	/* Check if we are shifting to the same port - Ravi 10 Nov 11:10 AM */
	if ((MaxthPort != MinthPort) && (ExtraLoad > (Avg >> 1)))  //revisit - threshold
	{
		MACtoShift = GetMACtoShift(pAggr,MaxthPort,ExtraLoad);
		LOAD_PER_MAC(pAggr,MACtoShift,LoadOnMAC);
		/* if the mac to be shifted itself occupies more than half of the Port's load
		   then shifting this mac will just load some other port and will not lead 
	       to load balancing. Hence break and do not shift 
		 */
//		if((MACtoShift != -1) && (LoadOnMAC < (MaxthLoad >> 1)))
		// Change the ratio to 3/4. Ravi, 7th Nov 6:15 PM
		if((MACtoShift != -1) && (LoadOnMAC < ((3*MaxthLoad) >> 2)))
		{
			/* Don't send marker if LACP is not enabled - Ravi 1st Nov 5:10 PM */
			pAdapter = AdapterArray[MaxthPort];
			if ((pAdapter->nFlags & LACP_FLAG) == FALSE) {
				//DbgPrint("Before call KeStallExecutionProc\n");
				ODMDelay(PROPAGATION_DELAY);
//				pAggr->PortForMAC[MACtoShift] = MAX_PORTS;
				//Ravi, 7th Nov 6:15 PM
				pAggr->PortForMAC[MACtoShift] = MinthPort;
				ODMDbgPrint4("Shifting  MAC class 0x%x from Port 0x%x to 0x%x\n", MACtoShift,MaxthPort,MinthPort);
			}
			else
			{
				ODMReleaseLock(pAggr->AggrLock,0,CurrLevel2);
				ret = SendMarker(MaxthPort, MACtoShift);
				CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,0,0);
				if (ret == SUCCESS)
					pAggr->PortForMAC[MACtoShift] = MAX_PORTS + MaxthPort + 1;
				else
					pAggr->PortForMAC[MACtoShift] = MAX_PORTS;
			}
		}

	}
	for(i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
		pAggr->PrevLoadPerMAC[i] = pAggr->LoadPerMAC[i];

	pAggr->ReshuffleTimerID = ODMTimeout(AggrReshuffle,pAggr,RESHUFFLE_TIMEOUT,AGGR_RESHUFFLE_TIMER);
	
	if(pAggr->ReshuffleTimerID == 0)
		ODMError("!AggrReshuffle : Couldn't Start Reshuffle Timer\n");

	ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel2);
	return;
}


/*******************************************************************************
*f*	
*	Name :
*			GetMACtoShift
*
*	Description :
*			Find the mac address class which uses port and whose load is closest
*			to the load given 
*
*	Parameters :
*			pAggr - Pointer to the aggregator structure
*			Port  - The port from which the load is to be reduced
*			Load  - The MAC's load should be closest to this load
*			
*	Return Value : 
*			MAC address class that has to be shifted
*
*	Called By :
*			AggrReshuffle()
*
*	Lock :
*			None
*f*
********************************************************************************/

SHORT
GetMACtoShift(lacpAggr_t *pAggr, UINT Port, ULONG Load)
{
	SHORT i, ret = -1;
	ULONG MACLoad, CurrentDiff, Diff;

	/* Skip MACS that do not use this port */ 
	for (i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
		if (pAggr->PortForMAC[i] == Port) break;

	/* This is the first MAC address class that uses this port */
	// Added by Gopi 8 Nov 2000. 11:35am.
	if(i == NUM_OF_MAC_ADDRESS_CLASSES)
		return ret;
	

	/* Find the Positive Difference between the Load for this MAC and Load */
	LOAD_PER_MAC(pAggr, ret, MACLoad);

	CurrentDiff = (MACLoad > Load) ? (MACLoad - Load) : (Load - MACLoad);

	i++;

	for (; i < NUM_OF_MAC_ADDRESS_CLASSES; i++) 
	{
		if (pAggr->PortForMAC[i] == Port)
		{
			LOAD_PER_MAC(pAggr, i, MACLoad);
			/* This MAC is using port */
			Diff = (MACLoad > Load) ? (MACLoad - Load) : (Load - MACLoad);

			if (Diff < CurrentDiff)
			{
				ret = i;
				CurrentDiff = Diff;
			}
		}
	}
	return ret;
}


/* Marker Protocol*/
/*******************************************************************************
*f*	
*	Name :
*			SendMarker
*
*	Description :
*			Called whenever the entire load is being shifted from one port to 
*			another in an aggregator or whenever a MAC address class is being 
*			shifted from one port to another. This function prepares a Marker 
*			PDU and sends it through the port and also starts the CollectorMaxDelay 
*			Timeout to handle the case when a Marker response isn't received.
*
*	Parameters :
*			Port			- The port through which the marker PDU is to be sent
*			TransactionId   - The TransactionId to be sent along with the Marker PDU
*			
*	Return Value : 
*			SUCCESS if CollectorMaxDelay is successfully started and FAILURE														
*			if scheduling the timeout fails.
*
*	Called By :
*			AggrReshuffle, MuxCollecting
*
*	Lock :
*			Port Lock is held while calling this function
*f*
********************************************************************************/

SHORT
SendMarker(USHORT Port, SHORT TransactionId)
{
	
	markerId_t	*pMarkerId;
	AddressStruct	pAddrStruct;
	lacpPort_t	*pPort;
	PktInfo		Pkt;
	marker_t	*pMarker;
	AdapterContext *pAdapter;

	
	if ((pMarkerId = (markerId_t *) ODMMalloc(sizeof(markerId_t), 0)) == NULL)
	{
		ODMError("!sendMarker : Allocation of MarkerId structure failed");
		return FAILURE;
	}

	GET_LACPPORTP(Port, pPort);
	pAdapter = (AdapterContext *) AdapterArray[pPort->ActorPortNumber];

	pMarkerId->Port = Port;
	pMarkerId->TransactionId = TransactionId;
	
	
	if (pPort->CollectorMaxDelayTimerID) 
	{
		ODMReleaseLock(pPort->PortLock,nFlags,0);
		/* Cancel the timer */
		ODMUntimeout(pPort->CollectorMaxDelayTimerID,pPort);
		ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
		pPort->CollectorMaxDelayTimerID = 0;
	}

	pPort->CollectorMaxDelayTimerID = ODMTimeout(CollectorMaxDelayTimer,pMarkerId,COLLECTOR_MAX_DELAY_TIME + PROPAGATION_DELAY,nFlags);

	if (!pPort->CollectorMaxDelayTimerID)
	{
		ODMError("!SendMarker : CollectorMaxDelayTimer could not scheduled");
		ODMFree(pMarkerId, sizeof(markerId_t),0);
		return FAILURE;
	}

	/* Allocate Memory for Marker */
	pAddrStruct.VirtAddr = NULL;
	pAddrStruct.PhysAddr = NULL;
	pAddrStruct.BufSize  = sizeof(marker_t);
	pAddrStruct.pCookie  = NULL;
	
	ODMMallocContiguous(&pAddrStruct,0);
	
	if ( pAddrStruct.PhysAddr == NULL )
		return SUCCESS; /* Memory Allocation failed */
	
	Pkt.FragArray[BASE_INDEX].pFrag = pAddrStruct.PhysAddr;
	/* Update the length field of the fragment */
	Pkt.FragArray[BASE_INDEX].FragLen = pAddrStruct.BufSize;
	Pkt.NumFrags = 1;
	Pkt.SlowProtocolType = TRUE;
	Pkt.pOSCtrlBlk = pAddrStruct.VirtAddr;
	/* Assign Virtual Address to fill the elements */
	pMarker = (marker_t *) pAddrStruct.VirtAddr;
	
	/* Fill in the marker_t structure */
	ODMCopy((UCHAR *)SlowProtocolMulticast, (UCHAR *)&pMarker->DestinationAddress,MAC_ADDR_LEN);
	ODMCopy((UCHAR *)pAdapter->CurrMacAddr, (UCHAR *)&pMarker->SourceAddress,MAC_ADDR_LEN);
	
	pMarker->LenType = (USHORT)ODMhtons(SLOW_PROTOCOL_TYPE);
	pMarker->Subtype = MARKER_PDU_TYPE;
	pMarker->Version = MARKER_VERSION;
	pMarker->TLVType = MARKER_INFORMATION;
	pMarker->Length = MARKER_INFORMATION_LENGTH;
	pMarker->RequestorPort = ODMhtons(pPort->ActorPortNumber);
	ODMCopy((UCHAR *)&pPort->ActorPortSystem,(UCHAR *)&pMarker->RequestorSystem, MAC_ADDR_LEN);
	pMarker->RequestorTransactionId = (UINT)ODMhtons(TransactionId);
	pMarker->Pad = MARKER_PADDING;
	pMarker->Terminator = MARKER_TERMINATOR;
	pMarker->TerminatorLength = MARKER_TERMINATOR_LENGTH;

	/* Send the packet using HSMSendPacket function call */
	pAdapter->FuncStruct.HsmSendPkt(pAdapter, Pkt, 0);
	
	return SUCCESS;
}

/*******************************************************************************
*f*	
*	Name :
*			CollectorMaxDelayTimer
*
*	Description :
*			Since Marker response was not received this function shifts the MAC
 *			address class that is to be shifted.
*
*	Parameters :
*			MarkerId	Structure holding Port and TransactionId
*
*	Return Value : 
*			None
*
*	Called By :
*			Called after timeout has occured after sending the marker PDU.
*
*	Lock :
*			None
*f*
********************************************************************************/

VOID
CollectorMaxDelayTimer(VOID *MarkerId)
{
	USHORT		Port  = ((markerId_t *)(MarkerId))->Port;
    USHORT		TransactionId = ((markerId_t *)(MarkerId))->TransactionId;
	lacpAggr_t	*pAggr;
	lacpPort_t	*pPort;
	INT			i;
	
	GET_LACPPORTP(Port, pPort);

	pAggr = pPort->LACPAggrp;

	ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
	if (!pPort->CollectorMaxDelayTimerID) 
	{
		/* MarkerResponseHandler() has handled the port shifting stuff. So just return */
		ODMReleaseLock(pPort->PortLock,nFlags,0);    
		ODMFree(MarkerId, sizeof(markerId_t),0);
		return; 
	}
	ODMReleaseLock(pPort->PortLock,nFlags,0);

	pPort->CollectorMaxDelayTimerID = 0;

	ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
	if (TransactionId == SHIFT_PORT)
	{
		for (i=0; i< NUM_OF_MAC_ADDRESS_CLASSES; i++)
		{
			if (pAggr->PortForMAC[i] ==  (MAX_PORTS + Port + 1))
			{
				pAggr->PortForMAC[i] = MAX_PORTS;
			}
		}
	}
	else
	{
		if (pAggr->PortForMAC[TransactionId] > MAX_PORTS)
			pAggr->PortForMAC[TransactionId] = MAX_PORTS;
	}
	ODMReleaseLock(pAggr->AggrLock,nFlags,0);

	ODMFree(MarkerId, sizeof(markerId_t),0);
	return;
}


/*******************************************************************************
*f*	
*	Name :
*			MarkerPDUHandler	
*
*	Description :
*			This Function is called to handle Marker PDUs
*	Parameters :
*			Rcb		Pointer to HsmRCB structure
*			pPort	Pointer to the lacpPort_t structure
*
*
*	Return Value : 
*			None	
*
*	Called By :
*			LacpProcessPackets()
*
*	Lock :
*			None
*f*
********************************************************************************/

VOID
MarkerPDUHandler(HsmRCB *Rcb, lacpPort_t *pPort)
{
	marker_t *pMarker;
	
	pMarker = (marker_t *)Rcb->pDataBuf;

	if (pMarker->TLVType == MARKER_INFORMATION)
		SendMarkerResponse(Rcb, pPort);
	else if (pMarker->TLVType == MARKER_RESPONSE_INFORMATION)
		MarkerResponseHandler(Rcb, pPort);
	else
	{
		/* Not handling any other protocol type. */
		ODMError("!MarkerPDUHandler : Could not handle different Protocol info\n");
	}
	
	return;
}


/*******************************************************************************
*f*	
*	Name :
*			SendMarkerResponse	
*
*	Description :
*			This function sends a Marker Response PDU after changing 
*			the TLV type in the marker PDU from MARKER_INFORMATION to 
*			MARKER_RESPONSE_INFORMATION.
*	Parameters :
*			Rcb		Pointer to HsmRCB structure
*			pPort	Pointer to the lacpPort_t structure
*
*	Return Value : 
*				
*
*	Called By :
*			MarkerPDUHandler
*
*	Lock :
*			None
*f*
********************************************************************************/

INT
SendMarkerResponse(HsmRCB *Rcb, lacpPort_t *pPort)
{
	marker_t *pRecvMarker, *pSendMarker;
	AdapterContext *pAdapter;
	AddressStruct	pAddrStruct;
	PktInfo		Pkt;
	
	pAdapter = (AdapterContext *) AdapterArray[pPort->ActorPortNumber];

	pRecvMarker = (marker_t *) Rcb->pDataBuf;

	/* Allocate Memory for Marker */
	pAddrStruct.VirtAddr = NULL;
	pAddrStruct.PhysAddr = NULL;
	pAddrStruct.BufSize  = sizeof(marker_t);
	pAddrStruct.pCookie  = NULL;
	
	ODMMallocContiguous(&pAddrStruct,0);
	
	if ( pAddrStruct.PhysAddr == NULL )
		return FAILURE; /* Memory Allocation failed */
	
	Pkt.FragArray[BASE_INDEX].pFrag = pAddrStruct.PhysAddr;
	/* Update the length field of the fragment */
	Pkt.FragArray[BASE_INDEX].FragLen = pAddrStruct.BufSize;
	Pkt.NumFrags = 1;

	/* Assign Virtual Address to fill the elements */
	pSendMarker = (marker_t *) pAddrStruct.VirtAddr;
	
	/* Fill in the marker_t structure */
	ODMCopy((UCHAR *)SlowProtocolMulticast, (UCHAR *)&pSendMarker->DestinationAddress,MAC_ADDR_LEN);
	ODMCopy((UCHAR *)pAdapter->CurrMacAddr, (UCHAR *)&pSendMarker->SourceAddress,MAC_ADDR_LEN);
	
	pSendMarker->LenType = (USHORT)ODMhtons(SLOW_PROTOCOL_TYPE);
	pSendMarker->Subtype = MARKER_PDU_TYPE;
	pSendMarker->Version = MARKER_VERSION;
	pSendMarker->TLVType = MARKER_RESPONSE_INFORMATION;
	pSendMarker->Length = MARKER_RESPONSE_INFORMATION_LENGTH;
	pSendMarker->RequestorPort = pRecvMarker->RequestorPort;
	ODMCopy((UCHAR *)&pRecvMarker->RequestorSystem,(UCHAR *)&pSendMarker->RequestorSystem, MAC_ADDR_LEN);
	pSendMarker->RequestorTransactionId = pRecvMarker->RequestorTransactionId;
	pSendMarker->Pad = MARKER_PADDING;
	pSendMarker->Terminator = MARKER_TERMINATOR;
	pSendMarker->TerminatorLength = MARKER_TERMINATOR_LENGTH;
	
	pAdapter->FuncStruct.HsmSendPkt(pAdapter, Pkt, 0);
	
	return SUCCESS;
}


/*******************************************************************************
*f*	
*	Name :
*			MarkerResponseHandler	
*
*	Description :
*			This function checks the marker response and shifts the MAC address
*			classes to some other port accordingly.
*
*	Parameters :
*			pPort	Pointer to the lacpPort_t structure
*
*	Return Value : 
*			None	
*
*	Called By :
*			MarkerPDUHandler
*
*	Lock :
*			None
*f*
********************************************************************************/

VOID
MarkerResponseHandler(HsmRCB *Rcb, lacpPort_t *pPort)
{
	marker_t	*pMarker;
	UINT		TransactionId;
	USHORT		Port;
	lacpAggr_t	*pAggr;
	INT			i;
	time_t		timerid;

	pMarker = (marker_t *) Rcb->pDataBuf;
	TransactionId = pMarker->RequestorTransactionId;
	Port = pMarker->RequestorPort;
	GET_LACPPORTP(Port, pPort);

	pAggr = pPort->LACPAggrp;

	ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
	
	/* Check CollecterMaxDelay timer has already run */
	if ( !pPort->CollectorMaxDelayTimerID) 
	{
		/*  No need to do anything here. */
		return;
	}
	timerid = pPort->CollectorMaxDelayTimerID;
	pPort->CollectorMaxDelayTimerID = 0;
	ODMReleaseLock(pPort->PortLock,nFlags,0);

	ODMUntimeout(timerid,pPort); /* Cancel the CollectorMaxDelay timer */ 


	ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
	if (TransactionId == SHIFT_PORT)
	{
		/* The entire load from this port has to be shifted to another port */
		for(i=0; i < NUM_OF_MAC_ADDRESS_CLASSES; i++)
		{
			if (pAggr->PortForMAC[i] ==  (MAX_PORTS + Port + 1))
			{
				pAggr->PortForMAC[i] = MAX_PORTS;
			}
		}
	}
	else
	{
		/* Only the Mac address class given by Requestor_Transaction_Port 
		   has to be shifted */
		if (pAggr->PortForMAC[TransactionId] > MAX_PORTS)
			pAggr->PortForMAC[TransactionId] = MAX_PORTS;
	}
	ODMReleaseLock(pAggr->AggrLock,nFlags,0);
	
	return;
}

/** CALLBACK functions **/
/* These functions are called from HSM */

/********************************************************************
*f*
*
* Name :			LacpMulticastAdd
*
* Description :		Adds the specified multicast addresses to the 
*					non-aggregator ports.
*
* Parameters :		pAdapter	Pointer to AdapterContext Structure
*					pMulti		List of multicast addresses	
*					numaddr		Number of mulitcast addresses to be added
*					ReloadFlag	Whether existing list is to be overwritten or
*								appended to.
*
*
* Return Value :	None
*
* Called By :		HsmMulticastAdd
*
* Lock :			
*
*f*
*********************************************************************/

void
LacpMulticastAdd(AdapterContext *pAdapter, MultiList *pMulti, UINT numaddr, UCHAR ReloadFlag)
{
	lacpPort_t *pPort;
	lacpAggr_t *pAggr;
	MultiList *tempMulti, *saveMulti;
	AdapterContext *pTempAdapter;
	UINT i;

	pPort = LACPPortp[pAdapter->Port];
	pAggr = pPort->LACPAggrp;
	/* If non-aggregator port or only one port in 
	 * aggregation, nothing to be done 
	 */
	if ((!pPort->AggregatorPort) || (pAggr->NumPorts == 1))	
		return;

	if (pMulti) {
		tempMulti = pMulti;
		for (i=0; i < numaddr-1; i++)
			tempMulti = tempMulti->Next;
		saveMulti = tempMulti->Next;
		tempMulti->Next = NULL;
	}

	for (i = 0; i < pAggr->NumPorts; i++) {
		if (pAggr->LAGPorts[i] == 0 || pAggr->LAGPorts[i] == pAdapter->Port)
			continue;
		pTempAdapter = AdapterArray[pAggr->LAGPorts[i]];
		pTempAdapter->FuncStruct.HsmMulticastAdd(pTempAdapter, pMulti, ReloadFlag);
	}
	if (pMulti)
		tempMulti->Next = saveMulti;
	return;
}	

/********************************************************************
*f*
*
* Name :			LacpMulticastDelete
*
* Description :		Deletes the specified multicast addresses from the
*					non-aggregator ports.
*
* Parameters :		pAdapter	Pointer to AdapterContext Structure
*					pMulti		List of multicast addresses	
*
* Return Value :	None
*
* Called By :		HsmMulticastDelete
*
* Lock :			
*
*f*
*********************************************************************/

void
LacpMulticastDelete(AdapterContext *pAdapter, MultiList *pMulti)
{
	lacpPort_t *pPort;
	lacpAggr_t *pAggr;
	AdapterContext *pTempAdapter;
	int i;

	pPort = LACPPortp[pAdapter->Port];
	pAggr = pPort->LACPAggrp;
	/* If non-aggregator port or only one port in 
	 * aggregation, nothing to be done 
	 */
	if ((!pPort->AggregatorPort) || (pAggr->NumPorts == 1))	
		return;

	for (i = 0; i < pAggr->NumPorts; i++) {
		if (pAggr->LAGPorts[i] == 0 || pAggr->LAGPorts[i] == pAdapter->Port)
			continue;
		pTempAdapter = AdapterArray[pAggr->LAGPorts[i]];
		pTempAdapter->FuncStruct.HsmMulticastDelete(pTempAdapter, pMulti);
	}
	return;
}

/********************************************************************
*f*
*
* Name :			LacpSetMacAddress
*
* Description :		Sets MAC address of non-aggregator ports.
*
* Parameters :		pAdapter	Pointer to AdapterContext Structure
*					addr		MAC address
*
* Return Value :	None
*
* Called By :		HsmSetMacAddress
*
* Lock :			
*
*f*
*********************************************************************/

void
LacpSetMacAddress(AdapterContext *pAdapter, UCHAR *addr)
{
	lacpPort_t *pPort;
	lacpAggr_t *pAggr;
	AdapterContext *pTempAdapter;
	int i;
	
	pPort = LACPPortp[pAdapter->Port];
	pAggr = pPort->LACPAggrp;
	/* If non-aggregator port or only one port in 
	 * aggregation, nothing to be done 
	 */
	if ((!pPort->AggregatorPort) || (pAggr->NumPorts == 1))	
		return;

	for (i = 0; i < LACP_MAX_PER_GROUP; i++) {
		if (pAggr->LAGPorts[i] == 0 || pAggr->LAGPorts[i] == pAdapter->Port)
			continue;
		pTempAdapter = AdapterArray[pAggr->LAGPorts[i]];
		pTempAdapter->FuncStruct.HsmSetMacAddress(pTempAdapter, addr);
		// Copy the address to CurrMacAddress - Ravi 23 Oct 6:03 PM
		ODMCopy(addr, pTempAdapter->CurrMacAddr, MAC_ADDR_LEN);
	}
	return;
}

USHORT
GetNumberOfLinks(AdapterContext *pAdapter)
{
	lacpAggr_t *pAggr;
	lacpPort_t *pPort;
	USHORT i,nCount = 0;
	
	// Consider individual port. Feb 05 2001
	if (pAdapter->nFlags == 0) {
		if (pAdapter->AdapterStatus & LINK_UP)
			return 1;
		else
			return 0;
	}

	pPort = LACPPortp[pAdapter->Port];
	pAggr = pPort->LACPAggrp;

	for(i=0;i<LACP_MAX_PER_GROUP;i++)
	{
		if(pAggr->LAGPorts[i] == 0)
			continue;

		pPort = LACPPortp[pAggr->LAGPorts[i]];
		// Revisit: Use LINK_UP status instead of PortEnabled - Dec 4, 7:19 PM
		//if(pPort->PortEnabled == TRUE)
		if ((AdapterArray[pAggr->LAGPorts[i]])->AdapterStatus & LINK_UP)
			nCount++;
	}
	return nCount;
}

void
LacpSetRxFilter(AdapterContext *pAdapter, UINT rxFilterFlag)
{
	lacpPort_t *pPort;
	lacpAggr_t *pAggr;
	AdapterContext *pTempAdapter;
	int i;

	pPort = LACPPortp[pAdapter->Port];
	pAggr = pPort->LACPAggrp;
	/* If non-aggregator port or only one port in 
	 * aggregation, nothing to be done 
	 */
	if ((!pPort->AggregatorPort) || (pAggr->NumPorts == 1))	
		return;

	for (i = 0; i < LACP_MAX_PER_GROUP; i++) {
		if (pAggr->LAGPorts[i] == 0 || pAggr->LAGPorts[i] == pAdapter->Port)
			continue;
		pTempAdapter = AdapterArray[pAggr->LAGPorts[i]];
		pTempAdapter->FuncStruct.HsmRxFilter(pTempAdapter, rxFilterFlag);
	}
	return;
}

void 
LacpSetPhyCapabilities(AdapterContext *pAdapter, UINT PhysFlags, UINT SetSpeed)
{
	lacpPort_t *pPort;
	lacpAggr_t *pAggr;
	AdapterContext *pTempAdapter;
	int i;

	pPort = LACPPortp[pAdapter->Port];
	pAggr = pPort->LACPAggrp;
	/* If non-aggregator port or only one port in 
	 * aggregation, nothing to be done 
	 */
	if ((!pPort->AggregatorPort) || (pAggr->NumPorts == 1))	
		return;

	for (i = 0; i < LACP_MAX_PER_GROUP; i++) {
		if (pAggr->LAGPorts[i] == 0 || pAggr->LAGPorts[i] == pAdapter->Port)
			continue;
		pTempAdapter = AdapterArray[pAggr->LAGPorts[i]];
		pTempAdapter->FuncStruct.HsmSetPhyCapabilities(pTempAdapter, PhysFlags, SetSpeed);
	}
	return;
}

void 
LacpUnInitialize(AdapterContext *pAdapter)
{
	lacpPort_t *pPort,*pTempPort;
	lacpAggr_t *pAggr;
	int i,j, flags;
	time_t timerid;
	PRIV_LEVEL CurrLevel1, CurrLevel2,CurrLevel3;
	AdapterContext *pTempAdapter;
	
	if(pAdapter->nFlags == 0)
	{
		AdapterArray[pAdapter->Port] = NULL;
		AdapterCount--;
		return;
	}

	pPort = LACPPortp[pAdapter->Port];
	pAggr = pPort->LACPAggrp;

	CurrLevel1 = ODMAcquireLock(GlobalLock,0,0);

	if (pPort->AggregatorPort) {
		flags = pAdapter->nFlags;
		pAdapter->nFlags = 0;
		/* Disable Send */
		CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
		for (i=0; i < MAX_PORTS; i++)
			pAggr->PortForMAC[i] = MAX_PORTS+1;
		ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel2);
		
		/* Make all the non-aggregator ports as individual */
		/* Run the loop from 1 as at zero index Aggregator port would be there ..
		 */
		for (i=1; i < LACP_MAX_PER_GROUP; i++) {
			if (pAggr->LAGPorts[i] == 0)
				continue;
			pTempAdapter = AdapterArray[pAggr->LAGPorts[i]];
			pTempPort = LACPPortp[pTempAdapter->Port];
			AddPortToDeferList(pTempPort,pTempAdapter->nFlags);
			pTempAdapter->nFlags = 0;
			pTempAdapter->pAggregatorContext = pTempAdapter;
			ODMUnInitializeLock(pTempPort->PortLock, 0);
			LACPPortp[pTempPort->ActorPortNumber] = NULL;
			ODMFree(pTempPort, sizeof(lacpPort_t), 0);
		}
		if (flags & LACP_FLAG){
			StopLACPTimers(pPort);
		}
		ODMFree(pAdapter->pLacpRCB, sizeof(LacpRCB_t), 0);
		ODMUnInitializeLock(pPort->PortLock, 0);
		AdapterArray[pPort->ActorPortNumber] = NULL;
		AdapterCount--;
		LACPPortp[pPort->ActorPortNumber] = NULL;
		ODMFree(pPort, sizeof(lacpPort_t), 0);
		CurrLevel2 = ODMAcquireLock(pAggr->AggrLock, 0, 0);
		timerid = pAggr->ReshuffleTimerID;
		pAggr->ReshuffleTimerID = 0;
		ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel2);
		ODMUntimeout(timerid,pAggr);

		for(j=0;j<MAX_PORTS;j++)
			if(LACPAggrp[j] != 0 && LACPAggrp[j] == pAggr)
				LACPAggrp[j] = NULL;

		ODMUnInitializeLock(pAggr->AggrLock, 0);
		ODMFree(pAggr, sizeof(lacpAggr_t), 0);
	}
	else	/* Non-aggregator port */
	{
		flags = pAdapter->nFlags;
		pAdapter->nFlags = 0;
		CurrLevel3 = ODMAcquireLock(pPort->PortLock,nFlags,nPrivLevel);
		pPort->PortEnabled = FALSE;
		
		BIT_CLEAR(pPort->ActorOperPortState, DISTRIBUTING);
		BIT_CLEAR(pPort->ActorOperPortState, COLLECTING);
		ODMReleaseLock(pPort->PortLock,nFlags,CurrLevel3);

		/* Reassign all MAC address classes using this port */
		CurrLevel2 = ODMAcquireLock(pAggr->AggrLock,nFlags,nPrivLevel);
		for (i=0; i < MAX_PORTS; i++) {
			if (pAggr->PortForMAC[i] == pAdapter->Port)
				pAggr->PortForMAC[i] = MAX_PORTS;
		}
		/* Remove port from aggregation */
		for (i=0; i < LACP_MAX_PER_GROUP; i++) {
			if (pAggr->LAGPorts[i] == pAdapter->Port) {
				pAggr->LAGPorts[i] = 0;
				pAggr->NumPorts--;
				break;
			}
		}
		ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel2);
		if (flags & LACP_FLAG)
			StopLACPTimers(pPort);
		ODMFree(pAdapter->pLacpRCB, sizeof(LacpRCB_t), 0);
		ODMUnInitializeLock(pPort->PortLock, 0);
		AdapterArray[pPort->ActorPortNumber] = NULL;
		AdapterCount--;
		LACPPortp[pPort->ActorPortNumber] = NULL;
		ODMFree(pPort, sizeof(lacpPort_t), 0);
	}
	ODMReleaseLock(GlobalLock,0,CurrLevel1);
}

void AddPortToDeferList(lacpPort_t *pPort,int nFlags)
{
	
	PortInfo_t				*pPortInfo;
	USHORT					i;
	
   /*
    * Allocate PortInfo strucure.
	*/
	if((pPortInfo = ODMMalloc(sizeof(PortInfo_t),ZERO_MEMORY)) == NULL){
		ODMDbgPrint2("WARNING : Memorty allocation failed in AddPortToDeferList. Port %x will not join aggregation.",pPort->ActorPortNumber); 
		return;
	}

   /*
    * Populate the aggregation configuration onto PortInfo.
	*/
	pPortInfo->Port					= pPort->ActorPortNumber;
    pPortInfo->LACP					= (nFlags & LACP_FLAG);
	pPortInfo->GEC					= (nFlags & GEC_FLAG);
	pPortInfo->Key					= pPort->ActorOperPortKey;
    pPortInfo->LACPActivity         = (pPort->ActorOperPortState) & LACP_ACTIVITY;
    pPortInfo->LACPTimeout          = (pPort->ActorOperPortState) & LACP_TIMEOUT;
    pPortInfo->AggregatorPort       = pPort->AggregatorPort;
    pPortInfo->Selected             = pPort->ControlVars.Selected;
    pPortInfo->CollectorState       = (pPort->ActorOperPortState) & COLLECTING;
    pPortInfo->DistributorState     = (pPort->ActorOperPortState) & DISTRIBUTING;
    pPortInfo->Synchronization      = (pPort->ActorOperPortState) & SYNCHRONIZATION;
	pPortInfo->AggregatorIdentifier = pPort->LACPAggrp->AggregatorIdentifier;

   /*
    * Insert the PortInfo into first empty slot in the DeferredPortInfoList.
	* The Aggregator port on loading will restore the aggregation with 
	* the help of this list.
	*/
	for(i=0; i<MAX_PORTS; i++){
		if(DeferPortInfoList[i] == NULL){
			DeferPortInfoList[i] = pPortInfo;
			break;
		}
	}
}

VOID
LacpDisablePort(AdapterContext *pAdapter)
{
	USHORT indx;
	lacpAggr_t *pAggr;
	PRIV_LEVEL	CurrLevel1;
	lacpPort_t *pPort = LACPPortp[pAdapter->Port];

	BIT_CLEAR(pPort->ActorOperPortState, DISTRIBUTING);

	pAggr = pPort->LACPAggrp;

	CurrLevel1 = ODMAcquireLock(pAggr->AggrLock,nFlags,0);
	for(indx=0; indx < NUM_OF_MAC_ADDRESS_CLASSES; indx++)
	{
		if(pAggr->PortForMAC[indx] == pPort->ActorPortNumber) 
		{
			pAggr->PortForMAC[indx] = MAX_PORTS;
			/* Reset load per MAC */
			pAggr->PrevLoadPerMAC[indx] = pAggr->LoadPerMAC[indx];
		}
	}
	ODMReleaseLock(pAggr->AggrLock,nFlags,CurrLevel1);
}

/* Returns speed of aggregation. Searches for a
 * NIC in aggregation with cable connected and
 * returns it's speed
 */
ULONG
GetAggrSpeed(AdapterContext *pAdapter)
{
	lacpAggr_t *pAggr;
	lacpPort_t *pPort;
	USHORT i;
	AdapterContext *pTempAdapter;
	
	// Consider individual port.
	if (pAdapter->nFlags == 0) {
		if (pAdapter->AdapterStatus & LINK_UP)
			return(pAdapter->MediaSpeed);
		else
			return 0;
	}

	pPort = LACPPortp[pAdapter->Port];
	pAggr = pPort->LACPAggrp;

	for(i=0;i<LACP_MAX_PER_GROUP;i++)
	{
		if(pAggr->LAGPorts[i] == 0)
			continue;

		pTempAdapter = AdapterArray[pAggr->LAGPorts[i]];
		if (pTempAdapter->AdapterStatus & LINK_UP)
			return(pTempAdapter->MediaSpeed);
	}
	return 0;
}
